/*  File: ascify.c
 *  Author: Richard Durbin (rd@sanger.ac.uk)
 *  Copyright (C) J Thierry-Mieg and R Durbin, 1995
 *-------------------------------------------------------------------
 * This file is part of the ACEDB genome database package, written by
 * 	Richard Durbin (MRC LMB, UK) rd@sanger.ac.uk, and
 *	Jean Thierry-Mieg (CRBM du CNRS, France) mieg@kaa.cnrs-mop.fr
 *
 * Description: 
   C program to be run on VAX to convert John Sulston's database files 
   into ascii stream files for transfer to the SUN and processing
 * Exported functions:
 * SCCS: $Id: ascify.c,v 1.1 2001/02/14 12:44:35 edgrif Exp $
 * HISTORY:
 * Last edited: Oct 18 15:44 1995 (rd)
 * Created: Wed Oct 18 15:43:40 1995 (rd)
 *-------------------------------------------------------------------
 */

#include <stdio.h>
 
char *inroot = "cb_disk0:[jes.map]cen2hs." ;	/* replace as appropiate */
char nambuf[128] ;

main()
{
  readnam () ;
  readrem () ;
  readint ("flg") ; 
  readcnt () ;
  readint ("cor") ;
}

readint (tag)
char *tag ;
{
  FILE *in,*out ;
  struct { int band;
         } x ;
  int size = sizeof(x);
  void *v = &x;
  int  n = 0 ;

  strcpy (nambuf,inroot) ; strcat (nambuf,tag) ; in = fopen (nambuf,"r") ;
  strcpy (nambuf,"jes.") ; strcat (nambuf,tag) ; out = fopen (nambuf,"w") ;
  if (!in ||!out)
    { printf ("Can't open %s file\n",tag) ; exit (-1) ; }
  printf(".%s line size = %d",tag,size);
  while(fread(v,size,1,in))
    { fprintf (out,"%6d\n",x.band) ; ++n ; }
  printf ("     %d lines read\n",n) ;
  fclose (in) ; fclose (out) ;
}

readnam()
{
  FILE *in,*out ;
  struct { char name[8];
           int nb, pos, gel, contig;
         } nam;
  int size = sizeof(nam);
  void *v = &nam;
  int  n = 0 ;

  strcpy (nambuf,inroot) ; strcat (nambuf,"nam") ; in = fopen (nambuf,"r") ;
  out = fopen ("jes.nam","w") ;
  if (!in ||!out)
    { printf ("Can't open nam file\n") ; exit (-1) ; }
  printf(".nam line size = %d",size);
  while (fread (v,size,1,in))
    { nam.name[7]=0;
      fprintf (out,"%12s   %12d%12d%12d%12d\n",
           nam.name, nam. nb, nam. pos,
           nam.gel, nam.contig);
      ++n ;
    }
  printf ("     %d lines read\n",n) ;
  fclose (in) ; fclose (out) ;
}

readrem()
{
  FILE *in,*out ;
  struct
    { int clone;
      char gene[8], remark[40];
      short ch, flag;
      float situ ;
      short z ;
    } rem;
  int size = sizeof(rem);
  void *v = &rem;
  int  n = 0 ;

  strcpy (nambuf,inroot) ; strcat (nambuf,"rem") ; in = fopen (nambuf,"r") ;
  out = fopen ("jes.rem","w") ;
  if (!in ||!out)
    { printf ("Can't open rem file\n") ; exit (-1) ; }
  printf(".rem line size = %d",size);
  while (fread (v,size,1,in))
    { rem.gene[7]=0;
      rem.remark[39]=0;
      fprintf (out,"%8d%12s   %42s%6d%6d%12.4f%6d\n",
            rem.clone, rem.gene,
            rem.remark, rem.ch,
            rem.flag, rem.situ, rem.z) ;
      ++n ;
    }
  printf ("     %d lines read\n",n) ;
  fclose (in) ; fclose (out) ;
}
