/*  File: cemsub.c
 *  Author: Friedemann "F" Wobus (fw@sanger.ac.uk)
 *  Copyright (C) John Sulston and Friedemann Wobus, 1994
 *-------------------------------------------------------------------
 * This file is part of the ContigC physical mapping database package,
 * 	written by John Sulston (jes@sanger.ac.uk)
 *	ported to UNIX-C by Friedemann Wobus (fw@sanger.ac.uk)
 *
 * Description:
 * SCCS: $Id: cemsub.c,v 1.1 2001/02/14 12:44:36 edgrif Exp $
 * HISTORY:
 * Last edited: Jan 23 15:11 1995 (fw)
 * Created: Fri May 27 13:06:43 1994 (fw)
 *-------------------------------------------------------------------
 */

#include "co9.h"

/*****************************************************************/

extern FILE *unit_2 ;			/* .cor */
extern FILE *unit_10 ;			/* .stk */
extern FILE *unit_11 ;			/* .rem */
extern FILE *unit_12 ;			/* textfile */

extern float hChar ;
extern float winWidth, winHeight ; /* determined by graphWhere in main() */

/* Common Block Declarations */

/* csec CB */
extern short int coorda[BANDMAX];

/* cint CB */
extern long int nbanda[30000], lbanda[30000], igela[30000], iconta[30000],
         iposa[30000], ilena[30000], icana[30000], irema[30000];

/* chars CB */
extern char namea[240000], chrom[65];

/* matdat CB */
extern long int itolmn, itoldf;
extern float logfact[201];

/* chr1 CB */
extern float xzero1, scale1;
extern long int ichrgp, maxlev1, levgap1;
extern short int genlev1[6000]	/* was [6][1000] */;

/* chr CB */
extern float xzero, scale1 ;
extern long int chrgap, maxlev, levgap;
extern short int genlev[6000]	/* was [6][1000] */;
extern float csiz, sitlev[1200], scale;


/* cass CB */
extern long int gpos[400], glen[400], gclst[400], ngrp;
extern short int gmat[160000]	/* was [400][400] */;

/* Table of constant values */

static long int c__1 = 1;
static long int c__0 = 0;
static long int c__5 = 5;
static long int c__20 = 20;
static long int c__3 = 3;
static long int c__16 = 16;
static long int c__2 = 2;
static long int c__380 = 380;
static long int c__400 = 400;

int cechr_(void)
{
  /* System generated locals */
  static char equiv_0[9];
#define tname (equiv_0)
#define tnameb ((char *)equiv_0)

  /* Local variables */
  static long int grec[2000];
  static long int gdir[2000];
  static long int igen;
  static float genl;
  static long int ilft;
  static float widh;
  static long int nent;
  static float gpos[2000], csiz;
  static char gene1[9];
  static float pchr1;
  static char gname[8*2000];
  static float gpchr[2000];
  static BOOL logpc;
  static long int itemp;
  static short int hflag1, hsitu1;
  static long int iq, ix;
  static long int iy, iz;
  static long int ichsel, iclone;
  static BOOL loggen;
  static short int gchrom[2000] ;
  static long int ichrom;
  static BOOL logsit;
  static short int sitlev[1200]	/* was [6][200] */, hchrom1;
  static char remark1[41];
  static float ghl;
  static char ans[1];
  static long int lev;
  static float ctr;
  static long int isp, irt, num;

/*   select mode */
L82:
  gprintf (stdout, "   select chromosome (1-6) or return (0) : ") ;
  readinput ("", stemp, 1) ; if (nonint(stemp)) goto L82 ;
  ichsel = a2int (stemp) ;
  if (ichsel == 0)
    {
      return 0;
    }
  else if (ichsel > 0 && ichsel < 7)
    {
      isp = 7 - ichsel;
    }
  else
    {
      goto L82;
    }
  gprintf (stdout, "  in situs required (Y/N) ? ") ;
  readinput ("", stemp, 1) ; 
  if (*stemp == 'y' || *stemp == 'Y')
    {
      logsit = TRUE;
    }
  else
    {
      logsit = FALSE;
    }
  gprintf (stdout, "  genetic positions required (Y/N) ? ") ;
  readinput ("", stemp, 1) ;
  if (*stemp == 'y' || *stemp == 'Y')
    {
      logpc = TRUE;
    }
  else
    {
      logpc = FALSE;
    }
  loggen = FALSE;

  clearvt640_();
  selectvt640_();

  xzero1 = 63.f;
  scale1 = 8.5f;
  maxlev1 = 4;
  levgap1 = 18;
  ichrgp = 110;
  csiz = 9.f;
  if (ichsel == 0)
    {
      for (ichrom = 1; ichrom <= 6; ++ichrom)
	{
	  iy = (7 - ichrom) * ichrgp;
	  strtcpy(tname, chrom + ichrom * 5, 5L);
	  movevt640_(0, iy - 6);
	  textvt640_(tnameb, 5);
	  movevt640_((long int) xzero1, iy);
	  drawvt640_((long int) (xzero1 + scale1 * 100.f), iy);
	}
    }
  else
    {
      maxlev1 = 30;
      ichrgp = 300;
      strtcpy(tname, chrom + ichsel * 5, 5L);
      iy = ichrgp;
      movevt640_(0, iy - 6);
      textvt640_(tnameb, 5);
      movevt640_((long int) xzero1, iy);
      drawvt640_((long int) (xzero1 + scale1 * 100.f), iy);
    }
  for (iq = 1; iq <= 6; ++iq)
    {
      sitlev[iq + 1193] = 0;
      genlev1[iq + 5993] = 0;
    }
/*   get plot order */
  igen = 0;
  iz = 0;
L69:
  ++iz;
  seek_11 (iz) ;
  fread (&iclone, sizeof(long int), 1, unit_11);
  fread (gene1, sizeof (char), 8, unit_11);
  fread (remark1, sizeof (char), 40, unit_11);
  fread (&hchrom1, sizeof(short int), 1, unit_11);
  fread (&hflag1, sizeof(short int), 1, unit_11);
  fread (&pchr1, sizeof(float), 1, unit_11);
  fread (&hsitu1, sizeof(short int), 1, unit_11);
  if (FILerror(unit_11)) goto L91 ;
  if (iclone == -9)
    {
      goto L91;
    }
  if (ichsel != 0 && hchrom1 != ichsel)
    {
      goto L69;
    }
  ++igen;
  gdir[igen - 1] = igen;
  grec[igen - 1] = iz;
  gpos[igen - 1] = (float) (hchrom1 * 100) + pchr1;
  goto L69;
L91:
  gsort_(&igen, gdir, gpos);
  for (iq = 1; iq <= igen; ++iq)
    {
      seek_11 (grec[gdir[iq - 1] - 1]) ;
      fread (&iclone, sizeof(long int), 1, unit_11);
      fread (gene1, sizeof (char), 8, unit_11);
      fread (remark1, sizeof (char), 40, unit_11);
      fread (&hchrom1, sizeof(short int), 1, unit_11);
      fread (&hflag1, sizeof(short int), 1, unit_11);
      fread (&pchr1, sizeof(float), 1, unit_11);
      fread (&hsitu1, sizeof(short int), 1, unit_11);
      
      strtcpy(tname, gene1, 8);
      if (pchr1 != 0.f && logpc)
	{
/* plot genetic position */
/* get gene name length */
	  gnl_(gene1, &genl, &csiz);
	  genplot1_(&pchr1, &genl, &hchrom1, gene1, &isp);
	}
      if (hsitu1 != 0 && logsit)
	{
/* plot in situ position */
/* get gene name half length */
	  gnhl_(gene1, &ghl, &csiz);
	  ilft = hsitu1 / 128;
	  irt = hsitu1 % 128;
	  ctr = xzero1 + scale1 * (float) (ilft + irt) / 2.f;
/* get plot level; use % units */
	  widh = scale1 * (float) (irt - ilft) / 2.f;
	  nent = sitlev[hchrom1 + 1193];
	  for (lev = 1; lev <= maxlev1; ++lev)
	    {
	      ilft += 200;
	      irt += 200;
	      for (num = 1; num <= nent; num += 2)
		{
		  if (ilft < sitlev[hchrom1 + (num + 1) * 6 - 7])
		    {
		      if (irt > sitlev[hchrom1 + num * 6 - 7])
			{
			  goto L71;
			}
		    }
		}
	      goto L73;
L71:
	      ;
	    }
L73:
	  sitlev[hchrom1 + 1193] = nent + 2;
	  sitlev[hchrom1 + (nent + 1) * 6 - 7] = ilft - 1;
/*   place gene */
	  sitlev[hchrom1 + (nent + 2) * 6 - 7] = irt + 1;
	  iy = (7 - hchrom1) / isp * ichrgp - 12 - levgap1 * (lev - 1);
	  movevt640_((long int) (ctr - ghl), iy - 7);
	  textvt640_(tnameb, 8);
	  movevt640_((long int) (ctr - ghl) - 4, iy);
	  ix = (long int) (ctr - widh);
	  drawvt640_(ix, iy);
	  movevt640_(ix, iy - 4);
	  drawvt640_(ix, iy + 4);
	  movevt640_((long int) (ctr + ghl) + 4, iy);
	  ix = (long int) (ctr + widh);
	  drawvt640_(ix, iy);
	  movevt640_(ix, iy - 4);
	  drawvt640_(ix, iy + 4);
	}
    }
/* get genes from genetic file */
  if (! loggen)
    {
      goto L79;
    }
/* get plot order */
  igen = 0;
  iz = 0;
L98:
  ++iz;
L83:
  if (!unit_12) goto L99 ;
  readstring (unit_12, gname + ((iz - 1) << 3), 8);
  readstring (unit_12, stemp, 1) ; hchrom1 = a2int (stemp) ;
  readstring (unit_12, 0, 2) ;
  readstring (unit_12, stemp, 10) ; pchr1 = a2flt (stemp) ;
  forward (unit_12) ;
  if (FILerror(unit_12)) goto L99 ;
  if (ichsel != 0 && hchrom1 != ichsel)
    {
      goto L83;
    }
  gdir[iz - 1] = iz;
  gchrom[iz - 1] = hchrom1;
  gpchr[iz - 1] = pchr1;
  gpos[iz - 1] = (float) (hchrom1 * 100) + pchr1;
  goto L98;

L99:
  igen = iz - 1;
  if (igen == 0)
    {
      goto L79;
    }
  gsort_(&igen, gdir, gpos);
  for (iz = 1; iz <= igen; ++iz)
    {
      gnl_(gname + ((gdir[iz - 1] - 1) << 3), &genl, &csiz);
      genplot1_(&gpchr[gdir[iz - 1] - 1], &genl, &gchrom[gdir[iz - 1] - 1], 
		gname + ((gdir[iz - 1] - 1) << 3), &isp);
    }
L79:
/*   draw scale */
  if (unit_12) rewind (unit_12) ;
  botscale1_(&c__20, &xzero1, &scale1);
  selectvt100_();
L96:
  gprintf (stdout,
	   "  type X for Xhair, C to clear text, "
	   "blank to return : ") ;
L93:
  readinput ("", stemp, 1) ; *ans = *stemp ;
  if (*ans == 'c' || *ans == 'C')
    {
      clearvt100_();
      movevt100_(0, 0);
      goto L93;
    }
  else if (*ans == 'x' || *ans == 'X')
    {
      long int itempx = WIN_WIDTH/2, itempy = WIN_HEIGHT/2 ;

      clearvt100_();
      gprintf (stdout, "   press key when done \n") ;
      selectvt640_();
      xhairvt640_(&itempx, &itempy, &itemp);
      selectvt100_();
      goto L96;
    }
  else
    {
      goto L82;
    }
  return 0;
} /* cechr_ */

#undef tnameb
#undef tname


int botscale1_(long int *iy, float *xzero1, float *scale1)
{
  static char schar[3*11] = "0  " "10 " "20 " "30 " "40 " "50 " "60 " "70 " 
    "80 " "90 " "100";

  /* System generated locals */
  static char equiv_0[9];
#define tname (equiv_0)
#define tnameb ((char *)equiv_0)

  static long int iq, ix;
  static long int iyt;
  
  movevt640_((long int) (*xzero1), *iy);
  drawvt640_((long int) (*xzero1 + *scale1 * 100.f), *iy);
  for (iq = 0; iq <= 100; ++iq)
    {
      ix = (long int) (*xzero1 + iq * *scale1);
      iyt = *iy + 3;
      if (iq % 5 == 0)
	{
	  iyt += 3;
	}
      if (iq % 10 == 0)
	{
	  iyt += 6;
	  movevt640_(ix - 5, 20);
	  strtcpy(tname, schar + iq / 10 * 3, 3);
	  textvt640_(tnameb, 3);
	}
      movevt640_(ix, *iy);
      drawvt640_(ix, iyt);
    }
  return 0;
} /* botscale1_ */

#undef tnameb
#undef tname


int cetri_(void)
{
  /* System generated locals */
  static char equiv_0[9];
#define tname (equiv_0)
#define tnameb ((char *)equiv_0)

  /* Local variables */
  static long int grec[2000], igen, gdir[2000];
  static float genl;
  static long int nchr;
  static float widh;
  static long int ilft, nent;
  static float gpos[2000];
  static float ytop;
  static char gene1[9];
  static float pchr1;
  static char gname[8*2000];
  static float y, x;
  static BOOL chsel[6];
  static float gpchr[2000];
  static BOOL logpc;
  static long int ifont;
  static BOOL topsc;
  static short int hflag1;
  static long int ic;
  static short int hsitu1;
  static long int iq, ix, iz;
  static long int ichsel, iclone;
  static BOOL loggen;
  static float yt;
  static BOOL filsel;
  static short int gchrom[2000];
  static char remark[41];
  static BOOL nomenc, logdot, logsit;
  static short int hchrom1;
  static char remark1[41];
  static float ghl;
  static char ans[1];
  static float ych[6];
  static long int lev;
  static float ctr;
  static long int igz, irt, num;
  
  xzero = 15.f;
  scale = 2.7f;
  levgap = 5;
  csiz = 2.7f;
  ifont = 1;

/* select mode */
  gprintf (stdout, "   select chromosome(s) (1-6), "
	   "whole map (7) or return (def) : ") ;
  readinput ("", remark, 2) ;
  if (strlength(remark, 2) == 0)
    {
      return 0;
    }
  else
    {
      for (iq = 1; iq <= 6; ++iq)
	{
	  chsel[iq - 1] = FALSE;
	}
      for (iq = 1; iq <= 40; ++iq)
	{
	  ic = (long int) remark[iq - 1];
	  if (ic >= 49 && ic <= 54)
	    {
	      chsel[ic - 49] = TRUE;
	    }
	  else if (ic == 55)
	    {
	      for (ix = 1; ix <= 6; ++ix)
		{
		  chsel[ix - 1] = TRUE;
		}
	      goto L84;
	    }
	}
    }
L84:
  nchr = 0;
  for (iq = 1; iq <= 6; ++iq)
    {
      if (chsel[iq - 1])
	{
	  ++nchr;
	}
    }
  if (nchr == 0)
    {
      return 0;
    }
  maxlev = 20.f;
  chrgap = 70.f;
/* get options */

  gprintf (stdout,
	   " Options:\n"
	   "  S = in situ bars\n"
	   "  G = genetically mapped clones\n"
	   "  F = change font\n"
	   "  R = read from file\n"
	   "  T = draw top scale\n"
	   "  P = set plot parameters : ") ;
  readinput ("", remark, 20) ;
  for (iq = 1; iq <= 20; ++iq)
    {
      *ans = remark[iq - 1];
      if (*ans == 'S')
	{
	  logsit = TRUE;
	}
      if (*ans == 'G')
	{
	  logpc = TRUE;
	}
      if (*ans == 'F')
	{
	  setfont_(&ifont);
	}
      if (*ans == 'R')
	{
	  filsel = TRUE;
	}
      if (*ans == 'T')
	{
	  topsc = TRUE;
	}
      if (*ans == 'P')
	{
	  setparam_();
	}
    }
/* jes-graph */
/*      call plt$pict */
/*      call plt$sclc(1.5 * csiz, 1.5 * csiz) */
  xzero = csiz * 5.5f;
  yt = 0.f;
  for (iq = 6; iq >= 1; --iq)
    {
      if (chsel[iq - 1])
	{
	  yt += chrgap;
	  ych[iq - 1] = yt;
/* jes-graph */
/*      call plt$ancd(0., yt - (csiz / 3.)) */
/*      call plt$strc(chrom(iq)) */
/*      call plt$mvto(xzero, yt) */
/*      call plt$dwto(xzero + (100. * scale), yt) */
	}
    }
  ytop = yt;
/* jes-graph */
/*      call plt$sclc(csiz, csiz) */
/*      call plt$font(ifont) */
  for (iq = 1; iq <= 6; ++iq)
    {
      sitlev[iq + 1193] = 0;
      genlev[iq + 5993] = 0;
    }
/* get plot order */
  igen = 0;
  iz = 0;
L69:
  ++iz;
  seek_11 (iz) ;
  fread (&iclone, sizeof(long int), 1, unit_11);
  fread (gene1, sizeof(char), 8, unit_11);
  fread (remark1, sizeof(char), 40, unit_11);
  fread (&hchrom1, sizeof(short int), 1, unit_11);
  fread (&hflag1, sizeof(short int), 1, unit_11);
  fread (&pchr1, sizeof(float), 1, unit_11);
  fread (&hsitu1, sizeof(short int), 1, unit_11);
  if (FILerror (unit_11))
    {
      goto L91;
    }
  if (filsel)
    {
      if (! inlist_(gene1)) 
	{
	  goto L69  ;
	}
    }
  if (hchrom1 == 0)
    {
      goto L69;
    }
  if (iclone == -9)
    {
      goto L91;
    }
  if (! chsel[hchrom1 - 1])
    {
      goto L69;
    }
  ++igen;
  gdir[igen - 1] = igen;
  grec[igen - 1] = iz;
  gpos[igen - 1] = (float) (hchrom1 * 100) + pchr1;
  goto L69;
L91:
  gsort_(&igen, gdir, gpos);
  for (iq = 1; iq <= igen; ++iq)
    {
      seek_11 (grec[gdir[iq - 1] - 1]) ;
      fread (&iclone, sizeof(long int), 1, unit_11);
      fread (gene1, sizeof(char), 8, unit_11);
      fread (remark1, sizeof(char), 40, unit_11);
      fread (&hchrom1, sizeof(short int), 1, unit_11);
      fread (&hflag1, sizeof(short int), 1, unit_11);
      fread (&pchr1, sizeof(float), 1, unit_11);
      fread (&hsitu1, sizeof(short int), 1, unit_11);

      strtcpy(tname, gene1, 8);
      if (nomenc)
	{
	  nomch_(gene1);
	}
      if (pchr1 != 0.f && logpc)
	{
/* plot genetic position */
/* get gene name length */
	  gnl_(gene1, &genl, &csiz);
	  genplot_(&pchr1, &genl, &hchrom1, &ych[hchrom1 - 1], gene1);
	}
      if (hsitu1 != 0 && logsit)
	{
/* plot in situ position */
/* get gene name half length */
	  gnhl_(gene1, &ghl, &csiz);
	  ilft = hsitu1 / 128;
	  irt = hsitu1 % 128;
	  ctr = xzero + scale * (float) (ilft + irt) / 2.f;
	  widh = scale * (float) (irt - ilft) / 2.f;

/*get plot level; use % units */
	  nent = sitlev[hchrom1 + 1193];
	  for (lev = 1; lev <= maxlev; ++lev)
	    {
	      ilft += 200;
	      irt += 200;
	      for (num = 1; num <= nent; num += 2)
		{
		  if (ilft < sitlev[hchrom1 + (num + 1) * 6 - 7])
		    {
		      if (irt > sitlev[hchrom1 + num * 6 - 7])
			{
			  goto L71;
			}
		    }
		}
	      goto L73;
L71:
	      ;
	    }
L73:
	  sitlev[hchrom1 + 1193] = nent + 2;
	  sitlev[hchrom1 + (nent + 1) * 6 - 7] = ilft - 1;
	  sitlev[hchrom1 + (nent + 2) * 6 - 7] = irt + 1;

/*   place gene */
	  y = ych[hchrom1 - 1] - (float) (levgap * lev);
/* jes-graph */
/*      call plt$ancd(ctr - ghl, y - (csiz * .37)) */
/*      call plt$strc(gene1) */
/*      call plt$mvto((ctr - ghl) - (csiz * .2), y) */
/*      call plt$dwto(ctr - widh, y) */
/*      call plt$mvby(0., - (csiz * .37)) */
/*      call plt$dwby(0., csiz * .7) */
/*      call plt$mvto((ctr + ghl) + (csiz * .2), y) */
/*      call plt$dwto(ctr + widh, y) */
/*      call plt$mvby(0., - (csiz * .37)) */
/*      call plt$dwby(0., csiz * .7) */
	}
    }

/* draw scales */
  y = chrgap * .3f;
  botscale_(&y, &xzero, &scale, &csiz);
  if (topsc)
    {
      y = ytop + chrgap;
/* jes-graph */
/*      call plt$mvto(xzero, y) */
/*      call plt$dwto(xzero + (100. * scale), y) */
      for (iq = 0; iq <= 100; ++iq)
	{
	  x = xzero + (float) iq * scale;
	  yt = y - csiz * .2f;
	  if (iq % 5 == 0)
	    {
	      yt -= csiz * .3f;
	    }
	  if (iq % 10 == 0)
	    {
	      yt -= csiz * .37f;
	    }
/* jes-graph */
/*      call plt$mvto(x, y) */
/*      call plt$dwto(x, yt) */
	}
    }
    corners_(0, scale * 100.f + xzero * 3.f, 0, y);

/* get genes from genetic file */
    if (! loggen)
	{
	goto L79;
    }

/* get plot order */
    igen = 0;
    iz = 0;
L98:
    ++iz;
L83:
  if (!unit_12) goto L99 ;
  readstring (unit_12, gname + ((iz - 1) << 3), 8);
  readstring (unit_12, stemp, 1) ; hchrom1 = a2int (stemp) ;
  readstring (unit_12, 0, 2) ;
  readstring (unit_12, stemp, 10) ; pchr1 = a2flt (stemp) ;
  forward (unit_12) ;
  if (FILerror (unit_12)) goto L99 ;
  if (ichsel != 0 && hchrom1 != ichsel)
    {
      goto L83;
    }
  gdir[iz - 1] = iz;
  gchrom[iz - 1] = hchrom1;
  gpchr[iz - 1] = pchr1;
  gpos[iz - 1] = (float) (hchrom1 * 100) + pchr1;
  goto L98;
L99:
  igen = iz - 1;
  if (igen == 0)
    {
      goto L79;
    }
  gsort_(&igen, gdir, gpos);
  for (iz = 1; iz <= igen; ++iz)
    {
      gnl_(gname + ((gdir[iz - 1] - 1) << 3), &genl, &csiz);
      igz = gdir[iz - 1];
      genplot_(&gpchr[igz - 1], &genl, &gchrom[igz - 1],
	       &ych[gchrom[igz - 1] - 1], gname + ((igz - 1) << 3));
    }
L79:
/*   get in situ dots */
  if (unit_12) rewind (unit_12) ;
  if (logdot)
    {
      plotdots_(ych);
    }
/* jes-graph */
/*      call plt$endp */
    return 0;
} /* cetri_ */

#undef tname1b
#undef tnameb
#undef tname1
#undef names
#undef tname
#undef name1

int botscale_(float *y, float *xzero, float *scale, float *csiz)
{
  static float x;
  static long int iq;
  static float yt;

/* jes-graph */
/*      call plt$font(1) */
/*      call plt$mvto(xzero, y) */
/*      call plt$dwto(xzero + (100. * scale), y) */

  for (iq = 0; iq <= 100; ++iq)
    {
      x = *xzero + (float) iq * *scale;
      yt = *y + *csiz * .2f;
      if (iq % 5 == 0)
	{
	  yt += *csiz * .3f;
	}
      if (iq % 10 == 0)
	{
	  yt += *csiz * .37f;
/* jes-graph */
/*      call plt$ancd(x, y - (csiz * 1.5)) */
/*      call plt$inum(iq, 3, 1., 1., 2) */
	}
/* jes-graph */
/*      call plt$mvto(x, y) */
/*      call plt$dwto(x, yt) */
    }
  return 0;
} /* botscale_ */

int genplot_(float *pchr1, float *genl, short int *hchrom1, 
	     float *ys, char *gene1)
{
  /* Local variables */
  static long int ilft, nent;
  static float x, y;
  static long int lev, irt, num;
  
/* get plot level; use 2 * plot units */
  x = xzero + *pchr1 * scale;
  ilft = (long int) (x / 2.f);
  irt = (long int) ((x + *genl) / 2.f);
  nent = genlev[*hchrom1 + 5993];
  for (lev = 1; lev <= maxlev; ++lev)
    {
      ilft += 1000;
      irt += 1000;
      for (num = 1; num <= nent; num += 2)
	{
	  if (ilft < genlev[*hchrom1 + (num + 1) * 6 - 7])
	    {
	      if (irt > genlev[*hchrom1 + num * 6 - 7])
		{
		  goto L74;
		}
	    }
	}
      goto L76;
L74:
      ;
    }
L76:
  genlev[*hchrom1 + 5993] = nent + 2;
  genlev[*hchrom1 + (nent + 1) * 6 - 7] = ilft - 2;
  genlev[*hchrom1 + (nent + 2) * 6 - 7] = irt + 2;

/* place gene */
    y = *ys;
/* jes-graph */
/*      call plt$mvto(x, y) */
/*      call plt$dwto(x, y + float(levgap * lev)) */
/*      call plt$ancd(x, (y + (csiz * .37)) + float(levgap * lev)) */
/*      call plt$strc(gene1) */
  return 0;
} /* genplot_ */

int gnhl_(char *gene1, float *ghl, float *csiz)
{
  static long int igl;
  
  for (igl = 8; igl >= 1; --igl)
    {
      if (gene1[igl - 1] != ' ')
	{
	  goto L70;
	}
    }
L70:
  *ghl = *csiz * (float) igl / 2.f;
  return 0;
} /* gnhl_ */

int gsort_(long int *itot, long int *dir, float *pos)
{
  /* System generated locals */
  long int i__1, i__2, i__3;
  
  /* Local variables */
  static long int i, j, m, itemp;
  
  /* Parameter adjustments */
  --pos;
  --dir;
  
  /* Function Body */
  m = *itot;
L15:
  m = (m + 2) / 3;
  i__1 = *itot;
  for (i = m + 1; i <= i__1; ++i)
    {
      i__2 = m + 1;
      i__3 = -m;
      for (j = i; i__3 < 0 ? j >= i__2 : j <= i__2; j += i__3)
	{
	  if (pos[dir[j]] <= pos[dir[j - m]])
	    {
	      goto L16;
	    }
	  itemp = dir[j];
	  dir[j] = dir[j - m];
	  dir[j - m] = itemp;
	}
L16:
      ;
    }
  if (m != 1)
    {
      goto L15;
    }
    return 0;
} /* gsort_ */

void plotBrackets (long int x1, long int x2, long int y)
{
  movevt640_(x1, y) ; drawvt640_(x1-1, y-5) ;
  drawvt640_(x1-1, y-15) ;
  drawvt640_(x1, y-20) ;

  movevt640_(x2, y) ; drawvt640_(x2+1, y-5) ;
  drawvt640_(x2+1, y-15) ;
  drawvt640_(x2, y-20) ;
}
void plotBigChromNum (long int chromNo, long int x, long int y)
{
  switch (chromNo)
    {
    case 3:
      movevt640_(x, y) ; drawvt640_(x+6, y) ;
      movevt640_(x+3, y) ; drawvt640_(x+3, y-20) ;
      movevt640_(x, y-20) ; drawvt640_(x+6, y-20) ;
      x += 10 ;
    case 2:
      movevt640_(x, y) ; drawvt640_(x+6, y) ;
      movevt640_(x+3, y) ; drawvt640_(x+3, y-20) ;
      movevt640_(x, y-20) ; drawvt640_(x+6, y-20) ;
      x += 10 ;
    case 1:
    case 4:
      movevt640_(x, y) ; drawvt640_(x+6, y) ;
      movevt640_(x+3, y) ; drawvt640_(x+3, y-20) ;
      movevt640_(x, y-20) ; drawvt640_(x+6, y-20) ;
      if (chromNo == 1 || chromNo == 2 || chromNo == 3)
	goto brackets ;
      x += 10 ;
    case 5:			/* plots a five */
      movevt640_(x, y) ; drawvt640_(x+6, y) ;
      movevt640_(x+3, y) ; 
      drawvt640_(x+8, y-20) ;
      drawvt640_(x+13, y) ;
      movevt640_(x+10, y) ; drawvt640_(x+16, y) ;
      goto brackets ;
    case 6:			/* plots a roman 10 = X */
      movevt640_(x, y) ; drawvt640_(x+6, y) ;
      movevt640_(x+10, y) ; drawvt640_(x+16, y) ;
      movevt640_(x, y-20) ; drawvt640_(x+6, y-20) ;
      movevt640_(x+10, y-20) ; drawvt640_(x+16, y-20) ;
      movevt640_(x+3, y) ; drawvt640_(x+13, y-20) ;
      movevt640_(x+13, y) ; drawvt640_(x+3, y-20) ;
      goto brackets ;

    default: return ;
    }
 brackets:
  switch (chromNo)
    {
    case 1:
      plotBrackets (x - 6, x + 6 + 6, y) ;
      break ;
    case 2:
      x -= 10 ;
      plotBrackets (x - 6, x + 10 + 6 + 6, y) ;
      break ;
    case 3:
      x -= 20 ;
      plotBrackets (x - 6, x + 20 + 6 + 6, y) ;
      break ;
    case 4:
      x -= 10 ;
      plotBrackets (x - 6, x + 20 + 6 + 6, y) ;
      break ;
    case 5:
    case 6:
      plotBrackets (x - 6, x + 10 + 6 + 6, y) ;
      break ;
   }
}
/*   plots contig for printing */
int tricont_(long int ixs, long int iys, long int ixrt1, long int iscale, 
	     long int ncomp, long int *icnuma)
{
  /* System generated locals */
  static char equiv_0[11], equiv_1[6], equiv_2[9], equiv_3[41];
#define tname3 (equiv_0)
#define tname3b (equiv_0)
#define chplt (equiv_1)
#define chpltb (equiv_1)
#define pgen (equiv_2)
#define pgenc (equiv_2)
#define prem (equiv_3)
#define premc (equiv_3)

  /* Local variables */
  static BOOL bmpg;
  static long int ilen;
  static long int ncyc, iptd;
  static long int nlev, ipxf;
  static long int ipos, itxg, ipxt;
  static short int hflag;
  static long int ichar;
  static float cspac;
  static char tname[9];
  static long int itemp, ixmin, ixmax;
  static long int itemp1, iq, iv, ix, iy, ncharg;
  static long int nchars;
  static short int hchrom;
  static long int remlev[16], itlstg;
  static long int ilg, ias, lev;
  static BOOL vir;
  static long int ipy, itx, ity;

  /* Parameter adjustments */
  --icnuma;
  
  /* Function Body */

/* save itlstg,remlev */
  ixmin = 10;
  ixmax = 1020 - (ixrt1 - ixs) * iscale ;

  ichar = 9;
  strtcpy(chplt, "     ", 5L);
  if (icnuma[3998] != 0)
    {
      strtcpy(chplt, chrom + icnuma[3998] * 5, 5L);
    }
  itlstg = -1000000;
  cspac = 30.f;
  nlev = 8;
  iptd = 4;
  ncyc = 3;
  for (lev = 1; lev <= 16; ++lev)
    {
      remlev[lev - 1] = itlstg;
    }

  for (ix = 1; ix <= ncomp; ++ix)
    {
      iy = icnuma[ix];
      if (iflag_(iy, 4) == 1)
	{
	  vir = TRUE;
	}
      else
	{
	  vir = FALSE;
	}
      strtcpy(tname3, namea + ((iy - 1) << 3), 8);
      ias = strlength (tname3b, 10) ;
      if (icana[iy - 1] == -1)
	{
	  tname3b[ias] = ' ';
	  tname3b[ias + 1] = '*';
	  tname3b[ias + 2] = 0;
	}
      ipos = iposa[iy - 1];
      ilen = ilena[iy - 1];

      if (vir)
	{
	  for (iq = ias; iq >= 1; --iq)
	    {
	      tname3b[iq] = tname3b[iq - 1];
	    }
	  tname3b[0] = '(';
	  tname3b[ias + 1] = ')';
	  tname3b[ias + 2] = 0;
	}
      itx = (ixs + ipos + ilen / 2) * iscale + 500 - ias / 2 * ichar;
/* clone has remark */
      if (irema[iy - 1] > 0)
	{
	  seek_11 (irema[iy - 1]) ;
	  fread (&itemp, sizeof(long int), 1, unit_11);
	  fread (pgen, sizeof (char), 8, unit_11) ;
	  fread (prem, sizeof(char), 40, unit_11) ;
	  fread (&hchrom, sizeof(short int), 1, unit_11);
	  fread (&hflag, sizeof(short int), 1, unit_11);
	  ity = iys - 30;
	  ilg = strlength (pgen, 8) ;
	  if (ilg == 0)
	    {
	      goto L37;
	    }
/* bump gene to right if necessary */
	  if (itlstg > itx)
	    {
	      itxg = itlstg;
	      bmpg = TRUE;
	    }
	  else
	    {
	      itxg = itx;
	      bmpg = FALSE;
	    }
	  itlstg = itxg + (ilg + 1) * ichar;
	  ncharg = max(0,min(8,(ixmax - itxg) / ichar));
	  if (itxg < ixmin)
	    {
	      ncharg = max(0,8 - (ixmin - itxg) / ichar - 1);
	      itxg += (8 - ncharg) * ichar;
	      for (iv = 1; iv <= ncharg; ++iv)
		{
		  pgen[iv - 1] = pgen[iv + 8 - ncharg - 1];
		}
	    }
/*   plot gene, indicate bump with comma */
	  if (bmpg && itxg - ichar > ixmin)
	    {
	     movevt640_(itxg - ichar, ity);
	     textvt640_(",", 1);
	    }
	  movevt640_(itxg, ity);
	  textvt640_(pgen, ncharg);
L37:
	  remplot1_(prem, premc, &ichar, remlev, &c__16,
			 ixmin, ixmax, &itx, &ity);
	  while(hflag != 0)
	    {
	      itemp1 = hflag;
/* not yet implemented */
	      if (itemp1 < 0)
		{
		  itemp1 = 32767 - itemp1;
		}
	      seek_11 (itemp1) ;
	      fread (&itemp, sizeof(long int), 1, unit_11);
	      fread (tname, sizeof(char), 8, unit_11);
	      fread (prem, sizeof(char), 40, unit_11);
	      fread (&hchrom, sizeof(short int), 1, unit_11);
	      fread (&hflag, sizeof(short int), 1, unit_11);
	      remplot1_(prem, premc, &ichar, remlev, &c__16,
			     ixmin, ixmax, &itx, &ity);
	    }
	}
      ipy = iys + cspac * ((ix - 1) % nlev) +
	cspac / ncyc * ((ix - 1) / nlev % ncyc);
      if (vir)
	{
	  ipy += 4;
	}
      ity = ipy + iptd;
      ipxf = (ixs + ipos) * iscale + 500;
      ipxt = ipxf + ilen * iscale;
      if (ipxf > ixmax)
	{
	  goto L32;
	}
      if (ipxt < ixmin)
	{
	  goto L32;
	}
      if (ipxf < ixmin)
	{
	  ipxf = ixmin;
	}
       if (ipxt > ixmax)
	{
	  ipxt = ixmax;
	}
      nchars = max(0,min(10,(ixmax - itx) / ichar));
      if (itx < ixmin)
	{
	  nchars = max(0,10 - (ixmin - itx) / ichar - 1);
	  itx += (10 - nchars) * ichar;
	  for (iv = 1; iv <= nchars; ++iv)
	    {
	      tname3b[iv - 1] = tname3b[iv + 10 - nchars - 1];
	    }
	  tname3b[nchars] = 0;
	}
      movevt640_(ipxf, ipy);
      drawvt640_(ipxt, ipy);
      movevt640_(itx, ity+2);        /* +2 plots text a bit higher*/
      textvt640_(tname3b, nchars);
L32:
      ;
    }
  graphTextHeight (0.6) ;
  pltdate_(ixmin, iys + 400);

  plotBigChromNum (icnuma[3998], 30, iys + 370) ;

  graphTextHeight (0.75) ;
  movevt640_(ixmin, iys + 300) ;
  textvt640_("scale of 10 HindIII sites", 26) ;

  movevt640_(ixmin, iys + 283) ;
  drawvt640_(ixmin, iys + 287) ;

  movevt640_(ixmin, iys + 285) ;
  drawvt640_(ixmin + 20 * iscale, iys + 285) ;

  movevt640_(ixmin + 20 * iscale, iys + 283) ;
  drawvt640_(ixmin + 20 * iscale, iys + 287) ;

  graphTextHeight (1.0) ;

  return ixmax ;
} /* tricont_ */

#undef tname3b
#undef chpltb
#undef tname3
#undef chplt
#undef premc
#undef pgenc
#undef prem
#undef pgen


int remplot1_(char *prem, char *premc, long int *ichar, 
	      long int *remlev, long int *iplev, long int ixmin,
	      long int ixmax, long int *itx, long int *ity)
{
  /* Local variables */
  static long int ilft, itxr, iv, ncharr, levgap, iremsp, ilr, lev, irt;

  /* Parameter adjustments */
  --remlev;
  --prem;
  
  /* Function Body */
  iremsp = 10;
  levgap = 16;
  itxr = *itx;

/* get length of remark */
  ilr = strlength (prem, 40) ;

/* skip if no remark */
  if (ilr == 0)
    {
      return 0 ;
    }
/* get plot level before clipping, to keep register between frames */
  ilft = itxr;
  irt = itxr + ilr * *ichar;
  for (lev = 1; lev <= *iplev; ++lev)
    {
      if (ilft >= remlev[lev])
	{
	  goto L73;
	}
    }
  lev = *iplev;
/* clip remark */
L73:
  remlev[lev] = irt + iremsp;
  ncharr = max(0,min(40,(ixmax - *itx) / *ichar));
  if (itxr < ixmin)
    {
      ncharr = max(0,40 - (ixmin - *itx) / *ichar - 1);
      itxr += (40 - ncharr) * *ichar;
      for (iv = 1; iv <= ncharr; ++iv)
	{
	  prem[iv] = prem[iv + 40 - ncharr];
	}
    }
  movevt640_(itxr, max(1, *ity - (levgap * lev))) ;
  if (ncharr)
    textvt640_(premc, ncharr) ;
  return 0;
} /* remplot1_ */

int corners_(long int xl, long int xh, long int yl, long int yh)
{
  pointvt640_(xl, yl) ;
  pointvt640_(xl, yh) ;
  pointvt640_(xh, yl) ;
  pointvt640_(xh, yh) ;
  return 0;
} /* corners_ */

int setfont_(long int *ifont)
{

  gprintf (stdout,
	   "   0 = caps\n"
	   "   1 = normal\n"
	   "   2 = italic\n"
	   "   3 = invit\n"
	   "   4 = Greek\n") ;
L52:
  gprintf (stdout,
	   "   font number = ") ; 
  readinput ("", stemp, 1) ; if (nonint(stemp)) goto L52 ;
  *ifont = a2int (stemp) ;
  if (*ifont < 0 || *ifont > 4)
    {
      goto L52;
    }
  return 0;
} /* setfont_ */

int nomch_(char *name)
{
  /* Local variables */
  static long int ic, in, iq;
  
  for (iq = 1; iq <= 8; ++iq)
    {
      ic = (long int) name[iq - 1];
      if (ic >= 65 && ic <= 90)
	{
	  name[iq - 1] = (char) (ic + 32);
	}
      else if (ic >= 48 && ic <= 57)
	{
	  goto L10;
	}
    }
  return 0;
L10:
  for (in = 7; in >= iq; --in)
    {
      strncpy(name + in, name + (in - 1), 1);
    }
  name[iq - 1] = '-';
  return 0;
} /* nomch_ */

BOOL inlist_(char *name)
{
  /* System generated locals */
  BOOL ret_val;
  FILE *unit_20 ;

  /* Local variables */
  static char list[8*200], ctemp[9];
  static long int nlist, iq;
  static BOOL rdlist;
  
  ret_val = FALSE;
  if (! rdlist)
    {
      unit_20 = FILopen ("gene", "acc", "r") ;
      for (iq = 1; iq <= 200; ++iq)
	{
	  readstring (unit_20, ctemp, 8) ;
	  if (FILerror (unit_20)) goto L10 ;
	  if (strlength(ctemp, 8) == 0)
	    {
	      goto L10;
	    }
	  ++nlist;
	  strncpy(list + ((nlist - 1) << 3), ctemp, 8);
	}
L10:
      fclose (unit_20) ;
      rdlist = TRUE;
    }
  for (iq = 1; iq <= nlist; ++iq)
    {
      if (strncmp(name, list + ((iq - 1) << 3), 8) == 0)
	{
	  ret_val = TRUE;
	  return ret_val;
	}
    }
  return ret_val;
} /* inlist_ */

int setparam_(void)
{
  /* Local variables */
  static float temp;
  static long int itemp;
  
  gprintf (stdout, "   chrgap (def =%6.1f) = ", chrgap) ;
  readinput ("", stemp, 8) ; temp = a2flt (stemp) ;
  if (temp != 0.f)
    {
      chrgap = temp;
    }
  gprintf (stdout, "   csiz (def =%6.1f) = ", csiz) ;
  readinput ("", stemp, 8) ; temp = a2flt (stemp) ;
  if (temp != 0.f)
    {
      csiz = temp;
    }
  gprintf (stdout, "   levgap (def =%6.1f) = ", levgap) ;
  readinput ("", stemp, 6) ; itemp = a2int (stemp) ;
  if (itemp != 0.f)
    {
      levgap = itemp;
    }
  return 0;
} /* setparam_ */

int plotdots_(float *ych)
{
  /* System generated locals */
  float r__1;
  FILE *unit_21, *unit_22 ;

  /* Local variables */
  static char name[9];
  static long int maxd, maxi;
  static float y;
  static long int itemp, isymb, id, iq, ichrom, dothis[101];
  static float dsp;

  /* Parameter adjustments */
  --ych;

    /* Function Body */
  isymb = 16;
  dsp = 4.f;
  if (!(unit_21 = FILopen ("dot", "nam", "r"))) goto L98 ;
  while(TRUE)
    {
      fscanf (unit_21, "%s%ld%ld", name, &ichrom, &itemp);
      if (FILerror (unit_21)) goto L99 ;
      y = ych[ichrom];
      if (itemp != 0)
	{
	  isymb = itemp;
	}
      for (iq = 0; iq <= 100; ++iq)
	{
	  dothis[iq] = 0;
	}
      if (!(unit_22 = FILopen (name, "dts", "r"))) goto L97 ;
      maxd = 0;
      while(TRUE)
	{
	  fscanf (unit_22, "%ld", &id) ;
	  if (FILerror (unit_22)) goto L96 ;
	  if (id < 0 || id > 100)
	    {
	      goto L96;
	    }
	  ++dothis[id];
	  if (dothis[id] > maxd)
	    {
	      maxd = dothis[id];
	      maxi = id;
	    }
	  r__1 = y + dothis[id] * dsp;
	  dot_(&isymb, &id, &r__1);
L96:
	  ;
	}
/* jes-graph */
/*      call plt$ancd(xzero + (maxi * scale), y + ((maxd + 1) * dsp)) */
/*      call plt$strc(name) */
L97:
	;
    }
L98:
  gprintf (stdout, "  DOT.NAM not available\n") ;
L99:
  return 0;
} /* plotdots_ */

int dot_(long int *isymb, long int *id, float *y)
{
  static float x;

  x = xzero + *id * scale;
/* jes-graph */
/*      call plt$ancd(x, y) */
/*      call plt$gsym(isymb, 1) */
    return 0;
} /* dot_ */

int pstart_(BOOL *tripr)
{
  if (*tripr)
    {
      return 0;
    }
/* jes-graph */
/*      call plt$init('chr.plt') */
/*      call plt$prnt(0) */
  *tripr = TRUE;
  return 0;
} /* pstart_ */

int prcont_(long int ncomp, long int *icnum, long int iscale)
{
  static long int list, ixrt, ixst;

  /* Parameter adjustments */
  --icnum;

  /* Function Body */
  ixst = -iposa[icnum[3999] - 1] - 400 / iscale;
  ixrt = iposa[icnum[ncomp] - 1] + ilena[icnum[ncomp] - 1];
  list = 1;
  tricont_(ixst, 320, ixrt, iscale, ncomp, &icnum[1]);
  while((ixst + ixrt) * iscale > 400)
    {
      ixst -= 900 / iscale;
      ++list;
      tricont_(ixst, 320, ixrt, iscale, ncomp, &icnum[1]);
    }
  return 0;
} /* prcont_ */

/* this function is really used */
int prcont1_(long int ncomp, long int *icnum, long int iscale,
	     long int ixst, long int ixrt, long int ixlm, long int ixrm)
{
  /* Local variables */
  static long int ixrt1, ixst1;
  static char ans[1];

L106:
  gprintf (stdout, "  Print whole contig (W) or just a section (S)? ") ;
  readinput ("", stemp, 1) ; *ans = *stemp ;
  if (*ans == 'w' || *ans == 'W')
    {
      ixst1 = ixst - 400 / iscale;
      ixrt1 = ixrt + 400 / iscale;
    }
  else if (*ans == 's' || *ans == 'S')
    {
      ixst1 = min(ixst - 400 / iscale,ixlm);
      ixrt1 = max(ixrt + 400 / iscale,ixrm);

      if (ixst1 < ixrt1)
	{
	  colorvt640_(RED+100) ;
	  gprintf (stdout, " !! WARNING !! ") ;
	  colorvt640_(BLACK) ;
	  gprintf (stdout, "\nThe left marker has been placed to right "
		   "of the right marker !\n") ;
	}
      gprintf (stdout, "  Do you want to print with the"
	       " selected markers (Y/N) ? ") ;
      readinput ("", stemp, 1) ; *ans = *stemp ;
      if (*ans != 'y' && *ans != 'Y')
	{
	  return 0;
	}
    }
  else
    {
      goto L106;
    }
  clearvt640_() ;		/* clear screen */

  return (tricont_(ixst1, 320, ixrt1, iscale, ncomp, icnum));
} /* prcont1_ */

/*   to plot chromosomes and unmapped contigs */
int chplt_(long int *nclone, BOOL hc)
{
  /* Local variables */
  static long int ibnd;
  static BOOL cdir[1200];
  static long int ichr, klen;
  static float cpcu[200];
  static long int igpt, cpnu[200], ctot[6], gout[2000];
  static char knama[24*5];
  static long int srcha[5], icmax, iqchr, itemp, ictot;
  static float pcurr;
  static long int iq, ktlena[5];
  static float chrscl;
  static long int ichrom, chstrt[9];
  static float cpc[1200]	/* was [200][6] */, chl, gap;
  static long int iqc, cpn[1200]	/* was [200][6] */;
  static char ans[1];
  static long int iqq;

  gap = .6f;			/* see also CBUMP */
  chrscl = .010235294117647059f; /* see also CHROMPLT */
  gprintf (stdout, 
	   "    -1    unmapped contigs\n"
	   "    1-6   single chromosome\n"
	   "    7     all chromosomes\n") ;
L101:
  gprintf (stdout, 
	   "    option = ") ;

  readinput ("", stemp, 6) ; if (nonint(stemp)) goto L101 ;
  ichrom = a2int (stemp) ;
  if (ichrom < -1 || ichrom > 7 || ichrom == 0)
    {
      goto L101;
    }
  for (iq = 1; iq <= 5; ++iq)
    {
      strncpy(knama + (iq - 1) * 24, "                        ", 24);
    }
  itemp = 0;
  gprintf (stdout,
	   "   give keysearch field if required\n"
	   "     (clone=C,gene=G,remark=R) : ") ;
  readinput ("", stemp, 1) ; *ans = *stemp ;
  if (*ans == 'c' || *ans == 'C')
    {
      itemp = 1;
    }
  if (*ans == 'g' || *ans == 'G')
    {
      itemp = 2;
    }
  if (*ans == 'r' || *ans == 'R')
    {
      itemp = 3;
    }
  if (itemp != 0)
    {
      keyw1_(knama + (itemp - 1) * 24, &ktlena[itemp - 1], &klen);

      gprintf (stdout,
	       "  type F for first characters only "
	       "(def = searches all): ") ;
      readinput ("", stemp, 1) ; *ans = *stemp ;
      if (*ans == 'f' || *ans == 'F')
	{
	  srcha[itemp - 1] = 1;
	}
      else
	{
	  srcha[itemp - 1] = 9 - klen;
	  if (itemp == 3)
	    {
	      srcha[itemp - 1] = 41 - klen;
	    }
	}
    }
  gencont1_(nclone, gout, &igpt, chstrt, ctot, cpn, cpc);
  if (ichrom == 7)
    {
      for (ichr = 1; ichr <= 6; ++ichr)
	{
	  chromplt_(&ichr, &ctot[ichr - 1], &cpn[ichr * 200 - 200],
		    &cpc[ichr * 200 - 200], nclone, ktlena, knama,
		    srcha, hc);
	  waitForMore (SPACE_KEY) ;
	}
    }
  else if (ichrom == -1)
    {
      seek_10 (1) ;
      fread (&icmax, sizeof(long int), 1, unit_10);
      for (iq = 1; iq <= icmax; ++iq)
	{
	  cdir[iq - 1] = FALSE;
	}
      for (iqchr = 1; iqchr <= 6; ++iqchr)
	{
	  for (iq = 1; iq <= ctot[iqchr - 1]; ++iq)
	    {
	      itemp = cpn[iq + iqchr * 200 - 201];
	      if (itemp > 0)
		{
		  cdir[itemp - 1] = TRUE;
		}
	    }
	}
/*   eliminate hidden contigs */
      for (iq = 1; iq <= icmax; ++iq)
	{
	  if (! cdir[iq - 1])
	    {
	      for (iqq = 2; iqq <= *nclone + 1; ++iqq)
		{
		  if (iconta[iqq - 1] == iq)
		    {
		      if (iflag_(iqq, 8) == 1)
			{
			  cdir[iq - 1] = TRUE;
			}
		      goto L102;
		    }
		}
	    }
L102:
	  ;
	}
      iqc = 0;
      ictot = 0;
      pcurr = 0.f;
      while(iqc < icmax)
	{
	  ++iqc;
	  if (! cdir[iqc - 1])
	    {
	      sizcont_(nclone, &iqc, &ibnd);
	      if (ibnd > 0)
		{
		  chl = (float) ibnd * chrscl;
		  if ((pcurr + gap+chl > 95.f && pcurr > 0.f) || ictot>200)
		    {
/*   section full, print it */
		      chromplt_(&c__0, &ictot, cpnu, cpcu, nclone, ktlena, 
				knama, srcha, hc);
		      ictot = 0;
		      pcurr = 0.f;
		    }
		  ++ictot;
		  cpnu[ictot - 1] = iqc;
		  cpcu[ictot - 1] = pcurr + gap + chl * .5f;
		  pcurr = pcurr + gap + chl;
		}
	    }
	}
      chromplt_(&c__0, &ictot, cpnu, cpcu, nclone,
		ktlena, knama, srcha, hc);
    }
  else
    {
      chromplt_(&ichrom, &ctot[ichrom - 1], &cpn[ichrom * 200 - 200],
		&cpc[ichrom * 200 - 200], nclone, ktlena, knama,
		srcha, hc);
    }
  return 0;
} /* chplt_ */

/*   to plot contigs lying on one chromosome */
/*   contigs are already ordered */
int chromplt_(long int *ichr, long int *ictot, long int *cpns, 
	      float *cpcs, long int *nclone, long int *ktlena,
	      char *knama, long int *srcha, BOOL hc)
{
  /* Initialized data */
  static long int chmb[7] = { 15,18,14,16,19,22,18 };

  /* System generated locals */
  float r__1;
  static char equiv_0[9];
#define tname (equiv_0)
#define tnameb ((char *)equiv_0)

  /* Local variables */
  static long int ican, ibnd;
  static float genl;
  static long int ilft, iref;
  static float temp;
  static long int iysc;
  static float xmin, ymin, ycnt, xmax, ymax, ykey;
  static char gene1[9];
  static float temp1;
  static short int hflag;
  static float pcend;
  static char kname[25];
  static float chist[1000];
  static BOOL lsrch[5];
  static short int htemp;
  static long int ncomp, itemp, icont;
  static float tpcth;
  static long int iykey, itemp1, ic;
  static long int iq, ix;
  static long int iy;
  static long int icnuma[4000];
  static char remark[41];
  static float chrscl, yscale;
  static long int iposav;
  static float pcstrt;
  static short int hchrom1;
  static float fac;
  static long int icb;
  static float bkb;
  static long int ifb;
  static float chl;
  static long int ilb;
  static float cpl[200];
  static float cpr[200], pct;
  static long int irt;
  static float gpx;
  
  /* Parameter adjustments */
  --srcha;
  knama -= 24;
  --ktlena;
  --cpcs;
  --cpns;
  
  /* Function Body */
  for (iq = 1; iq <= 5; ++iq)
    {
/* lsrch(iq)=(knama(iq).ne.' ') */

      if (strlength(knama + iq * 24, 24) == 0)
	lsrch[iq - 1] = FALSE ;
      else
	lsrch[iq - 1] = TRUE ;

      if (lsrch[iq - 1])
	{
	  strtcpy(kname, knama + iq * 24, 24);
	}
    }
  bkb = 1.74f;		/* kb per band */
  chrscl = bkb/((float) chmb[*ichr]*10.f); /* % per band; see also CHPLT */
  scale = 2.7f;
  levgap = 5;
  csiz = 2.7f;
  maxlev = 20;
  chrgap = 70.f;
  ycnt = 40.f;
  ykey = 25.f;
  yscale = 20.f;
  fac = 1.5f;
  hchrom1 = 1;
  xzero = csiz * 5.5f;
  xmin = 0.f;
  xmax = scale * 100.f + xzero * 3.f;
  ymin = 0.f;
  ymax = ycnt + (float) (levgap * (maxlev + 5));
  tpcth = 10.f;			/* percent to histogram */
  xzero1 = 63.f;
  scale1 = 8.5f;
  levgap1 = 24;
  maxlev1 = 25;
  ichrgp = 80;
  iysc = 30;
  iykey = 55;
  for (iq = 1; iq <= 6; ++iq)
    {
      sitlev[iq + 1193] = 0;
      genlev[iq + 5993] = 0;
      genlev1[iq + 5993] = 0;
    }
  for (iq = 1; iq <= 1000; ++iq)
    {
      chist[iq - 1] = 0.f;
    }
  for (ic = 1; ic <= *ictot; ++ic)
    {
      if (cpns[ic] < 0)
	{
	  chl = (float) ilena[-cpns[ic] - 1] * chrscl;
	}
      else
	{
	  sizcont_(nclone, &cpns[ic], &ibnd);
	  chl = (float) ibnd * chrscl;
	}
      cpl[ic - 1] = cpcs[ic] - chl / 2.f;
      cpr[ic - 1] = cpcs[ic] + chl / 2.f;
    }
  cbump_(ictot, cpl, cpr);
  clearvt640_();
  selectvt640_();
  for (ic = *ictot; ic >= 1; --ic)
    {
      movevt640_(n_int(xzero1) + n_int(cpl[ic - 1] * scale1), ichrgp);
      drawvt640_(n_int(xzero1) + n_int(cpr[ic - 1] * scale1), ichrgp);
      if (cpns[ic] > 0)
	{
	  asscont4_(nclone, &cpns[ic], &ncomp, icnuma, &iposav);
	  ilft = iposa[icnuma[3998] - 1];
	  irt = iposa[icnuma[3999] - 1] + ilena[icnuma[3999] - 1];
	}
      else
	{
	  ncomp = 1;
	  icnuma[0] = -cpns[ic];
	  ilft = iposa[icnuma[0] - 1];
	  irt = ilft + ilena[icnuma[0] - 1];
	}
      for (ix = ncomp; ix >= 1; --ix)
	{
	  iy = icnuma[ix - 1];
	  if (irema[iy - 1] != 0)
	    {
	      seek_11 (irema[iy - 1]);
	      fread (&itemp, sizeof(long int), 1, unit_11);
	      fread (gene1, sizeof(char), 8, unit_11);
	      fread (remark, sizeof(char), 40, unit_11);
	      fread (&htemp, sizeof(short int), 1, unit_11);
	      fread (&hflag, sizeof(short int), 1, unit_11);
	      if (strlength(gene1, 8) > 0)
		{	/* if gene1 not empty */
		  gpx = cpl[ic - 1] + (cpr[ic - 1] - cpl[ic - 1]) * 
		    (float) (iposa[iy - 1] + ilena[iy - 1] / 2 - ilft) /
		      (float) (irt - ilft);
		  gnl_(gene1, &genl, &csiz);
		  itemp = 7 - hchrom1;
		  r__1 = genl * 4.4f;
		  genplot1_(&gpx, &r__1, &hchrom1, gene1, &itemp);
		  if (lsrch[1])
		    {
		      if (keychk1_(gene1, &srcha[2], &ktlena[2],knama + 48))
			{
			  getpct_(&iy, &ilft, &irt, &cpl[ic - 1],
				  &cpr[ic - 1], &pct);
			  icb = max(1,min(1000,(long int)
					  (pct * tpcth + .5f) - 1));
			  chist[icb - 1] += fac;
			}
		    }
		}
	      if (lsrch[2])
		{
		  if (strlength (remark, 40) > 0)
		    {		/* if remark not empty */
		      if (keychk1_(remark,&srcha[3],&ktlena[3], knama + 72))
			{
			  getpct_(&iy, &ilft, &irt, &cpl[ic - 1],
				  &cpr[ic - 1], &pct);
			  icb = max(1,min(1000,(long int)
					  (pct * tpcth + .5f) - 1));
			  chist[icb - 1] += fac;
			}
/*   now search for secondary remarks */
		      while(hflag != 0)
			{
			  itemp1 = hflag;
			  if (itemp1 < 0)
			    {
			      itemp1 = 32767 - itemp1;
			    }
			  seek_11 (itemp1);
			  fread (&itemp, sizeof(long int), 1, unit_11);
			  fread (tname, sizeof(char), 8, unit_11);
			  fread (remark, sizeof(char), 40, unit_11);
			  fread (&htemp, sizeof(short int), 1, unit_11);
			  fread (&hflag, sizeof(short int), 1, unit_11);
			  if (keychk1_(remark, &srcha[3],
				       &ktlena[3], knama + 72))
			    {
			      getpct_(&iy, &ilft, &irt, &cpl[ic - 1],
				      &cpr[ic - 1], &pct);
			      icb = max(1,min(1000,(long int)
					      (pct * tpcth + .5f) - 1));
			      chist[icb - 1] += fac;
			    }
			}
		    }
		}
	    }
	}
      icont = cpns[ic];
      if (lsrch[0])
	{
	  for (ix = 2; ix <= *nclone + 1; ++ix)
	    {
	      if (iconta[ix - 1] == icont)
		{
		  if (keychk_(&ix, &srcha[1], &ktlena[1], knama + 24))
		    {
		      ican = abs(icana[ix - 1]) % 10000000;
		      if (ican > 1)
			{
			  iref = ican;
			}
		      else
			{
			  iref = ix;
			}
		      itemp = max(1,irt - ilft);
		      temp = (cpr[ic - 1] - cpl[ic - 1]) / (float) itemp;
		      pcstrt = cpl[ic - 1] +
			(float) (iposa[iref - 1] - ilft) * temp;
		      pcend = pcstrt + (float) ilena[iref - 1] * temp;
		      ifb = max(1,(long int) (pcstrt * tpcth + .5f) - 1);
		      ilb = min(1000,(long int) (pcend * tpcth + .5f) - 1);
		      for (iq = ifb; iq <= ilb; ++iq)
			{
			  chist[iq - 1] += fac;
			}
		    }
		}
	    }
	}
    }
  temp = scale * .1f;
  temp1 = scale1 * .1f;

  colorvt640_(BLUE) ;
  for (iq = 1; iq <= 1000; ++iq)
    {
      if (chist[iq - 1] > 0.f)
	{
	  itemp = xzero1 + n_int((float) iq * temp1);
	  movevt640_(itemp, iykey);
	  drawvt640_(itemp, iykey + n_int(chist[iq - 1]));
	}
    }
  colorvt640_(BLACK) ;

  botscale1_(&iysc, &xzero1, &scale1);
  strtcpy(tname, chrom + *ichr * 5, 5L);
  movevt640_(0, 600);
  textvt640_(tnameb, 5);
  return 0;
} /* chromplt_ */

#undef tnameb
#undef tname


int getpct_(long int *ix, long int *ilft, long int *irt,
	    float *cpl, float *cpr, float *pct)
{
  /* Local variables */
  static long int ican, iref;
  static float temp;
  static long int itemp;
  
  ican = abs(icana[*ix - 1]) % 10000000;
  if (ican > 1)
    {
      iref = ican;
    }
  else
    {
      iref = *ix;
    }
  itemp = max(1,*irt - *ilft);
  temp = (*cpr - *cpl) / (float) itemp;
  *pct = *cpl + (float) (iposa[iref - 1] - *ilft +
			 ilena[iref - 1] / 2) * temp;
  return 0;
} /* getpct_ */

int pltdate_(int x, int y)
{
  movevt640_(x, y) ;
  textvt640_(getdatetime(), 19) ;
  
  return 0;
} /* pltdate_ */

int cbump_(long int *ictot, float *cpl, float *cpr)
{
  /* Local variables */
  static float endlt, endrt, shift, shift1, shift2;
  static long int ic, iq;
  static float gap, ref, ref1, ref2;

/* see also CHPLT */
  /* Parameter adjustments */
  --cpr;
  --cpl;
  
  /* Function Body */
  gap = .6f;
  for (ic = 2; ic <= *ictot; ++ic)
    {
      if (cpr[ic - 1] + gap > cpl[ic])
	{
	  ref1 = cpr[ic - 1];
	  ref2 = cpl[ic];
	  ref = (ref1 + ref2) / 2.f;
	  shift = ref1 - ref2 + gap;
	  shift1 = ref * shift / 100.f;
	  shift2 = (100.f - ref) * shift / 100.f;
	  for (iq = ic - 1; iq >= 1; --iq)
	    {
	      cpl[iq] -= shift1;
	      cpr[iq] -= shift1;
	      if (iq > 1)
		{
		  if (cpr[iq - 1] + gap <= cpl[iq])
		    {
		      goto L101;
		    }
		}
	    }
L101:
	  for (iq = ic; iq <= *ictot; ++iq)
	    {
	      cpl[iq] += shift2;
	      cpr[iq] += shift2;
	      if (iq < *ictot)
		{
		  if (cpl[iq + 1] - gap >= cpr[iq])
		    {
		      goto L102;
		    }
		}
	    }
L102:
	  ;
	}
    }
/*   shrink to fit if necessary */
  endlt = 0.f;
  endrt = 100.f;
  for (ic = 1; ic <= *ictot; ++ic)
    {
      if (cpl[ic] < endlt)
	{
	  endlt = cpl[ic];
	}
      if (cpr[ic] > endrt)
	{
	  endrt = cpr[ic];
	}
    }
  if (endlt != 0.f || endrt != 100.f)
    {
      for (ic = 1; ic <= *ictot; ++ic)
	{
	  cpl[ic] = cpl[ic] - endlt * (100.f - cpl[ic]) / (100.f - endlt) - 
	    (endrt - 100.f) * cpl[ic] / endrt;
	  cpr[ic] = cpr[ic] - endlt * (100.f - cpr[ic]) / (100.f - endlt) - 
	    (endrt - 100.f) * cpr[ic] / endrt;
	}
    }
  return 0;
} /* cbump_ */

static int size_of_cor = 0 ;

/*   to order clones in contig automatically */
int cntss_(long int *nclone, char *projectbase, BOOL *tripr, 
	   long int *iclone)
{
  /* Local variables */
  static char gene[9], name[9], tname[9];
  static long int bmat[400], line;
  static long int nmat[400], irng, igrp, tlen[400], maxm, cstk[400];
  static short int tmat[160000]	/* was [400][400] */;
  static BOOL unat[400];
  static long int nrnk, nfix, ivir, icrt, icyc;
  static long int ncln1, clst1[30000];
  static long int i, j;
  static long int icmax;
  static long int maxcl, ibest, iqold, tgrpa[4000], itemp;
  static long int itgrp, ncomp, nxtcl, tclst[400], vclst[400];
  static long int nband1, icnum1[4000], ncomp1;
  static long int iq, iscale, ix;
  static long int iz, iy, imatch;
  static long int ishift, coords[200];
  static long int iposav;
  static long int itolmn;
  static long int ihi, ilo;
  static BOOL bur;
  static float logfact[201];
  static long int iys, ixs, ixst, ixrt;

/* NUMBER IN PROBABILITY RANK */
  nrnk = 5;
/* MAX NUMBER OF CLONES FOR ONE CONTIG */
  icmax = 5;
/* INITIATE CANONICAL COUNT */
  nfix = 0;
  iscale = 5;
  iys = 60;
  line = *iclone;
/*   calc log factorials */
  logfact[0] = 0.f;
  logfact[1] = 0.f;
  for (i = 2; i <= 200; ++i)
    {
      logfact[i] = logfact[i - 1] + log((float) i);
    }
  if (size_of_cor == 0) /* not loaded yet */
    {				/* then load all the bands */
      int unit_cor ;
      char file[MAXPATHLEN] ;
      sprintf (file, "%s.cor", projectbase) ;

      unit_2 = FILopen (file, "", "r") ;
      fseek (unit_2, 0, SEEK_END) ;
    /* determine filesize of *.cor file */
      size_of_cor = ftell (unit_2) ;
      fclose (unit_2) ;

      unit_cor = open (file, O_RDONLY) ;
      /* read *.cor file into coorda array */
      /* cor file are shorts to make it load faster */
      read (unit_cor, &coorda, size_of_cor) ;
      close (unit_cor) ;
    }
/*   get clones */
L15:
    ncln1 = 0;
L4:
  gprintf (stdout, "   centre clone (G=gene,ST=start assembly) = ") ;
  readinput ("", name, 8);
  if (strlength(name, 8) == 0)
    {
      return 0;
    }
  else if (strcasecmp(name, "st") == 0)
    {
      if (line == 0)
	{
	  goto L4;
	}
      goto L2;
    }
  else if (strcasecmp(name, "g") == 0 || strcasecmp(name, "gene") == 0)
    {
      gprintf (stdout, "   gene name = ") ;
      readinput ("", gene, 8);
      iz = 0;
L402:
      ++iz;
      seek_11 (iz) ;
      fread (&line, sizeof(long int), 1, unit_11);
      fread (tname, sizeof(char), 8, unit_11);
      if (strncmp(tname, gene, 8) == 0)
	{
	  strtcpy(name, tname, 8);
	  goto L401;
	}
      else
	{
	  if (line != -9)
	    {
	      goto L402;
	    }
	}
      goto L4;
    }
  else
    {
      getline1_(name, &line, nclone);
    }
L401:
  if (line == 0)
    {
      goto L4;
    }
  if (iconta[line - 1] == 0)
    {
      goto L4;
    }
  asscont4_(nclone, &iconta[line - 1], &ncomp1, icnum1, &iposav);
  ixs = -iposa[line - 1];
  initvt640_();
  selectvt640_();
  plotcont4_(&ixs, &c__380, &c__5, &ncomp1, icnum1, projectbase,
	     nclone, &c__1);
  selectvt100_();
  goto L4;
L2:
/*   get clones and tolerance */
  gprintf (stdout, "   range in bands (full screen = 200, def = 150) = ") ;
  readinput ("", stemp, 6) ; if (nonint(stemp)) goto L2 ;
  itemp = a2int (stemp) ;
  irng = 150;
  if (itemp != 0)
    {
      irng = itemp;
    }
  getzone_(&line, &ncln1, clst1, nclone, &iconta[line - 1], &irng, &c__400);
L3:
  gprintf (stdout, "   tolerance (default = 7) = ") ;
  readinput ("", stemp, 6) ; if (nonint(stemp)) goto L3 ;
  itolmn = a2int (stemp) ;
  if (itolmn == 0)
    {
      itolmn = 7;
    }
  itoldf = itolmn ;
  gprintf (stdout, "  tolerance in tenths of mm=%6d (main)   "
	   "%6d (difmap)\n", itolmn, itoldf) ;
/* get options */
  bur = TRUE;
  gprintf (stdout,
	   "  Options :\n"
	   "   default     normal mode (positions buried clones only,\n"
	   "                   leaving canonicals unchanged)\n"
	   "   ALL         complete assembly (positions all clones,\n"
	   "                   but may give misleading result)\n"
	   "        option = ") ;
  readinput ("", name, 4) ;
  if (strcasecmp(name, "all") == 0)
    {
      bur = FALSE ;
    }
  ncln1 = min(ncln1,400);
  for (iq = 1; iq <= ncln1; ++iq)
    {
      tgrpa[iq - 1] = 1;
      strtcpy (ntemp1, namea + ((clst1[iq - 1] - 1) << 3), 8) ;
/*
      gprintf (stdout, "%-8s %d\n", ntemp1, clst1[iq - 1]);
*/
    }
/* later, start main loop here */
  igrp = 1;
/* get group */
  if (bur)
    {
/*************   BUR OPTION  *************** */
      itgrp = 0;
      ivir = 0;
      for (iq = 1; iq <= ncln1; ++iq)
	{
	  if (tgrpa[iq - 1] == igrp)
	    {
	      ix = clst1[iq - 1];
	      if (abs(icana[ix - 1]) <= 1)
		{
		  if (nbanda[ix - 1] == 0) /* virtual clone: set aside */
		    {
		      ++ivir;
		      vclst[ivir - 1] = ix;
		    }
		  else
		    {
		      if (iflag_(ix, 1) != 1)
			/* check for computer positioning */
			{
			  ++itgrp;
			  gclst[itgrp - 1] = ix;
			  glen[itgrp - 1] = ilena[ix - 1];
			  gpos[itgrp - 1] = iposa[ix - 1];
			}
		    }
		}
	    }
	}
      nfix = itgrp;
      for (iq = 1; iq <= ncln1; ++iq)
	{
	  if (tgrpa[iq - 1] == igrp)
	    {
	      ix = clst1[iq - 1];
	      if (abs(icana[ix - 1]) > 1 || iflag_(ix, 1) == 1)
		{
		  ++itgrp;
		  gclst[itgrp - 1] = ix;
		  glen[itgrp - 1] = nbanda[ix - 1];
		}
	    }
	}
/*   get match matrix for group */
      for (iq = 1; iq <= itgrp - 1; ++iq)
	{
	  getbnds_(&gclst[iq - 1], &nband1, coords);
	  for (j = iq + 1; j <= itgrp; ++j)
	    {
	      matchs_(gclst[j - 1], nband1, coords, itolmn, &imatch);
	      imatch =
		max(0,imatch - ibg_(&glen[j - 1],
				    &glen[iq - 1], &imatch, &itolmn));
		gmat[j + iq * 400 - 401] = imatch;
		gmat[iq + j * 400 - 401] = imatch; /* probably not needed */
	    }
	}
      ngrp = nfix;
    }
/*   ****************   TOTAL OPTION   ******************** */
  else
    {
      itgrp = 0;
      for (iq = 1; iq <= ncln1; ++iq)
	{
	  if (tgrpa[iq - 1] == igrp && nbanda[clst1[iq - 1] - 1] != 0)
	    {
	      ++itgrp;
	      tclst[itgrp - 1] = clst1[iq - 1];
	    }
/* get clone sizes, clear arrays */
	}
      for (iq = 1; iq <= itgrp; ++iq)
	{
	  ix = tclst[iq - 1];
	  if (abs(icana[ix - 1]) > 1)
	    {
	      tlen[iq - 1] = nbanda[ix - 1];
	    }
	  else
	    {
	      tlen[iq - 1] = ilena[ix - 1];
	    }
	  bmat[iq - 1] = 0;
	  nmat[iq - 1] = 0;
	  unat[iq - 1] = TRUE;
	}
/*   get match matrix for group */
      maxm = 0;
      for (iq = 1; iq <= itgrp - 1; ++iq)
	{
	  getbnds_(&tclst[iq - 1], &nband1, coords);
	  for (j = iq + 1; j <= itgrp; ++j)
	    {
	      matchs_(tclst[j - 1], nband1, coords, itolmn, &imatch);
	      imatch =
		max(0,imatch - ibg_(&tlen[j - 1], &tlen[iq - 1], &
				    imatch, &itolmn));
	      if (imatch > nmat[j - 1])
		{
		  nmat[j - 1] = imatch;
		  bmat[j - 1] = iq;
		}
	      if (imatch > nmat[iq - 1])
		{
		  nmat[iq - 1] = imatch;
		  bmat[iq - 1] = j;
		}
	      if (imatch > maxm)
		{
		  maxm = imatch;
		  maxcl = iq;
		}
	      tmat[j + iq * 400 - 401] = imatch;
	      tmat[iq + j * 400 - 401] = imatch; /* probably not needed */
	    }
	}
/*   get entry order */
      ihi = 1;
      cstk[0] = maxcl;
      unat[maxcl - 1] = FALSE;
      for (ilo = 1; ilo <= itgrp; ++ilo)
	{
	  nxtcl = cstk[ilo - 1];
	  enter_(&bmat[nxtcl - 1], &ihi, cstk, unat);
	  for (iq = 1; iq <= itgrp; ++iq)
	    {
	      if (bmat[iq - 1] == nxtcl)
		{
		  enter_(&iq, &ihi, cstk, unat);
		}
	    }
	  if (ihi == itgrp)
	    {
	      goto L211;
	    }
	  if (ilo == ihi)
	    {
	      findnew_(&ihi, cstk, unat, &itgrp, tmat);
	    }
	  if (ihi == itgrp)
	    {
	      goto L211;
	    }
	}
/*   sort by entry order */
L211:
      for (iq = 1; iq <= itgrp; ++iq)
	{
	  iqold = cstk[iq - 1];
	  gclst[iq - 1] = tclst[iqold - 1];
	  glen[iq - 1] = tlen[iqold - 1];
	  for (j = 1; j <= itgrp; ++j)
	    {
	      gmat[j + iq * 400 - 401] =
		tmat[cstk[j - 1] + iqold * 400 - 401];
	    }
	}
      ngrp = 1;
      gpos[0] = 0;
    }
/****************   END OPTIONS   **************** */
/*
  gprintf (stdout, "  nfix = %d   itgrp = %d\n", nfix, itgrp) ;
*/

/* initiate contig */
  assgrp_(&ncomp, icnum1, &iposav, &icrt);

/* add clones to contig one by one */
  for (ngrp = max(2,nfix + 1); ngrp <= itgrp; ++ngrp)
    {
/*
      gprintf (stdout, "%d\n", ngrp);
*/
      ibest = -1000000;
      gpos[ngrp - 1] = iposav;
      irng = iposav - gpos[icnum1[3998] - 1] + 50;
      ixs = -iposav;
      repos_(&ngrp, &ibest, &irng, &c__2);
      icyc = 0;
      for (iq = nfix + 1; iq <= ngrp; ++iq)
	{
	  if (min(gpos[iq - 1] + glen[iq - 1],
		  gpos[ngrp - 1] + glen[ngrp - 1]) + 10 >=
	      max(gpos[iq - 1],gpos[ngrp - 1]))
	    {
	      repos_(&iq, &ibest, &c__3, &c__1);
	    }
	}
      assgrp_(&ncomp, icnum1, &iposav, &icrt);
    }
  ngrp = itgrp;
  for (irng = 30; irng >= 10; irng += -10)
    {
      for (iq = nfix + 1; iq <= ngrp; ++iq)
	{
	  repos_(&iq, &ibest, &irng, &c__1);
	}
    }
/* add back virtuals */
  if (bur)
    {
      for (iq = 1; iq <= ivir; ++iq)
	{
	  ix = vclst[iq - 1];
	  ++ngrp;
	  gclst[ngrp - 1] = ix;
	  glen[ngrp - 1] = ilena[ix - 1];
	  gpos[ngrp - 1] = iposa[ix - 1];
	}
    }
L16:
  assgrp_(&ncomp, icnum1, &iposav, &icrt);
L17:
  clearvt640_();
  plotgrp_(ixs, iys, iscale, ncomp, icnum1, FALSE, bur);
L301:
  gprintf (stdout, "  command (H gets help) = ") ;
  readinput ("", name, 8) ;
  if (strcasecmp(name, "h") == 0)
    {
      gprintf (stdout, "\n"
	       " highlighted clones are canonical\n"
	       "   INV  invert\n"
	       "    SC  scroll view\n"
	       "    CS  change scale\n"
	       "    PR  print whole display\n"
	       "    NC  get new group\n"
	       "     *  quit contass\n") ;
      goto L301;
    }
  else if (strcasecmp(name, "inv") == 0)
    {
      for (ix = 1; ix <= ncomp; ++ix)
	{
	  iy = icnum1[ix - 1];
	  gpos[iy - 1] = iposav - gpos[iy - 1] - glen[iy - 1] + iposav;
	}
      goto L16;
    }
  else if (strcasecmp(name, "sc") == 0)
    {
      gprintf (stdout, "   scroll (in band units) = ") ;
      readinput ("", stemp, 5) ; ishift = a2int (stemp) ;
      ixs -= ishift;		/* shift changed to scroll */
      goto L17;
    }
  else if (strcasecmp(name, "cs") == 0)
    {
      scale_(&iscale);
      goto L17;
    }
  else if (strcasecmp(name, "nc") == 0)
    {
      goto L15;
    }
  else if (strcasecmp(name, "pr") == 0)
    {
      int dim ;

      ixst = -gpos[icnum1[3998] - 1] - 400 / iscale ;
      ixrt = gpos[icnum1[ncomp - 1] - 1] + glen[icnum1[ncomp - 1] - 1] ;
      clearvt640_() ;
      dim = plotgrp_(ixst, 150, iscale, ncomp, icnum1, TRUE, bur) ;
      graphBoundsPrint ((float)MAPX(dim), winHeight, 0) ;
      goto L17 ;
    }
  else if (strcmp(name, "*") == 0)
    {
      return 0;
    }
  else
    {
      goto L301;
    }
  goto L15;
} /* cntss_ */

