/*  File: contaslib.c
 *  Author: Friedemann "F" Wobus (fw@sanger.ac.uk)
 *  Copyright (C) John Sulston and Friedemann Wobus, 1994
 *-------------------------------------------------------------------
 * This file is part of the ContigC physical mapping database package,
 * 	written by John Sulston (jes@sanger.ac.uk)
 *	ported to UNIX-C by Friedemann Wobus (fw@sanger.ac.uk)
 *
 * Description:
 * SCCS: $Id: contaslib.c,v 1.1 2001/02/14 12:44:36 edgrif Exp $
 * HISTORY:
 * Last edited: Jun 28 14:28 1994 (fw)
 * Created: Wed May 25 12:09:10 1994 (fw)
 *-------------------------------------------------------------------
 */

#include "co9.h"
/*****************************************************************/

extern FILE *unit_11 ;			/* .rem */

/* Common Block Declarations */

/* csec CB */
extern short int coorda[500000];

/* cint CB */
extern long int nbanda[30000], lbanda[30000], igela[30000], iconta[30000],
         iposa[30000], ilena[30000], icana[30000], irema[30000];

/* chars CB */
extern char namea[240000], chrom[65];

/* matdat CB */
extern long int itolmn, itoldf;
extern float logfact[201];

/* chr1 CB */
extern float xzero1, scale1;
extern long int ichrgp, maxlev1, levgap1;
extern short int genlev1[6000]	/* was [6][1000] */;

/* cass CB */
extern long int gpos[400], glen[400], gclst[400], ngrp;
extern short int gmat[160000]	/* was [400][400] */;

#ifndef NO_GRAPHICS
int plotgrp_(long int ixs, long int iys, long int iscale, 
	     long int ncomp, long int *icnuma, BOOL PRINT, BOOL bur)
{
  /* System generated locals */
  static char equiv_0[11], equiv_1[6] , equiv_2[9], equiv_3[41] ;
#define tname3 (equiv_0)
#define tname3b (equiv_0)
#define chplt (equiv_1)
#define chpltb (equiv_1)
#define pgen (equiv_2)
#define pgenc (equiv_2)
#define prem (equiv_3)
#define premc (equiv_3)

  /* Local variables */
  static long int ilen;
  static long int ncyc;
  static long int iptd;
  static long int nlev, ipxf;
  static long int ipos, ipxt, itxr;
  static long int ichar;
  static long int ixmin, ixmax;
  static long int iq, iv, ix, icspac, iy;
  static long int levgap;
  static long int nchars, remlev[10];
  static long int iremsp, itlstg;
  static long int ias, lev ;
  static BOOL vir, bmpg;
  static long int ipy, itx, ity, ilg, itxg, itemp, ncharg ;
  static short int hchrom, chromNo;
  int ret_val = 0 ;
/*
  static float emphsp;
  static long int ilft, ncharr, irt, ilr, 
*/
  /* Parameter adjustments */
  --icnuma;
  
  /* Function Body */
  if (ncomp == 0)
    {
      return 0;
    }

  ixmin = 10;
  ixmax = 1022;
  ichar = 9 ;

  strtcpy (chplt, "     ", 5) ;
  itlstg = -1000000;
  icspac = 30;
  nlev = 16;
  iptd = 8;			/* line to text space */
  ncyc = 2;			/* no of different line levels */
  for (lev = 1; lev <= 10; ++lev)
    {
      remlev[lev - 1] = itlstg;
    }
  levgap = 20;
  iremsp = 10;
  for (ix = 1; ix <= ncomp; ++ix)
    {
      iy = icnuma[ix];
      if (iflag_(gclst[iy - 1], 4) == 1)
	{
	  vir = TRUE;
	}
      else
	{
	  vir = FALSE;
	}
      strtcpy (tname3, namea + ((gclst[iy - 1] - 1) << 3), 8) ;
      ias = strlength (tname3b, 8) ;
      ipos = gpos[iy - 1];
      ilen = glen[iy - 1];
      if (vir)
	{
	  for (iq = ias; iq >= 1; --iq)
	    {
	      tname3b[iq] = tname3b[iq - 1];
	    }
	  tname3b[0] = '(';
	  tname3b[ias + 1] = ')';
	  tname3b[ias + 2] = 0;
	}
      itx = (ixs + ipos + ilen / 2) * iscale + 500 - ias / 2 * ichar;
      itxr = itx;

/* clone has remark */
      if (irema[gclst[iy - 1] - 1] > 0)
	{
	  seek_11 (irema[gclst[iy - 1] - 1]) ;
	  fread (&itemp, sizeof(long int), 1, unit_11);
	  fread (pgen, sizeof(char), 8, unit_11) ;
	  fread (prem, sizeof(char), 40, unit_11) ;
	  fread (&hchrom, sizeof(short int), 1, unit_11);
	  if (hchrom != 0)
	    {
	      strtcpy (chplt, chrom + hchrom * 5, 5);
	      chromNo = hchrom ;
	    }
	  ity = iys - 30;
/* get length of gene */
	  ilg = strlength (pgen, 8) ;
	  if (ilg == 0)
	    {
	      goto L36;
	    }
/* bump gene to right if necessary */
	  if (itlstg > itx)
	    {
	      itxg = itlstg;
	      bmpg = TRUE;
	    }
	  else
	    {
	      itxg = itx;
	      bmpg = FALSE;
	    }
/* clip gene */
	  itlstg = itxg + (ilg + 1) * ichar;

	  if (PRINT)
	    ncharg = 8 ;
	  else
	    {
	      ncharg = max(0,min(8,(ixmax - itxg) / ichar));
	    }
	  if (itxg < ixmin)
	    {
	      ncharg = max(0,8 - (ixmin - itxg) / ichar - 1);
	      itxg += (8 - ncharg) * ichar;
	      for (iv = 1; iv <= ncharg; ++iv)
		{
		  pgen[iv - 1] = pgen[iv + 8 - ncharg - 1];
		}
	    }

/* plot gene, indicate bump with comma */
	  if (bmpg && (itxg - ichar > ixmin))
	    {
	      movevt640_(itxg - ichar, ity);
	      textvt640_(",", 1);
	    }

	  movevt640_(itxg, ity);
	  if (ncharg > 0)
	    textvt640_(pgen, ncharg);
	}	
L36:
      ipy = iys + icspac * ((ix - 1) % nlev) +
	icspac / ncyc * ((ix - 1) / nlev % ncyc);

      if (vir)
	{
	  ipy += 4;
	}
      ity = ipy + iptd;
      ipxf = (ixs + ipos) * iscale + 500;
      ipxt = ipxf + ilen * iscale;
      if (!PRINT && ipxf > ixmax)
	{
	  goto L35;
	}
      if (ipxt < ixmin)
	{
	  goto L32;
	}
      if (ipxf < ixmin)
	{
	  ipxf = ixmin;
	}
      if (!PRINT && ipxt > ixmax)
	{
	  ipxt = ixmax;
	}

      if (PRINT)
	nchars = 10 ;
      else
	nchars = max(0,min(10,(ixmax - itx) / ichar));

      if (itx < ixmin)
	{
	  nchars = max(0,10 - (ixmin - itx) / ichar - 1);
	  itx += (10 - nchars) * ichar;
	  for (iv = 1; iv <= nchars; ++iv)
	    {
	      tname3b[iv - 1] = tname3b[iv + 10 - nchars - 1];
	    }
	  for (iv = nchars + 1; iv <= 10; ++iv)
	    {
	      tname3b[iv - 1] = 0; /* was  = ' ' before */
	    }
	}

      movevt640_(ipxf, ipy);
      drawvt640_(ipxt, ipy); if (ipxt > ret_val) ret_val = ipxt ;
      if (abs(icana[gclst[iy - 1] - 1]) <= 1)
	{
	  if (iflag_(gclst[iy - 1], 1) == 0)
	    {
	      colorvt640_(RED) ;
	      movevt640_(ipxf, ipy - 2);
	      rectvt640_(ipxt, 2) ;
	      colorvt640_(BLACK) ;
	    }
	}
      movevt640_(itx, ity);
      textvt640_(tname3b, nchars);

    L32:
      ;
    }
 L35:
  if (PRINT)
    {
      plotBigChromNum(chromNo, 30,
		      iys + (icspac << 4) + icspac + 10);

      movevt100_(0, 0) ;
      colorvt640_(BLACK+100) ; gprintf (stdout, " WARNING ");
      colorvt640_(BLACK) ;
      if (bur)
	gprintf (stdout, " : buried clones placed by computer\n\n") ;
      else
	gprintf (stdout, " : all clones placed by computer\n\n") ;
    }
  else
    {
      movevt640_(10, iys + (icspac << 4) + icspac);
      textvt640_(chplt, 5);
    }

  return ret_val;
} /* plotgrp_ */

#undef tname3b
#undef tname3
#undef chpltb
#undef chplt
#undef prem
#undef premc
#undef pgen
#undef pgenc


/*   score -1 for match undrawn or nonmatch drawn, */
/*   +1 for match drawn */
int score_(long int *iscore)
{
  /* Local variables */
  static long int icln, imat, ivlp, ipos1, ipos2, ipos3, ipos4, iq;
  
  *iscore = 0;
  for (icln = 1; icln <= ngrp - 1; ++icln)
    {
      for (iq = icln + 1; iq <= ngrp; ++iq)
	{
	  imat = gmat[iq + icln * 400 - 401];
	  ipos1 = gpos[iq - 1];
	  ipos2 = gpos[icln - 1];
	  ipos3 = ipos1 + glen[iq - 1];
	  ipos4 = ipos2 + glen[icln - 1];
	  ivlp = max(0, min(ipos3,ipos4) - max(ipos1,ipos2));
	  *iscore = *iscore + min(imat,ivlp) * min(imat,ivlp) -
	    abs(imat - ivlp) * abs(imat - ivlp);
	}
    }
  return 0;
} /* score_ */

/*   gets clones in existing order */
int getcont1_(long int *ncln, long int *clst, long int *nclone, 
	      long int *iconta)
{
  /* Local variables */
  static char name[9];
  static long int icrt, i, icont, ncomp, ifrom, iq,
                  icnuma[4000], iposav, ito;

  /* Parameter adjustments */
  --iconta;
  --clst;

  gprintf (stdout, "  enter contig number = ");
  readinput ("", stemp, 10) ;
  icont = a2int (stemp) ;
  asscont3_(nclone, &icont, &ncomp, icnuma, &iposav, &icrt);
  gprintf (stdout, "  enter first clone to consider = ");
  readinput ("", name, 8) ;
  if (strlength(name, 8) == 0)
    {
      ifrom = 1;
      goto L17;
    }
  getline_(name, &i, nclone);
  for (ifrom = 1; ifrom <= ncomp; ++ifrom)
    {
      if (icnuma[ifrom - 1] == i)
	{
	  goto L17;
	}
    }
L17:
  gprintf (stdout, "  enter last clone to consider = ");
  readinput ("", name, 8) ;
  if (strlength(name, 8) == 0)
    {
      ito = ncomp;
      goto L19;
    }
  getline_(name, &i, nclone);
  for (ito = 1; ito <= ncomp; ++ito)
    {
      if (icnuma[ito - 1] == i)
	{
	  goto L19;
	}
    }
L19:
  for (iq = ifrom; iq <= ito; ++iq)
    {
      ++(*ncln);
      clst[*ncln] = icnuma[iq - 1];
    }
    return 0;
} /* getcont1_ */

/* picks up zone for CONTASS assembly; avoids use of ASSCONT3 */
/* to keep numbers down */
int getzone_(long int *ixc, long int *ncln, long int *clst, 
	     long int *nclone, long int *icont,
	     long int *irng, long int *ipgrp)
{
  /* Local variables */
  static BOOL more;
  static long int ncst, ipos, ncomp, iposl, iposr;
  static long int icnuma[4000], iposlf, iposav, iposrf, icc, icl, icr;

  /* Parameter adjustments */
  --clst;
  
  /* Function Body */
  ncst = *ncln;
  asscont4_(nclone, icont, &ncomp, icnuma, &iposav);
  for (icc = 1; icc <= ncomp; ++icc)
    {
      if (icnuma[icc - 1] == *ixc)
	{
	  goto L101;
	}
    }
  exit (1) ;
L101:
  getcpb_(ixc, ncln, &clst[1], nclone, icont);
  ipos = iposa[*ixc - 1] + ilena[*ixc - 1] / 2;
  iposl = ipos;
  iposr = ipos;
  iposlf = ipos - *irng / 2;
  iposrf = ipos + *irng / 2;
  icl = icc;
  icr = icc;
  more = TRUE;
  while(more && *ncln < *ipgrp)
    {
      more = FALSE;
      if (icl > 1 && iposl > iposlf)
	{
	  --icl;
	  getcpb_(&icnuma[icl - 1], ncln, &clst[1], nclone, icont);
	  iposl = iposa[icnuma[icl - 1] - 1] +
	    ilena[icnuma[icl - 1] - 1] / 2;
	  more = TRUE;
	}
      if (icr < ncomp && iposr < iposrf)
	{
	  ++icr;
	  getcpb_(&icnuma[icr - 1], ncln, &clst[1], nclone, icont);
	  iposr = iposa[icnuma[icr - 1] - 1] + 
	    ilena[icnuma[icr - 1] - 1] / 2;
	  more = TRUE;
	}
    }
  gprintf (stdout, " %d clones added\n", *ncln - ncst);
  return 0;
} /* getzone_ */

/* gets clone plus burieds */
int getcpb_(long int *ix, long int *ncln, long int *clst, 
	    long int *nclone, long int *icont)
{
  /* Local variables */
  static long int icc;
  
  /* Parameter adjustments */
  --clst;
  
  /* Function Body */
  ++(*ncln);
  clst[*ncln] = *ix;
  if (icana[*ix - 1] == -1)
    {
      for (icc = 2; icc <= *nclone + 1; ++icc)
	{
	  if (iconta[icc - 1] == *icont)
	    {
	      if (abs(icana[icc - 1]) % 10000000 == *ix)
		{
		  ++(*ncln);
		  clst[*ncln] = icc;
		}
	    }
	}
    }
  return 0;
} /* getcpb_ */

#endif /* ! NO_GRAPHICS */
/* all the functions used by the non-graphical contrasp follow : */

/* to get log of first binomial term in probability expression */
int firsterm_(float *fbtl, float *psl, long int *nb1, long int *nb2,
	      float *logfact, long int *imatch)
{
  /* Local variables */
  static float c;
  static long int nbandh;
  static float pl;
  static long int nbandl;
  
  if (*nb1 > *nb2)
    {
      nbandh = *nb1;
      nbandl = *nb2;
    }
  else
    {
      nbandh = *nb2;
      nbandl = *nb1;
    }
  pl = *psl * nbandh;
  c = logfact[nbandl] - logfact[nbandl - *imatch] - logfact[*imatch];
  *fbtl = c + *imatch * log(1 - exp(pl)) + (nbandl - *imatch) * pl;
  return 0;
} /* firsterm_ */

/* estimates expected no of coincidental matches */
long int ibg_(long int *n1, long int *n2, long int *imatch, long int *itol)
{
  /* System generated locals */
  long int ret_val ;
  
  /* Local variables */
  static float p, gelen;
  static long int iexpm, nh, nl, iq, itempm, nhw, nlw;
  
  gelen = 3300.f;
  nl = min(*n1,*n2);
  nh = max(*n1,*n2);
  p = (float) (*itol << 1) / gelen;
  itempm = *imatch;
  for (iq = 1; iq <= 2; ++iq)
    {
      nlw = max(0,nl - itempm);
      nhw = max(0,nh - itempm);
      iexpm = (long int) ((float) (nlw * nhw) * p *
			  (1 - (float) nlw * p / 2.f));
      itempm -= iexpm;
    }
  ret_val = iexpm;
  return ret_val;
} /* ibg_ */

int enter_(long int *icl, long int *ihi, long int *cstk, BOOL *unat)
{
  /* Parameter adjustments */
  --unat;
  --cstk;
  
  /* Function Body */
  if (*icl == 0)
    {
      return 0;
    }
  if (unat[*icl])
    {
      ++(*ihi);
      cstk[*ihi] = *icl;
      unat[*icl] = FALSE;
    }
  return 0;
} /* enter_ */

/* gets unattached clone that has most matches to an attached clone */
int findnew_(long int *ihi, long int *cstk, BOOL *unat, 
	     long int *itgrp, short int *tmat)
{
  /* Local variables */
  static long int inew, maxm, iout, itemp, iq, iin;
  
  /* Parameter adjustments */
  tmat -= 401;
  --unat;
  --cstk;
  
  /* Function Body */
  inew = 0;
  maxm = 0;
  for (iq = 1; iq <= *ihi; ++iq)
    {
      iin = cstk[iq];
      for (iout = 1; iout <= *itgrp; ++iout)
	{
	  if (unat[iout])
	    {
	      itemp = tmat[iin + iout * 400];
	      if (itemp > maxm)
		{
		  inew = iout;
		  maxm = itemp;
		}
	    }
	}
    }
  if (inew == 0)
    {
      return 0;
    }
  ++(*ihi);
  cstk[*ihi] = inew;
  unat[inew] = FALSE;
  return 0;
} /* findnew_ */

/*   assembles group, finds true right end clone */
int assgrp_(long int *ncomp, long int *icnuma,
	    long int *iposav, long int *icrt)
{
  /* Local variables */
  static long int ilen, ilft, ipos, iclft, ictra[4000], iy, irt;

  /* Parameter adjustments */
  --icnuma;
  
  /* Function Body */
/*   initialise end hunts */
  irt = -1000000;
  ilft = 1000000;
  *ncomp = 0;
/*   loop for each clone */
  for (iy = 1; iy <= ngrp; ++iy)
    {
      ipos = gpos[iy - 1];
      ilen = glen[iy - 1];
      if (ipos < ilft)
	{
	  iclft = iy;
	  ilft = ipos;
	}
/*   compute right end */
      if (ipos + ilen > irt)
	{
	  *icrt = iy;
	  irt = ipos + ilen;
	}
      if (*ncomp >= 3998)
	{
	  gprintf (stdout, "  ICNUMA array overflow\n") ;
	  exit (-1) ;
	}
      ++(*ncomp);
      icnuma[*ncomp] = iy;
      ictra[*ncomp - 1] = ipos + ilen / 2;
    }
  if (*ncomp == 0)
    {
      return 0;
    }
  srtctr_(ncomp, ictra, &icnuma[1]);
  *iposav = (gpos[iclft - 1] + gpos[*icrt - 1] + glen[*icrt - 1]) / 2;
  icnuma[4000] = *icrt;
  icnuma[3999] = iclft;
  return 0;
} /* assgrp_ */

int repos_(long int *icln, long int *ibest, long int *irng, long int *istep)
{
  /* Local variables */
  static long int isav, itsc, ibest1;
  static long int iq, ishift;
  
  ishift = 0;
  isav = gpos[*icln - 1];
  ibest1 = -1000000;
  for (iq = -(*irng); *istep < 0 ? iq >= *irng : iq <= *irng; iq += *istep)
    {
      gpos[*icln - 1] = isav + iq;
      score1_(&itsc, icln);
      if (itsc > ibest1)
	{
	  ibest1 = itsc;
	  ishift = iq;
	}
    }
  gpos[*icln - 1] = isav + ishift;
  return 0;
} /* repos_ */

/*   score -1 for match undrawn or nonmatch drawn, */
/*   +1 for match drawn */
/*   for 1 clone only */
int score1_(long int *iscore, long int *icln)
{
  /* Local variables */
  static long int imat, ivlp, ipos1, ipos2, ipos3, ipos4, iq;
  
  *iscore = 0;
  ipos2 = gpos[*icln - 1];
  ipos4 = ipos2 + glen[*icln - 1];
  for (iq = 1; iq <= *icln - 1; ++iq)
    {
      imat = gmat[iq + *icln * 400 - 401];
      ipos1 = gpos[iq - 1];
      ipos3 = ipos1 + glen[iq - 1];
      ivlp = max(0,min(ipos3,ipos4) - max(ipos1,ipos2));
      *iscore = *iscore + min(imat,ivlp) * min(imat,ivlp) -
	abs(imat - ivlp) * abs(imat - ivlp);
    }
  for (iq = *icln + 1; iq <= ngrp; ++iq)
    {
      imat = gmat[iq + *icln * 400 - 401];
      ipos1 = gpos[iq - 1];
      ipos3 = ipos1 + glen[iq - 1];
      ivlp = max(0,min(ipos3,ipos4) - max(ipos1,ipos2));
      *iscore = *iscore + min(imat,ivlp) * min(imat,ivlp) -
	abs(imat - ivlp) * abs(imat - ivlp);
    }
    return 0;
} /* score1_ */

