/*  Last edited: Nov 24 11:41 1999 (fw) */
#include "co9.h"

/*****************************************************************/

extern FILE *unit_1 ;		/* .nam */
extern FILE *unit_2 ;		/* .cor */
extern FILE *unit_4 ;		/* .cnt */
extern FILE *unit_11 ;		/* .rem */
extern FILE *unit_13 ;		/* .flg */

/* Common Block Declarations */
/* cint CB */
long int nbanda[30000], lbanda[30000], igela[30000], iconta[30000],
         iposa[30000], ilena[30000], icana[30000], irema[30000];

/* chars CB */
char namea[240000];

void main (int argc, char** argv)
{
  /* Local variables */
  char projectbase[128], filnam[128];
  long int nbands, nclone, ix;

  printf ("\n  Contig_dumpace\n"
	  "   dump ContigC database in .ace-file format\n\n") ;


  if (argc != 3)
    {
      printf ("Usage: contig_dumpace <project> <ace-file>\n");
      exit (1);
    }

  strcpy (projectbase, argv[1]);
  strcpy (filnam, argv[2]);

  if (!(unit_1 = FILopen (projectbase, "nam", "r"))) exit (-1) ;
  if (!(unit_2 = FILopen (projectbase, "cor", "r"))) exit (-1) ;

  if (!(unit_4 = FILopen (projectbase, "cnt", "r"))) exit (-1) ;
  if (!(unit_11 = FILopen (projectbase, "rem", "r"))) exit (-1) ;

  if (!(unit_13 = FILopen (projectbase, "flg", "r"))) exit (-1) ;
  seek_1 (1) ;
  fread (&nclone, sizeof(long int), 1, unit_1);
  fread (&nbands, sizeof(long int), 1, unit_1);

  gprintf (stdout, "%8ld clones    %8ld bands\n", nclone, nbands) ;

  /* read database */
  gprintf (stdout, "reading database ...");
  {
    char name_nam[128], name_cnt[128];
    int unit_nam, unit_cnt ;
    unsigned long_len = sizeof(long int), char_len = 8 * sizeof(char) ;
    sprintf (name_nam, "%s.nam", projectbase);
    sprintf (name_cnt, "%s.cnt", projectbase);
    unit_nam = open(name_nam, O_RDONLY) ;
    unit_cnt = open(name_cnt, O_RDONLY) ;
    lseek (unit_nam, 8*sizeof(char)+4*sizeof(long int), SEEK_SET) ;
    lseek (unit_cnt, 4*sizeof(long int), SEEK_SET) ;
    for (ix = 1; ix < nclone + 1; ++ix)
      {
	read (unit_nam, namea + (ix << 3), char_len) ;
	read (unit_nam, &nbanda[ix], long_len) ;
	read (unit_nam, &lbanda[ix], long_len) ;
	read (unit_nam, &igela[ix],  long_len) ;
	read (unit_nam, &iconta[ix], long_len) ;

	read (unit_cnt, &iposa[ix],  long_len) ;
	read (unit_cnt, &ilena[ix],  long_len) ;
	read (unit_cnt, &icana[ix],  long_len) ;
	read (unit_cnt, &irema[ix],  long_len) ;
      }
    close (unit_nam) ; close (unit_cnt) ;
  }
  gprintf (stdout, "\n\nDumping .ace-file");

  dumpAce (projectbase, filnam, nclone, nbands);
  
  gprintf (stdout, "\n");

  fclose (unit_1) ;
  fclose (unit_2) ;
  fclose (unit_4) ;
  fclose (unit_13) ;
} /* main */
