/*  File: difmap.c
 *  Author: Friedemann "F" Wobus (fw@sanger.ac.uk)
 *  Copyright (C) John Sulston and Friedemann Wobus, 1994
 *-------------------------------------------------------------------
 * This file is part of the ContigC physical mapping database package,
 * 	written by John Sulston (jes@sanger.ac.uk)
 *	ported to UNIX-C by Friedemann Wobus (fw@sanger.ac.uk)
 *
 * Description:
 * SCCS: $Id: difmap.c,v 1.1 2001/02/14 12:44:37 edgrif Exp $
 * HISTORY:
 * Last edited: Jan 23 15:04 1995 (fw)
 * Created: Tue May 24 12:32:25 1994 (fw)
 *-------------------------------------------------------------------
 */

#include "co9.h"

/*****************************************************************/

extern FILE *unit_1 ;			/* .nam */
extern FILE *unit_3 ;			/* standard.dat */

/* Common Block Declarations */

extern long int nbanda[30000], lbanda[30000], igela[30000], iconta[30000],
       iposa[30000], ilena[30000], icana[30000], irema[30000];

extern char namea[240000], chrom[65];

extern short int coorda[BANDMAX];

/* Table of constant values */

#ifndef NO_GRAPHICS	/* needed for the graphical functions in here */
static long int c__100 = 100;
static long int c__20 = 20;
static long int c__50 = 50;
static long int c__380 = 380;
#endif

/*   program to search ends of contigs for matches */
#ifndef NO_GRAPHICS
int difmap_(long int *isch, long int *icurr,
	    long int *ixs, long int *iscale)
{
  /* System generated locals */
  long int i__1, i__2;
  float r__1;
	  
  /* Local variables */
  static long int ican;
  static char name[9], cname[9], names[9], ans[1];
  static long int ilen, ihnd, ilft;
  static float prob;
  static long int irnk, matt[100], iint, itol, nrnk, ipos;
  static long int i, j, k, idefd, m;
  static long int idefm;
  static long int iinta[100];
  static float bprob, rankp[100];
  static long int itemp;
  static float rankt[100];
  static long int isubm;
  static float probp;
  static long int toler;
  static long int nprnt, lband1, nband1, nband2, nband3, nband4;
  static long int coord2[200], coord3[200], coord4[200], coord6[200],
                  icnum1[4000], icnum2[4000], ncomp2, ncomp1;
  static long int im, nbandd;
  static long int iq, is, nbandm, ix;
  static float ps;
  static float bproba[100];
  static long int nbands, imatch, coordd[200], nclone, icontc;
  static long int coords[200], rktdir[100], iposav, srtdir[100];
  static float logfact[201];
  static long int irt;
  static BOOL owncnt;

/* number in probability rank */
  nrnk = 30;
    nprnt = 10;
/*   calc log factorials */
  owncnt = FALSE;
  logfact[0] = 0.f;
  logfact[1] = 0.f;
  for (i = 2; i <= 200; ++i)
    {
      logfact[i] = logfact[i - 1] + log((float) i);
    }
  seek_1 (1) ;
  fread (&nclone, sizeof(long int), 1, unit_1);
  fread (&nbands, sizeof(long int), 1, unit_1);
L1009:
  gprintf (stdout, "   select (H gets help) = ") ;
  readinput ("", stemp, 2) ; *ans = *stemp ;
  if (*ans == 'H' || *ans == 'h')
    {
      gprintf (stdout,
	       " H  for Help\n"
	       " M  for Manual band choice\n"
	       " S  for clone Subtraction\n"
	       " W  to match to own contig\n"
	       " P  to use Previous bands\n"
	       " R  for display of last Result\n\n") ;
      goto L1009;
    }
  else if (*ans == 'W' || *ans == 'w')
    {
      owncnt = TRUE;
      gprintf (stdout, " will match to own contig\n");
      goto L1009;
    }
  else if (*ans == 'M' || *ans == 'm'|| *ans == 'S' || *ans == 's')
    {
      goto L3;
    }
  else if (*ans == 'P' || *ans == 'p' || *ans == 'R' || *ans == 'r')
    {
      if (ix > 0 && nbandm > 0)
	{
	  strtcpy(cname, namea + ((ix - 1) << 3), 8);
	  icontc = iconta[ix - 1];
	  getbnds_(&ix, &nband1, coords);
	  ps = 1 - (float) (toler << 1) / 3300.f;
	}
      else
	{
	  gprintf (stdout, "data not available \n") ;
	  goto L1009;
	}
      if (*ans == 'R' || *ans == 'r')
	{
	  gprintf (stdout,
		   "%4d-%-8s(%3db,%4d)  selected              = %3dd\n",
		   igela[ix - 1], cname, nbanda[ix - 1],
		   iconta[ix - 1], nbandm) ;
	  goto L1025;
	}
      clearvt640_();
      selectvt640_();
      marker1_(&c__100, &c__20);
      pltbnds_(&nbandm, coord6, &c__50, &c__20);
      selectvt100_();
      clearvt100_();
      movevt100_(0, 0) ;
      gprintf (stdout,
	       "%4d-%-8s(%3db,%4d)  selected              = %3dd\n",
	      igela[ix - 1], cname, nbanda[ix - 1], iconta[ix - 1], nbandm);
      goto L1024;
    } 
  else
    {
      return 0;
    }
/*   get match clone */
L3:
  gprintf (stdout, "  clone to match = ") ;
  readinput ("", cname, 8) ;
  if (strlength(cname, 8) == 0)
    {
      return 0;
    }
  for (ix = 2; ix <= nclone + 1; ++ix)
    {
      if (strncmp(namea + ((ix - 1) << 3), cname, 8) == 0)
	{
	  goto L307;
	}
    }
  gprintf (stdout, "clone not found\n") ;
  goto L3;
/*   read in data for clone cname */
L307:
  icontc = iconta[ix - 1];
  lband1 = lbanda[ix - 1];
  nband1 = nbanda[ix - 1];
  if (nband1 == 0)
    {
      gprintf (stdout, "%s has no bands\n", cname) ;
      goto L3;
    }
  for (k = 1; k <= nband1; ++k)
    {
      coords[k - 1] = coorda[lband1 + k - 2];
    }
/*   plot current contig above */
  if (*ans == 'M' || *ans == 'm')
    {
      initvt640_();
      asscont_(&nclone, icurr, iconta, iposa, &ncomp2, icnum2,
	       &iposav, icana);
      plotcont3_(ixs, &c__380, iscale, &ncomp2, icnum2);
      bandselect_(&ix, &nbandm, coord6, isch);
      clearvt640_();
      marker1_(&c__100, &c__20);
      pltbnds_(&nbandm, coord6, &c__50, &c__20);
      selectvt100_();
      clearvt100_();
      movevt100_(0, 0) ;
      gprintf (stdout,
	       "%4d-%-8s(%3db,%4d)  selected              = %3dd\n",
	      igela[ix - 1], cname,
	      nbanda[ix - 1], iconta[ix - 1],
	      nbandm);
      goto L1024;
    }
L2:
  gprintf (stdout, "  subtract tolerance in tenths of mm = ") ;
  readinput ("", stemp, 5) ; if (nonint(stemp)) goto L2 ;
  itol = a2int (stemp) ;
  if (itol == 0)
    {
      return 0;
    }
  gprintf (stdout, "  clone to subtract = ") ;
  readinput ("", names, 8) ;
  if (strlength(names, 8) == 0)
    {
      is = 1;
      goto L309;
    }
  for (is = 2; is <= nclone + 1; ++is)
    {
      if (strncmp(namea + ((is - 1) << 3), names, 8) == 0)
	{
	  goto L309;
	}
    }
  gprintf (stdout, "clone not found\n") ;
  goto L307;
L309:
  clondif_(&ix, &is, &itol, &nbandm, coord6);
  gprintf (stdout, "%4d-%-8s(%3db,%4d)  minus  %4d-%-8s   =%6dd\n",
	  igela[ix - 1], cname, nbanda[ix - 1], iconta[ix - 1], 
	  igela[is - 1], names, nbandm);
/*   get match tolerance */
L1024:
  gprintf (stdout, "   match tolerance in tenths of mm = ") ;
  readinput ("", stemp, 5) ; if (nonint(stemp)) goto L1024 ;
  itemp = a2int (stemp) ;
  if (itemp <= 0)
    {
      goto L3;
    }
  else
    {
      toler = itemp;
    }
  ps = 1 - (float) (toler << 1) / 3300.f;
  for (iq = 1; iq <= 100; ++iq)
    {
      rankt[iq - 1] = 1.f;
    }
  itemp = icontc;
  if (owncnt)
    {
      itemp = -1;
    }

  patch5_(2, ix - 1, nbandm, coord6, toler, logfact,
	  rankt, rktdir, ps, nrnk, matt, itemp);
  patch5_(ix + 1, nclone + 1, nbandm, coord6, toler, logfact,
	  rankt, rktdir, ps, nrnk, matt, itemp);

  i__1 = nrnk ;			/* really needed */
  for (irnk = 1; irnk <= i__1; ++irnk)
    {
      im = rktdir[irnk - 1];
/*   protection needed for small databases */
      if (im == 0)
	{
	  nrnk = irnk - 1;
	  goto L28;
	}
      srtdir[irnk - 1] = irnk;
      if (iconta[im - 1] == 0)
	{
	  r__1 = dmax(1e-19f, rankt[irnk - 1]);
	  probp = r__1 * r__1;
	  bproba[irnk - 1] = 90.f;
	  iint = 0;
	  iinta[irnk - 1] = 0;
	  goto L26;
	}
      asscont_(&nclone, &iconta[im - 1], iconta, iposa,
	       &ncomp1, icnum1, &iposav, icana);
      ilft = iposa[icnum1[0] - 1];
      irt = iposa[icnum1[ncomp1 - 1] - 1] +
	ilena[icnum1[ncomp1 - 1] - 1];
      for (iq = ncomp1 - 1; iq >= max(1, ncomp1 - 10); --iq)
	{
	  irt = max(irt,
		    iposa[icnum1[iq - 1] - 1] + ilena[icnum1[iq - 1] - 1]);
	}
/*   find position of clone in contig */
      ican = abs(icana[im - 1]) % 10000000;
      if (ican > 1)
	{
	  ipos = iposa[ican - 1];
	  ilen = ilena[ican - 1];
	  strtcpy(name, namea + ((ican - 1) << 3), 8);
	}
      else
	{
	  ipos = iposa[im - 1];
	  ilen = ilena[im - 1];
	  if (icana[im - 1] == -1)
	    {
	      strcpy(name, "canon");
	    }
	  else
	    {
	      strcpy(name, "");
	    }
	}
      iint = min(ipos - ilft,irt - ipos - ilen);
      iinta[irnk - 1] = iint;
      if (irt - ilft == ilen)
	{
	  r__1 = dmax(1e-19f,rankt[irnk - 1]);
	  probp = r__1 * r__1;
	  bproba[irnk - 1] = 90.f;
	  goto L26;
	}
      else if (iint != 0)
	{
	  /* penalty for mid clone */
	  probp = pow_dd((double) dmax(1e-25f,rankt[irnk - 1]),(double)1.5);
	  bproba[irnk - 1] = 90.f;
	  goto L26;
	}
      if (ipos - ilft == 0)
	{
	  ihnd = 1;
	}
      if (irt - ipos - ilen == 0)
	{
	  ihnd = 2;
	}
/*   find best clone to subtract */
      bestsubtr_(&im, &ihnd, icnum1, &ncomp1, &isubm);
/*   subtract */
      clondif_(&im, &isubm, &toler, &nbandd, coordd);
/*   do reverse match */
      matchs_(ix, nbandd, coordd, toler, &imatch);

      probcoinc_(imatch,
		 min(nbandd,nbanda[ix - 1]),
		 max(nbandd,nbanda[ix - 1]), &bprob, toler, logfact);

/* bonus for end clone + dispersion */
      probp = dmax(1e-36f,rankt[irnk - 1] * bprob *
		   sqrt(dmin(rankt[irnk - 1],bprob) /
			dmax(rankt[irnk - 1],bprob)));
      bproba[irnk - 1] = bprob;
      getbnds_(&im, &nband2, coord2);
      overlap_(&toler, &nband1, coords, &nband2, coord2, &nband3, coord3);
      overlap_(&toler, &nbandm, coord6, &nband3, coord3, &nband4, coord4);
      idefm = min(nbandm,nband3) - nband4;
      overlap_(&toler, &nband2, coord2, &nband1, coords, &nband3, coord3);
      overlap_(&toler, &nbandd, coordd, &nband3, coord3, &nband4, coord4);
      idefd = min(nbandd,nband3) - nband4;
L26:
      rankp[irnk - 1] = probp;
    }

/*   sort results into order of increasing probability */
L28:
  m = nrnk;
L25:
  m = (m + 2) / 3;
  for (i = m + 1; i <= nrnk; ++i)
    {
      i__1 = m + 1;
      i__2 = -m;
      for (j = i; i__2 < 0 ? j >= i__1 : j <= i__1; j += i__2)
	{
	  if (rankp[srtdir[j - 1] - 1] >= rankp[srtdir[j - m - 1] - 1])
	    {
	      goto L6;
	    }
	  itemp = srtdir[j - 1];
	  srtdir[j - 1] = srtdir[j - m - 1];
	  srtdir[j - m - 1] = itemp;
	}
L6:
      ;
    }
  if (m != 1)
    {
      goto L25;
    }
L1025:
  for (iq = 1; iq <= nprnt; ++iq)
    {
      irnk = srtdir[iq - 1];
      j = rktdir[irnk - 1];
      iint = iinta[irnk - 1];
      if (j == 0)
	{
	  goto L1022;
	}
      ican = abs(icana[j - 1]) % 10000000;
      if (ican > 1)
	{
	  strtcpy(name, namea + ((ican - 1) << 3), 8);
	}
      else
	{
	  if (icana[j - 1] == -1)
	    {
	      strcpy(name, "canon");
	    }
	  else
	    {
	      strcpy(name, "");
	    }
	}
      if (iconta[j - 1] == icontc)
	{
	  *ans = 's';
	}
      else
	{
	  *ans = ' ';
	}
      matchs_(j, nband1, coords, toler, &imatch);
      probcoinc_(imatch, min(nband1,nbanda[j - 1]),
		 max(nband1,nbanda[j - 1]), &prob, toler, logfact);

      strtcpy (ntemp1, namea + ((j - 1) << 3), 8) ;
      strtcpy (ntemp2, name, 8) ;
      gprintf (stdout, "%3dm %4d-%-8s(%3db,%4d) E%2d%6d%6d%c %-8s"
	      "%4d%4d%4d\n",
	      imatch, igela[j - 1], 
	      ntemp1, nbanda[j - 1], iconta[j - 1],
	      -((long int) r_lg10(&prob)),
	      iint, matt[irnk - 1], *ans, ntemp2, 
	      -((long int) r_lg10(&rankt[irnk - 1])),
	      -((long int) r_lg10(&bproba[irnk - 1])),
	      -((long int) r_lg10(&rankp[irnk - 1]))) ;
L1022:
      ;
    }
  goto L1024;
} /* difmap_ */

/*   for manual selection of subset of bands from clone ix */
int bandselect_(long int *ix, long int *nbandx,
		long int *coordx, long int *isch)
{
  /* Local variables */
  static long int iycf, iych, ipnt, iyst;
  static char tname[9];
  static long int coord6[200], ia;
  static long int iq, nbandm, iy;
  static long int iyh;
  static BOOL notfnd;
  static BOOL keep[200];
  int key ;

  /* Parameter adjustments */
  --coordx;
  
  /* Function Body */
  iyst = 280;
  iyh = 20;
  marker1_(&iyst, &iyh);
  iyst -= iyh << 1;
  pltclone_(ix, &iyst, &iyh);
  iy = iyst - iyh;
  for (iq = 1; iq <= 10; ++iq)
    {
      clearvt100_();
      movevt100_(0, 0) ;
      gprintf (stdout, "   additional clone (def = not wanted) = ") ;
      readinput ("", tname, 8) ;
      if (strlength(tname, 9) == 0)
	{
	  goto L102;
	}
      getclone1_(tname, &ia, &notfnd);
      if (notfnd)
	{
	  goto L101;
	}
      iy -= iyh * 3 / 2;
      selectvt640_();
      pltclone_(&ia, &iy, &iyh);
      selectvt100_();
L101:
      ;
    }
L102:
  getbnds_(ix, &nbandm, coord6);
  clearvt100_();
  gprintf (stdout,
	   "   <   cursor left\n"
	   "   >   cursor right\n"
	   "   N   reject band\n"
	   "   Y   accept band\n"
	   "   E   exit to difmap\n") ;
  movevt100_(0, 0) ;
  for (iq = 1; iq <= nbandm; ++iq)
    {
      keep[iq - 1] = TRUE;
    }
  iycf = iyst - iyh / 2 - 2;
  iych = iyh / 2;
  ipnt = 1;
  selectvt640_();
L103:
  pltbnd_(&coord6[ipnt - 1], &iycf, &iych, FALSE);
  selectvt100_();
L104:
  key = waitForKey (0) ;
  if (key == 0)
    {
      goto L104;
    }
  selectvt640_();
  if (key == 44 || key == 60 || key == LEFT_KEY) /* 44 = , */
    {
      pltbnd_(&coord6[ipnt - 1], &iycf, &iych, TRUE);
      ipnt = max(1,ipnt - 1);
      goto L103;
    }
  else if (key == 46 || key == 62 || key == RIGHT_KEY) /* 46 = . */
    {
      pltbnd_(&coord6[ipnt - 1], &iycf, &iych, TRUE);
      ipnt = min(nbandm,ipnt + 1);
      goto L103;
    }
  else if (key == 78 || key == 110)	/* 78 = N */
    {
      pltbnd_(&coord6[ipnt - 1], &iycf, &iych, TRUE);
      keep[ipnt - 1] = FALSE;
      pltbnd_(&coord6[ipnt - 1], &iyst, &iyh, TRUE);
      ipnt = min(nbandm,ipnt + 1);
      goto L103;
    }
  else if (key == 89 || key == 121)	/* 89 = Y */
    {
      pltbnd_(&coord6[ipnt - 1], &iycf, &iych, TRUE);
      keep[ipnt - 1] = TRUE;
      pltbnd_(&coord6[ipnt - 1], &iyst, &iyh, FALSE);
      ipnt = min(nbandm,ipnt + 1);
      goto L103;
    }
  else if (!(key == 69 || key == 101)) /* 69 = E */
    {
      goto L103;
    }
  *nbandx = 0;
  for (iq = 1; iq <= nbandm; ++iq)
    {
      if (keep[iq - 1])
	{
	  ++(*nbandx);
	  coordx[*nbandx] = coord6[iq - 1];
	}
    }
  return 0;
} /* bandselect_ */

int marker1_(long int *iyst, long int *iyh)
{
  /* Local variables */
  static long int codm[500], nbm=0; /* static needed */
  int itmp, stdk ;
  float ftmp, stdr ;
  
  if (nbm == 0)
    {
      if (!(unit_3 = FILopen ("standard", "dat", "r")))
	goto L21 ;
      /* skip header */
      fscanf (unit_3,"%d,%d,%f,%f,%f,%d,%d,%d,%f,%f,%d,%f\n",
	      &itmp, &itmp, &ftmp, &ftmp, &ftmp, &itmp,
	      &itmp, &itmp, &ftmp, &ftmp, &itmp, &ftmp) ;
      /* load standard-file */
      while (!feof(unit_3) && nbm < 500)
	{
	  fscanf (unit_3,"%d,%d,%d,%f,%d",
		  &stdk, &itmp, &itmp, &stdr,&itmp);
	  while (!feof(unit_3) && fgetc (unit_3) != '\n') ;
	  if (stdk == 0) continue ;
	  codm[nbm++] = (long int)(stdr*10.0) ;
	}
      --nbm;
      fclose (unit_3) ;
    }
  pltbnds_(&nbm, codm, iyst, iyh);
L21:
  return 0;
} /* marker1_ */

int pltclone_(long int *il, long int *iyst, long int *iyh)
{
  /* System generated locals */
  static char equiv_0[9];
#define tname (equiv_0)
#define tnameb ((char *)equiv_0)
  
  /* Local variables */
  static long int coord6[200], nbandm;
  
  strtcpy(tname, namea + ((*il - 1) << 3), 8);

  movevt640_(10, *iyst + 8);
  textvt640_(tnameb, 8);

  getbnds_(il, &nbandm, coord6);
  pltbnds_(&nbandm, coord6, iyst, iyh);
  return 0;
} /* pltclone_ */

#undef tnameb
#undef tname


int pltbnds_(long int *nbandm, long int *coord6, long int *iyst,
	     long int *iyh)
{
  /* Local variables */
  static long int iq;
  
  /* Parameter adjustments */
  --coord6;
  
  /* Function Body */
  for (iq = 1; iq <= *nbandm; ++iq)
    {
      pltbnd_(&coord6[iq], iyst, iyh, FALSE);
    }
  return 0;
} /* pltbnds_ */

int pltbnd_(long int *ib, long int *iyst, long int *iyh, BOOL delete_)
{
  static long int ix;
  static long int iyt;

  ix = *ib * 1003 / 3600 + 10;
  iyt = *iyst + *iyh;
  movevt640_(ix, *iyst);
  if (delete_)
    {
      colorvt640_(WHITE) ;
      drawvt640_(ix, iyt);
      colorvt640_(BLACK) ;
    }
  else
    {
      drawvt640_(ix, iyt);
    }
  return 0;
} /* pltbnd_ */
#endif /* ! NO_GRAPHICS */

int getclone1_(char *tname, long int *ic, BOOL *notfnd)
{
  /* Local variables */
  static long int nbands, nclone;
  
  seek_1 (1) ;
  fread (&nclone, sizeof(long int), 1, unit_1);
  fread (&nbands, sizeof(long int), 1, unit_1);
  *notfnd = FALSE;
  for (*ic = 2; *ic <= nclone + 1; ++(*ic))
    {
      if (strncmp(namea + ((*ic - 1) << 3), tname, 8) == 0)
	{
	  goto L101;
	}
    }
  gprintf (stdout, "clone not found\n");
  *notfnd = TRUE;
L101:
  return 0;
} /* getclone1_ */

/*   gives best nrnk matches for coords; rejects own contig; has */
/*   enlarged rank compared with patch4 */
int patch5_(long int ifromp, long int itop, long int nband1, 
	    long int *coords, long int toler, float *logfact,
	    float *rankt, long int *rktdir, float ps,
	    long int nrnk, long int *matt, long int icont)
{
  /* Local variables */
  static float prob;
  static long int irnk;
  static float c;
  static long int j, k;
  static float p;
  static long int ishuf;
  static long int lband2, nband2, nbandh, nbandl, imatch, coordt[200];
  static float fbt;
  
  /* Parameter adjustments */
    --matt;
    --rktdir;
    --rankt;
    --coords;

  /* Function Body */
  for (j = ifromp; j <= itop; ++j)
    {
      if (iconta[j - 1] == icont)
	{
	  goto L150;
	}
      nband2 = nbanda[j - 1];
      lband2 = lbanda[j - 1];
      if (nband2 == 0)
	{
	  goto L150;
	}

/*   read in data for clone j */
      nbandl = min(nband1,nband2);
      nbandh = max(nband1,nband2);
      for (k = 1; k <= nband2; ++k)
	{
	  coordt[k - 1] = coorda[lband2 + k - 2];
	}

/*   calculate first binomial term */
      getmatch_(nband1, &coords[1], nband2, coordt, toler, &imatch);
      p = pow_ri(ps, nbandh);
      c = logfact[nbandl] - logfact[nbandl - imatch] - logfact[imatch];
/*   worth keeping? */
      fbt = exp((dmax(-88.f,
		      c + imatch * log(1 - p) +
		      (nbandl - imatch) * log(p))));
      if (fbt > rankt[nrnk])
	{
	  goto L150;
	}
      probcoinc_(imatch, nbandl, nbandh, &prob, toler, logfact);
      for (irnk = 1; irnk <= nrnk; ++irnk)
	{
	  if (prob < rankt[irnk])
	    {
	      for (ishuf = nrnk; ishuf >= irnk; --ishuf)
		{
		  rankt[ishuf + 1] = rankt[ishuf];
		  rktdir[ishuf + 1] = rktdir[ishuf];
		  matt[ishuf + 1] = matt[ishuf];
		}
	      rankt[irnk] = prob;
	      rktdir[irnk] = j;
	      matt[irnk] = imatch;
	      goto L150;
	    }
	}
L150:
      ;
    }
  return 0;
} /* patch5_ */

/*   to find best clone to subtract from IC, assumed to lie at end */
/*   (defined by IHND: 1 for left, 2 for right) of contig */
int bestsubtr_(long int *ic, long int *ihnd, long int *icnuma, 
	       long int *ncomp, long int *isubtr)
{
  /* System generated locals */
  float r__1;
  
  /* Local variables */
  static long int ilen;
  static float cerr;
  static long int ipos, ivlp;
  static float pout, score;
  static long int iq, iy;
  static float tscore;
  
  /* Parameter adjustments */
  --icnuma;
  
  /* Function Body */
  *isubtr = 1;
  score = 1e5f;
  if (*ihnd < 0 || *ihnd > 2)
    {
      gprintf (stdout, " ihnd out of range \n") ;
      return 0;
    }
  if (*ihnd == 0)
    {
      pout = 0.f;
    }
  ilen = ilena[*ic - 1];
  if (ilen == 0)
    {
      strtcpy (ntemp1, namea + ((*ic - 1) << 3), 8) ;
      gprintf (stdout, " ilen 0 for %s\n", ntemp1) ;
      return 0;
    }
  ipos = iposa[*ic - 1];
  for (iq = 1; iq <= *ncomp; ++iq)
    {
      iy = icnuma[iq];
      if (iy == *ic || nbanda[iy - 1] <= 0)
	{
	  goto L23;
	}
      ivlp = max(0,min(ipos + ilen,iposa[iy - 1] + ilena[iy - 1]) -
		 max(ipos,iposa[iy - 1]));
      if (ivlp == 0)
	{
	  goto L23;
	}
/* Computing 2nd power */
      r__1 = .5f - (float) ivlp / (float) ilen;
      cerr = r__1 * r__1 * 16;
      if (*ihnd == 1)
	{
	  pout = (float) (iposa[iy - 1] + ilena[iy - 1] - ipos 
			  - ilen) / (float) ilen;
	}
      if (*ihnd == 2)
	{
	  pout = (float) (ipos - iposa[iy - 1]) / (float) ilen;
	}
      if (pout < 0.f)
	{
/* Computing 4th power */
	  r__1 = pout, r__1 *= r__1;
	  pout = r__1 * r__1 * 2000;
	}
      tscore = cerr + pout;
      if (tscore < score)
	{
	  *isubtr = iy;
	  score = tscore;
	}
L23:
      ;
    }
  return 0;
} /* bestsubtr_ */

/*   compare 1 with 2, output bands from 1 that match 2 in coord3(nband3) */
int overlap_(long int *itol, long int *nband1, long int *coord1,
	     long int *nband2, long int *coord2, long int *nband3,
	     long int *coord3)
{
  /* Local variables */
  static long int j, k, jband, nband5, coordt[200];
  
  /* Parameter adjustments */
  --coord3;
  --coord2;
  --coord1;
  
  /* Function Body */
  *nband3 = 0;
  nband5 = 0;
  for (j = 1; j <= *nband2; ++j)
    {
      coordt[j - 1] = coord2[j];
    }
  for (j = 1; j <= *nband1; ++j)
    {
      jband = coord1[j];
      for (k = 1; k <= *nband2; ++k)
	{
	  if (abs(jband - coordt[k - 1]) < *itol)
	    {
	      ++(*nband3);
	      coord3[*nband3] = jband;
	      coordt[k - 1] = 9999;
	      goto L31;
	    }
	}
L31:
      ;
    }
  return 0;
} /* overlap_ */
