/*  File: laben.c
 *  Author: Friedemann "F" Wobus (fw@sanger.ac.uk)
 *  Copyright (C) John Sulston and Friedemann Wobus, 1994
 *-------------------------------------------------------------------
 * This file is part of the ContigC physical mapping database package,
 * 	written by John Sulston (jes@sanger.ac.uk)
 *	ported to UNIX-C by Friedemann Wobus (fw@sanger.ac.uk)
 *
 * Description: various functions, partly hardware-like access
 * SCCS: $Id: laben.c,v 1.1 2001/02/14 12:44:38 edgrif Exp $
 * HISTORY:
 * Last edited: Oct 27 10:19 1994 (fw)
 * Created: Thu May 19 16:39:35 1994 (fw)
 *-------------------------------------------------------------------
 */

#include "co9.h"

/*****************************************************************/

extern FILE *unit_1 ;			/* .nam */
extern FILE *unit_4 ;			/* .cnt */
extern FILE *unit_10 ;			/* .stk */
extern FILE *unit_11 ;			/* .rem */
extern FILE *unit_13 ;			/* .flg */
extern FILE *unit_14 ;			/* here: scratch[1,2].dat */
extern FILE *unit_20 ;		        /* CLONE.LIS */
extern FILE *unit_21 ;			/* new*.nam */
extern FILE *unit_22 ;			/* new*.cor */
extern FILE *unit_23 ;			/* new*.cnt */
extern FILE *unit_29 ;			/* new*.flg */

extern float hChar ;

/* Common Block Declarations */

extern long int nbanda[30000], lbanda[30000], igela[30000], iconta[30000],
       iposa[30000], ilena[30000], icana[30000], irema[30000];

extern char namea[240000], chrom[65];

extern short int coorda[BANDMAX];

extern long int isch, icurs, ibtot, iwend;

/* Table of constant values */

static long int c__1 = 1;
static long int c__0 = 0;
static long int c__2 = 2;
static long int c_n1 = -1;

int checkcont1_(char *projectbase, long int *nclone)
{
  /* Initialized data */
  char hislab[30] = "UC 51015202530354045#";
  
  /* System generated locals */
  long int i__1, i__2, i__3;
  static char equiv_0[9];
#define tname (equiv_0)
#define tnameb (equiv_0)

  /* Local variables */
  static long int ican;
  static char gene[9], name[9], cname[9], kname[25], resp[11], ans[1];
  static long int ilna[100], igel, alft[4000], ilen, iflg, ians, irem;
  static float tnbh;
  static long int ilft;
  static float rnbh, pchr;
  static long int klen, itlp;
  static long int ctot[6], ipos, nbnd, isum, gout[2000];
  static long int itot;
  static long int icrt, ikey, iret, igpt;
  static long int lina1[30000], lina2[30000], ilft1;
  static long int i, lband;
  static short int hflag;
  static long int nband;
  static long int ictbd, ifctc;
  static long int itcan;
  static float fract;
  static long int icmax;
  static long int iqchr, iutbd, bhist[101], isrch, icont, ncomp, itemp, 
  ifrom, ncont;
  static float tsnbh;
  static long int nrcnt;
  static float rmluc, rsnbh, rmltc;
  static long int ktlen, itslp;
  static short int hsitu;
  static long int maxht, nicnt, inext, icpnt, ising, ictot, iytop;
  static float pcurr;
  static long int icnum1[4000], icnum2[4000], icpnt1, icpnt2, ncomp1,
  ncomp2,ia, ib, ic, il;
  static long int iq, ip, it, iw, ix, iy, iz;
  static long int iclone;
  static short int hchrom;
  static char remark[41];
  static long int isztbd, icontt, iposav, itempr;
  static long int iunatt, ithist;
  static long int chstrt[9], lunatt;
  static long int ilstrt;
  static long int icc;
  static float cpc;
  static long int inc;
  static long int iqc, cpn[1200]	/* was [200][6] */;
  static long int art[4000];
  static long int iqq, ito, irt;
  static float pcunatt;
  static long int irt1;
  static long int iacc;
  static BOOL red;
  static BOOL pur;
  static BOOL cnt;
  static BOOL sing;
  static BOOL logver;
  static BOOL test;
  static BOOL key;
  static BOOL cdir[1200];
  static FILE *iunit ;

  clearvt640_() ;
L99:
  gprintf (stdout, "\n Check menu\n"
	  "   1   read clone data\n"
	  "   2   list contigs\n"
	  "   3   count and check contigs and unattached clones\n"
	  "   4   overlap analysis\n"
	  "   5   list files\n"
	  "   6   overlap histogram\n"
	  "   7   type contigs\n"
	  "   8   list set of overlapping clones\n"
	  "   9   list selected clones\n"
	  "  10   list projecting posd clones\n"
	  "  11   Y....cy doubles search (?)\n"
	  "  12   search and list\n"
	  "  13   list unmapped contigs\n\n") ;
L100:
  gprintf (stdout, "  enter choice : ") ;
  readinput ("", stemp, 6) ; if (nonint(stemp)) goto L100 ;
  ians = a2int (stemp) ;
  if (ians == 0) return 0 ;
  switch (ians)
    {
    case 1:  goto L108;
    case 2:  goto L102;
    case 3:  goto L301;
    case 4:  goto L401;
    case 5:  goto L501;
    case 6:  goto L601;
    case 7:  goto L701;
    case 8:  goto L801;
    case 9:  goto L901;
    case 10:  goto L1111;
    case 11:  goto L1150;
    case 12:  goto L1250;
    case 13:  goto L1350;
    }
L108:
  gprintf (stdout, "  clone name = ") ;
  readinput ("", cname, 8) ;
  if (strlength(cname, 8) == 0)
    {
      goto L99;
    }
  for (ix = 2; ix <= *nclone + 1; ++ix)
    {
      if (strncmp(namea + ((ix - 1) << 3), cname, 8) == 0)
	{
	  goto L107;
	}
    }
  gprintf (stdout, "clone not found\n") ;
  goto L108;
L107:
  seek_1 (ix) ;
  fread (name, sizeof(char), 8, unit_1);
  fread (&nband, sizeof(long int), 1, unit_1);
  fread (&lband, sizeof(long int), 1, unit_1);
  fread (&igel, sizeof(long int), 1, unit_1);
  fread (&icont, sizeof(long int), 1, unit_1);

  gprintf (stdout, "  NAM:  %-8s%7d%7d%7d%7d\n", name, nband, lband, igel, icont);

  seek_4 (ix) ;
  fread (&ipos, sizeof(long int), 1, unit_4);
  fread (&ilen, sizeof(long int), 1, unit_4);
  fread (&ican, sizeof(long int), 1, unit_4);
  fread (&irem, sizeof(long int), 1, unit_4);

  gprintf (stdout, "  CAN:  %6d%6d%10d%6d\n",
	  ipos, ilen, ican, irem);

  seek_13 (ix) ;
  fread (&iflg, sizeof(long int), 1, unit_13);
  strtcpy(remark, "                                 ", 40);
  for (iq = 32; iq >= 2; iq += -2)
    {
      itemp = iflg % 2;
      if (itemp == 0)
	{
	  remark[iq - 1] = '0';
	}
      if (itemp == 1)
	{
	  remark[iq - 1] = '1';
	}
      iflg /= 2;
    }
  gprintf (stdout, "  FLAGS:  %s\n", remark) ;
  goto L99;
L102:
  gprintf (stdout, "  contig number = ") ;
  readinput ("", stemp, 10); if (nonint(stemp)) goto L102 ;
  icont = a2int (stemp) ;
  if (icont == 0)
    {
      goto L99;
    }
  ncomp = 0;
  for (ix = 2; ix <= *nclone + 1; ++ix)
    {
      if (iconta[ix - 1] == icont)
	{
	  strtcpy (ntemp1, namea + ((ix - 1) << 3), 8) ;
	  gprintf (stdout, "%s\n", ntemp1);
	  ++ncomp;
	}
    }
  if (ncomp == 0)
    {
      gprintf (stdout, "no clones\n") ;
    }
  goto L102;
L301:
  seek_10 (1) ;
  fread (&ncont, sizeof(long int), 1, unit_10);
  gprintf (stdout, "first line of contstack =%12d\n", ncont);
  iunatt = 0;
  nrcnt = 0;
  for (iy = 1; iy <= ncont; ++iy)
    {
      ncomp = 0;
      for (ix = 2; ix <= *nclone + 1; ++ix)
	{
	  if (iconta[ix - 1] == iy)
	    {
	      if (iflag_(ix, 8) == 1)
		{
		  goto L303;
		}
	      ++ncomp;
	      if (ncomp > 1)
		{
		  ++nrcnt;
		  goto L303;
		}
	    }
	}
      if (ncomp == 1)
	{
	  ++iunatt;
	  gprintf (stdout, "contig no %d single clone\n", iy) ;
	}
L303:
      ;
    }
  for (ix = 2; ix <= *nclone + 1; ++ix)
    {
      if (iconta[ix - 1] == 0 && namea[(ix - 1) * 8] != '!')
	{
	  ++iunatt;
	}
    }
  gprintf (stdout, "%12d true contigs  %12d unattached clones\n", nrcnt, iunatt) ;
  goto L99;
L401:
  gprintf (stdout, "   first clone in set (* to return) = ") ;
  readinput ("", cname, 8) ;
  if (strcmp(cname, "*") == 0)
    {
      goto L99;
    }
  if (strlength(cname, 8) == 0)
    {
      ifrom = 2;
      goto L403;
    }
  for (ifrom = 2; ifrom <= *nclone + 1; ++ifrom)
    {
      if (strncmp(namea + ((ifrom - 1) << 3), cname, 8) == 0)
	{
	  goto L403;
	}
    }
  gprintf (stdout, "clone not found\n") ;
  goto L99;
L403:
  gprintf (stdout, "   last clone in set = ") ;
  readinput ("", cname, 8) ;
  if (strlength(cname, 8) == 0)
    {
      ito = *nclone + 1;
      goto L405;
    }
  for (ito = 2; ito <= *nclone + 1; ++ito)
    {
      if (strncmp(namea + ((ito - 1) << 3), cname, 8) == 0)
	{
	  goto L405;
	}
    }
  gprintf (stdout, "clone not found\n") ;
  goto L401;
L405:
  tnbh = 0.f;
  iunatt = 0;
  iclone = 0;
/* init ilen sum */
  isztbd = 0;
/* init contig nband sum */
  ictbd = 0;
/* init unatt nband sum */
  iutbd = 0;
  tsnbh = 0.f;

/* loop for each clone in set */
  for (ia = ifrom; ia <= ito; ++ia)
    {
/* omit cancellations */
      if (namea[(ia - 1) * 8] == '!')
	{
	  goto L406;
	}
      icont = iconta[ia - 1];
/* no ribosomal */
      if (icont == 1)
	{
	  goto L406;
	}
      ican = (i__2 = icana[ia - 1], abs(i__2)) % 10000000;
      if (ican > 1)
	{
	  ix = ican;
	}
      else
	{
	  ix = ia;
	}
      ilen = ilena[ix - 1];
/* prevent trouble later */
      if (ilen == 0)
	{
	  goto L406;
	}
      isztbd += ilen;
      if (icont == 0)
	{
	  ++iunatt;
	  iutbd += nbanda[ia - 1];
	  goto L406;
	}
      ictbd += nbanda[ia - 1];
      ilft = iposa[ix - 1];
      irt = ilft + ilen;
      itlp = 0;
      ++iclone;
      itslp = 0;
/* search for clones in same contig */
      for (ib = 2; ib <= *nclone + 1; ++ib)
	{
	  if (namea[(ib - 1) * 8] == '!')
	    {
	      goto L407;
	    }
	  if (iconta[ib - 1] != icont)
	    {
	      goto L407;
	    }
	  ican = (i__3 = icana[ib - 1], abs(i__3)) % 10000000;
	  if (ican > 1)
	    {
	      ix = ican;
	    }
	  else
	    {
	      ix = ib;
	    }
	  ilft1 = iposa[ix - 1];
	  irt1 = ilft1 + ilena[ix - 1];
	  inc = max(min(irt,irt1) - max(ilft,ilft1),0);
	  itlp += inc;
	  if (ib >= ifrom && ib <= ito)
	    {
	      itslp += inc;
	    }
L407:
	  ;
	}
/* NB exclude self */
      tnbh += (float) (itlp - ilen) / (float) ilen;
      tsnbh += (float) (itslp - ilen) / (float) ilen;
/*   count total clones in contigs */
L406:
      ;
    }
  itot = 0;
  for (ib = 2; ib <= *nclone + 1; ++ib)
    {
      if (namea[(ib - 1) * 8] == '!')
	{
	  goto L408;
	}
      if (iconta[ib - 1] == 0)
	{
	  goto L408;
	}
      ++itot;
L408:
      ;
    }
  if (iunatt > 0)
    {
      rmluc = (float) iutbd / (float) iunatt;
    } 
  else
    {
      rmluc = 0.f;
    }
  if (iclone > 0 && itot > 0)
    {
      rnbh = tnbh / (float) (iclone * itot);
      rsnbh = tsnbh / (float) (iclone * iclone);
    }
  else
    {
      rnbh = 0.f;
      rsnbh = 0.f;
    }
  if (iunatt + iclone == 0)
    {
      gprintf (stdout, " empty set \n") ;
      goto L401;
    }
  rmltc = (float) (ictbd + iutbd) / (float)(iunatt + iclone);
  pcunatt = (float) (iunatt * 100) / (float) (iunatt + iclone);
  gprintf (stdout, " clones analysed =%6d\n"
	  " mean clone length =%7.1f bands (corr)   %7.1f bands (raw)\n"
	  " clones in contigs =%6d\n"
	  " overlap index for all clones in contigs =%10.3f\n"
	  " overlap index for set =%10.3e\n"
	  " unattached clones =%6d  (%5.1f%%)\n"
	  " mean unattached clone length = %7.1f bands\n",
	  iunatt + iclone, 
	  (float) isztbd / (float) (iunatt + iclone),
	  rmltc, iclone, rnbh, rsnbh, iunatt,
	  pcunatt, rmluc);
  goto L401;
 L501:
  gprintf (stdout, "  file to list [REM/NAM(1),PSS(2),REJ(3),NAM(4)]  = ") ;
  readinput ("", stemp, 2) ; if (nonint(stemp)) goto L501 ;
  itemp = a2int (stemp) ;
  switch (itemp)
    {
    case 1:  goto L504;
    case 2:  goto L505;
    case 3:  goto L506;
    case 4:  goto L507;
    }
L505:
  rejpss_("tP", &c__0, &c__0, ilna, projectbase, nclone);
  goto L99;
L506:
  rejpss_("tR", &c__0, &c__0, ilna, projectbase, nclone);
  goto L99;
L507:
  gprintf (stdout, "  Do you really want to list the entire NAM file (Y/N) ? ") ;
  readinput ("", stemp, 2) ;
  *ans = *stemp ;
  if (*ans != 'y' && *ans != 'Y')
    {
      goto L501;
    }
  iunit = getfile_();
  for (iq = 2; iq <= *nclone + 1; ++iq)
    {
      seek_1 (iq) ;
      fread (name, sizeof(char), 8, unit_1);
      fread (&nband, sizeof(long int), 1, unit_1);
      fread (&lband, sizeof(long int), 1, unit_1);
      fread (&igel, sizeof(long int), 1, unit_1);
      fread (&icont, sizeof(long int), 1, unit_1);
      
      gprintf (iunit, "%4d-%-8s(%3db,%4d)\n",
	       igel, name, nband, icont);
    }
  if (iunit != stdout)
    fclose (iunit) ;
  goto L99;
L504:
  gprintf (stdout, "  list REM from line ") ;
  readinput ("", stemp, 5) ; if (nonint (stemp)) goto L504 ;
  ix = a2int (stemp) ;
  iz = max(ix - 1,0);
L502:
  ++iz;
  seek_11 (iz) ;
  fread (&il, sizeof(long int), 1, unit_11);
  fread (gene, sizeof(char), 8, unit_11);
  fread (remark, sizeof(char), 40, unit_11);
  fread (&hchrom, sizeof(short int), 1, unit_11);
  fread (&hflag, sizeof(short int), 1, unit_11);
  fread (&pchr, sizeof(float), 1, unit_11);
  fread (&hsitu, sizeof(short int), 1, unit_11);
  if (ferror(unit_11) || feof(unit_11)) goto L503 ;
  if (il == -9)
    {
      goto L503;
    }
  gprintf (stdout, "%6d%-8s%-40s%6d%6d%7.2f%6d\n",
	  il, gene, remark, hchrom, hflag, pchr, hsitu);
  goto L502;
L503:
  gprintf (stdout, "  NAM line to write = ") ;
  readinput ("", stemp, 2) ; if (nonint(stemp)) goto L503 ;
  ix = a2int (stemp) ;
  if (ix < 2)
    {
      goto L99;
    }
  if (ix > *nclone + 1)
    {
      ix = *nclone + 1;
    }
  seek_1 (ix) ;
  fread (name, sizeof(char), 8, unit_1);
  fread (&nband, sizeof(long int), 1, unit_1);
  fread (&lband, sizeof(long int), 1, unit_1);
  fread (&igel, sizeof(long int), 1, unit_1);
  fread (&icont, sizeof(long int), 1, unit_1);
  if (ferror(unit_1) || feof(unit_1)) goto L503 ;

  gprintf (stdout, "%5d  %-8s%7d%7d%7d%7d\n",
	  ix, name, nband, lband, igel, icont) ;
  goto L503;
L601:
  clearvt640_();

  icpnt1 = 0;
  icpnt2 = 0;
  logver = FALSE;
  gprintf (stdout, "\n"
	   " Type  V  for verification\n"
	  "first group:\n"
	  "  accumulate clones in sets or by initial character keywords;\n"
	  "  when complete,  type :\n"
	  "  W  for whole database,\n"
	  "  S  for self,\n"
	  "  N  for second group.\n") ;
L610:
  gprintf (stdout, "  first clone (* to return , I for initials) = ") ;
  readinput ("", cname, 8) ;
  if (strcmp(cname, "*") == 0)
    {
      goto L99;
    }
  else if (strcasecmp(cname, "v") == 0)
    {
      logver = TRUE;
      goto L610;
    }
  else if (strcasecmp(cname, "w") == 0)
    {
      icpnt2 = 0;
      i__1 = *nclone + 1;
      clonaccum_(&c__2, &i__1, lina2, &icpnt2);
      redset_(lina1, &icpnt1, &logver);
      goto L605;
    }
  else if (strcasecmp(cname, "n") == 0)
    {
      goto L612;
    } 
  else if (strcasecmp(cname, "s") == 0)
    {
      redset_(lina1, &icpnt1, &logver);
      for (iq = 1; iq <= icpnt1; ++iq)
	{
	  lina2[iq - 1] = lina1[iq - 1];
	}
      icpnt2 = icpnt1;
      goto L605;
    } 
  else if (strcasecmp(cname, "i") == 0)
    {
      keyw1_(kname, &ktlen, &klen);
      if (klen == 0 || ktlen == 0)
	{
	  goto L610;
	}
      getinit1_(&icpnt1, lina1, nclone, kname, &ktlen);
      goto L610;
    } 
  else
    {
      getset1_(&icpnt1, lina1, nclone, cname);
    }
  goto L610;
L612:
  redset_(lina1, &icpnt1, &logver);
  gprintf (stdout, "\n"
	   "second group:\n"
	   "  accumulate clones in sets or by initial character keywords;\n"
	   "  when complete,  type :\n"
	   "  H  to compute\n") ;
L613:
  gprintf (stdout, "  first clone (* to return , I for initials) = ") ;
  readinput ("", cname, 8) ;
  if (strcmp(cname, "*") == 0)
    {
      goto L99;
    } 
  else if (strcasecmp(cname, "h") == 0)
    {
      redset_(lina2, &icpnt2, &logver);
      goto L605;
    } 
  else if (strcasecmp(cname, "i") == 0)
    {
      keyw1_(kname, &ktlen, &klen);
      if (klen == 0 || ktlen == 0)
	{
	  goto L613;
	}
      getinit1_(&icpnt2, lina2, nclone, kname, &ktlen);
      goto L613;
    } 
  else 
    {
      getset1_(&icpnt2, lina2, nclone, cname);
    }
  goto L613;
L605:
  nbnd = 0;
  for (iq = 0; iq <= 100; ++iq)
    {
      bhist[iq] = 0;
    }
  tnbh = 0.f;
  iunatt = 0;
  iclone = 0;
/* init hist sum */
  ithist = 0;
/* init ilen sum */
  isztbd = 0;
/* init contig nband sum */
  ictbd = 0;
/* init unatt nband sum */
  iutbd = 0;
  tsnbh = 0.f;
/* loop for each clone in first group */
  for (iacc = 1; iacc <= icpnt1; ++iacc)
    {
      ia = lina1[iacc - 1];
      icont = iconta[ia - 1];
/* no ribosomal */
      if (icont == 1)
	{
	  goto L606;
	}
      ican = (i__2 = icana[ia - 1], abs(i__2)) % 10000000;
      if (ican > 1)
	{
	  ix = ican;
	} 
      else
	{
	  ix = ia;
	}
      ilen = ilena[ix - 1];
/* prevent trouble later */
      if (ilen == 0)
	{
	  goto L606;
	}
      isztbd += ilen;
      if (icont == 0)
	{
	  ++iunatt;
	  iutbd += nbanda[ia - 1];
	  bhist[0] += ilen;
	  ++ithist;
	  goto L606;
	}
      ictbd += nbanda[ia - 1];
      ilft = iposa[ix - 1];
      irt = ilft + ilen;
      itlp = 0;
      ++iclone;
      itslp = 0;
      ncomp = 0;
      for (iz = 1; iz <= icpnt2; ++iz)
	{
	  ib = lina2[iz - 1];
/* omit self */
	  if (ib == ia)
	    {
	      goto L607;
	    }
/* search for clones in same contig */
	  if (iconta[ib - 1] != icont)
	    {
	      goto L607;
	    }
	  ican = (i__3 = icana[ib - 1], abs(i__3)) % 10000000;
	  if (ican > 1)
	    {
	      ix = ican;
	    } 
	  else
	    {
	      ix = ib;
	    }
	  ++ncomp;
	  alft[ncomp - 1] = iposa[ix - 1];
	  art[ncomp - 1] = iposa[ix - 1] + ilena[ix - 1];
/*   sum no of appearances of each band in test clone */
L607:
	  ;
	}
      for (iy = ilft; iy <= irt; ++iy)
	{
	  isum = 0;
	  for (iw = 1; iw <= ncomp; ++iw)
	    {
	      if (iy >= alft[iw - 1] && iy <= art[iw - 1])
		{
		  ++isum;
		}
	    }
	  isum = min(isum,41);
	  ++bhist[isum + 1];
	  ++ithist;
	}
L606:
      ;
    }
  gprintf (stdout, "   clones analysed = %d\n", iclone + iunatt);
  maxht = 0;
  selectvt640_();
  iytop = bhist[0] * 2000 / ithist;
  if (iytop > 700)
    {
      iytop = 700;
      movevt640_(18, 760);
      textvt640_(hislab + 20, 1);
    }
  movevt640_(20, 50);
  drawvt640_(20, iytop + 50);
  movevt640_(15, 20);
  textvt640_(hislab, 1);
  for (iq = 1; iq <= 41; ++iq)
    {
      iytop = bhist[iq] * 2000 / ithist;
      if (iytop > 700)
	{
	  iytop = 700;
	  movevt640_(iq * 20 + 38, 760);
	  textvt640_(hislab + 20, 1);
	}
      movevt640_(iq * 20 + 40, 50);
      drawvt640_(iq * 20 + 40, iytop + 50);
    }
  movevt640_(900, 50);
  drawvt640_(900, bhist[42] * 2000 / ithist + 50);
  movevt640_(55, 20);
  textvt640_(hislab + 1, 1);
  movevt640_(145, 20);
  textvt640_(hislab + 2, 2);
  for (iq = 2; iq <= 8; ++iq)
    {
      movevt640_(iq * 100 + 50, 20);
      textvt640_(hislab + (iq << 1), 2);
    }

  waitForMore (SPACE_KEY) ;
  goto L601;

L701:
  gprintf (stdout, "   contig number (-1 for contig 0) = ") ;
  readinput ("", stemp, 10) ; if (nonint(stemp)) goto L701 ;
  icontt = a2int (stemp) ;
  if (icontt == 0)
    {
      goto L99;
    }
  iunit = getfile_() ;
  gprintf (stdout, "\n") ;
  tycont_(&icontt, iunit, nclone);
  if (iunit != stdout)
    fclose (iunit) ;
  goto L701;
L801:
  gprintf (stdout, "   minimum fraction of clone to overlap = ") ;
  readinput ("", stemp, 15) ; if (nonflt(stemp)) goto L801 ;
  fract = a2flt (stemp) ;
  if (fract < 0.f || fract > 1.f)
    {
      gprintf (stdout, "only values between 0 and 1 please ...\n") ;
      goto L801;
    }
L806:
  gprintf (stdout, "   last clone to consider as unattached = ") ;
  readinput ("", tname, 8) ;
  if (strlength(tname, 8) == 0)
    {
      lunatt = *nclone + 1;
    } 
  else
    {
      getline1_(tname, &lunatt, nclone);
      if (lunatt == 0)
	{
	  goto L806;
	}
    }
  iunit = getfile_() ;
  seek_10 (1) ;
  fread (&nicnt, sizeof(long int), 1, unit_10);
  ifctc = 1;
/*   loop for each contig */
  for (icont = ifctc; icont <= nicnt - 1; ++icont)
    {
      asscont_(nclone, &icont, iconta, iposa, &ncomp1, icnum1,
	       &iposav, icana);
/*   select clones starting from left of contig; find right ends */
      if (ncomp1 == 0)
	{
	  goto L802;
	}
      icrt = icnum1[0];
      irt = iposa[icrt - 1] + ilena[icrt - 1];
      ncomp2 = 1;
      icnum2[ncomp2 - 1] = icrt;
      ilstrt = irt;
      for (iq = 2; iq <= ncomp1; ++iq)
	{
	  ic = icnum1[iq - 1];
	  if ((float) (ilstrt - iposa[ic - 1]) < 
	      (float) min(ilena[ic - 1],
			  ilena[icnum2[ncomp2 - 1] - 1]) * fract)
	    {
	      if (icnum1[iq - 2] == icnum2[ncomp2 - 1])
		{
		  inext = ic;
		}
	      else
		{
		  inext = icnum1[iq - 2];
/*   ensure that we dont have a better one already */
		}
	      if (iposa[inext - 1] + ilena[inext - 1] < irt)
		{
		  for (ip = 1; ip <= ncomp2; ++ip)
		    {
		      if (icnum2[ip - 1] == icrt)
			{
			  goto L804;
			}
		    }
		  inext = icrt;
		}
	      ++ncomp2;
	      icnum2[ncomp2 - 1] = inext;
	      ilstrt = iposa[inext - 1] + ilena[inext - 1];
	    }
	  itempr = iposa[ic - 1] + ilena[ic - 1];
	  if (itempr > irt)
	    {
	      irt = itempr;
	      icrt = ic;
	    }
L804:
	  ;
	}
      for (iq = 1; iq <= ncomp2; ++iq)
	{
	  if (icnum2[iq - 1] == icrt)
	    {
	      goto L803;
	    }
	}
      ++ncomp2;
      icnum2[ncomp2 - 1] = icrt;
L803:
      for (iq = 1; iq <= ncomp2; ++iq)
	{
	  ic = icnum2[iq - 1];
	  if (iq == 1 || iq == ncomp2)
	    {
	      strtcpy (ntemp1, namea + ((ic - 1) << 3), 8) ;
	      gprintf (iunit, "%4d-%-8s(%3db,%4d)      E\n",
		       igela[ic - 1], ntemp1,
		       nbanda[ic - 1], iconta[ic - 1]) ;
	    }
	  else
	    {
	      strtcpy (ntemp1, namea + ((ic - 1) << 3), 8) ;
	      gprintf (iunit, "%4d-%-8s(%3db,%4d)\n",
		       igela[ic - 1], ntemp1,
		       nbanda[ic - 1], iconta[ic - 1]) ;
	    }
	}
/*   unattacheds */
L802:
      ;
    }
  for (ic = 2; ic <= lunatt; ++ic)
    {
      if (iconta[ic - 1] == 0 && namea[(ic - 1) * 8] != '!')
	{
	  strtcpy (ntemp1, namea + ((ic - 1) << 3), 8) ;
	  gprintf (iunit, "%4d-%-8s(%3db,%4d)\n",
		   igela[ic - 1], ntemp1,
		   nbanda[ic - 1], iconta[ic - 1]);
	}
    }
  if (iunit != stdout)
    fclose (iunit) ;
  goto L99;
L901:
  ikey = 1;
  cnt = FALSE;
  pur = FALSE;
  sing = FALSE;
  red = FALSE;
  seek_10 (1) ;
  fread (&ncont, sizeof(long int), 1, unit_10);
  icpnt = 0;
  keyw1_(kname, &ktlen, &klen);
/*   get options */
  if (klen == 0 || ktlen == 0)
    {
      goto L99;
    }
  gprintf (stdout,
	   " Options :\n"
	   "  F = search first characters only\n"
	   "  C = output by contig\n"
	   "  P = pure contigs only\n"
	   "  S = selected contig\n"
	   "  R = reduced format : ") ;
  readinput ("", resp, 5) ;
  isrch = 9 - klen;
  for (iq = 0; iq < strlen(resp); ++iq)
    {
      *ans = resp[iq];
      if (*ans == 'F' || *ans == 'f')
	{
	  isrch = 1;
	}
      if (*ans == 'C' || *ans == 'c')
	{
	  cnt = TRUE;
	}
      if (*ans == 'P' || *ans == 'p')
	{
	  pur = TRUE;
	}
      if (*ans == 'S' || *ans == 's')
	{
	  sing = TRUE;
	}
      if (*ans == 'R' || *ans == 'r')
	{
	  red = TRUE;
	}
    }
  if (sing)
    {
      gprintf (stdout, "  contig number = ") ;
      readinput ("", stemp, 10) ;
      ising = a2int (stemp) ;
      ising = max(0,min(ncont,ising));
    }
  iunit = getfile_() ;
  if (sing)
    {
      goto L910;
    }
  if (cnt)
    {
      gprintf (iunit, "\n          *** contigs ***\n\n") ;
    }
/*   begin key search */
L902:
  if (ikey > *nclone)
    {
      goto L908;
    }
  ++ikey;
  if (! keychk_(&ikey, &isrch, &ktlen, kname))
    {
      goto L902;
    }
  if (! cnt)
    {
      if (red)
	{
	  strtcpy (ntemp1, namea + ((ikey - 1) << 3), 8) ;
	  gprintf (iunit, "%s\n", ntemp1);
	}
      else
	{
	  strtcpy (ntemp1, namea + ((ikey - 1) << 3), 8) ;
	  gprintf (iunit, "%4d-%-8s\n", igela[ikey - 1], ntemp1);
	}
      goto L902;
    }
    if (! cntchk_(&ikey, &icpnt))
      {
	goto L902;
      }
  icontt = iconta[ikey - 1];
/*   now have as yet unlisted contig: get all key clones */
  if (icontt == 0)
    {
      goto L902;
    }
  ncomp2 = 0;
  for (ix = 2; ix <= *nclone + 1; ++ix)
    {
      if (iconta[ix - 1] == icontt)
	{
	  if (keychk_(&ix, &isrch, &ktlen, kname))
	    {
	      ++ncomp2;
	      icnum2[ncomp2 - 1] = ix;
	    }
	  else if (pur)
	    {
/* reject if pure contigs needed */
	      goto L902;
	    }
	}
/*   write out */
    }
  asscont_(nclone, &icontt, iconta, iposa, &ncomp1,
	   icnum1, &iposav, icana);
  i__1 = ncomp1;
  for (i = 1; i <= i__1; ++i)
    {
      ix = icnum1[i - 1];
      iy = (i__2 = icana[ix - 1], abs(i__2));
/*   write if key */
      if (iy == 0)
	{
	  if (lstchk_(&ix, &ncomp2, icnum2))
	    {
	      strtcpy (ntemp1, namea + ((ix - 1) << 3), 8) ;
	      gprintf (iunit, "%4d-%-8s\n", igela[ix - 1], ntemp1);
	    }
	  goto L1055;
/*   write if key ... */
	}
      else
	{
/*    ... or if has key buried  ... */
	  if (lstchk_(&ix, &ncomp2, icnum2))
	    {
	      goto L1054;
	    }
	  for (iq = 1; iq <= ncomp2; ++iq)
	    {
	      if ((i__3 = icana[icnum2[iq - 1] - 1], abs(i__3)) % 
		  10000000 == ix)
		{
		  goto L1054;
		}
/*    ... otherwise skip */
	    }
	  goto L1055;
L1054:
	  strtcpy (ntemp1, namea + ((ix - 1) << 3), 8) ;
	  gprintf (iunit, "%4d-%-8s                 (canonical)",
		   igela[ix - 1], ntemp1);
	  if (iy == 1)
	    {
	      ican = ix;
	    }
	  for (iq = 1; iq <= ncomp2; ++iq)
	    {
	      ix = icnum2[iq - 1];
	      itcan = icana[ix - 1];
	      if (itcan == ican)
		{
		  strtcpy (ntemp1, namea + ((ix - 1) << 3), 8) ;
		  gprintf (iunit, "        %4d-%-8s\n",
			   igela[ix - 1], ntemp1);
		}
	      else if (itcan == -ican)
		{
		  strtcpy (ntemp1, namea + ((ix - 1) << 3), 8) ;
		  gprintf (iunit, "        %4d-%-8s               (partial identity)\n",
			   igela[ix - 1], ntemp1);
		} 
	      else if (abs(itcan) == ican + 10000000)
		{
		  strtcpy (ntemp1, namea + ((ix - 1) << 3), 8) ;
		  gprintf (iunit, "        %4d-%-8s               (limbo)\n",
			   igela[ix - 1], ntemp1);
		}
	    }
	}
L1055:
      ;
    }
  gprintf (iunit, "\n") ;
  goto L902;
/*   get unattacheds... */
L908:
  if (! cnt)
    {
      goto L909;
    }
  gprintf (iunit, "\n          *** unattached ***\n\n") ;
/*   ...or selected contig */
L910:
  for (ix = 2; ix <= *nclone + 1; ++ix)
    {
      if (iconta[ix - 1] == ising)
	{
	  if (keychk_(&ix, &isrch, &ktlen, kname))
	    {
	      if (red)
		{
		  strtcpy (ntemp1, namea + ((ix - 1) << 3), 8) ;
		  gprintf (iunit, "%s\n", ntemp1) ;
		} 
	      else
		{
		  strtcpy (ntemp1, namea + ((ix - 1) << 3), 8) ;
		  gprintf (iunit, "%4d-%-8s(%3db,%4d)\n",
			   igela[ix - 1], ntemp1,
			   nbanda[ix - 1], iconta[ix - 1]);
		}
	    }
	}
    }
L909:
  if (iunit != stdout)
    fclose (iunit) ; 
  goto L99;
L1111:
  red = FALSE;
  gprintf (stdout, "   full(def) or reduced(R) format ? ") ;
  readinput ("", stemp, 2) ; *ans = *stemp ;
  if (*ans == 'R' || *ans == 'r')
    {
      red = TRUE;
    }
  seek_10 (1) ;
  fread (&ncont, sizeof(long int), 1, unit_10);
  iunit = getfile_() ;
  for (icont = 1; icont <= ncont; ++icont)
    {
      asscont_(nclone, &icont, iconta, iposa, &ncomp1, icnum1,
	       &iposav, icana);
      if (ncomp1 == 0)
	{
	  goto L1112;
	}
      iq = 1;
      while(iflag_(icnum1[iq - 1], 1) == 1)
	{
	  ic = icnum1[iq - 1];
	  if (red)
	    {
              strtcpy (ntemp1, namea + ((ic - 1) << 3), 8) ;
	      gprintf (iunit, "%s\n", ntemp1);
	    } 
	  else
	    {
	      strtcpy (ntemp1, namea + ((ic - 1) << 3), 8) ;
              gprintf (iunit, "%4d-%-8s (%3d)\n",
		       igela[ic - 1], ntemp1, icont);
	    }
	  if (iq >= ncomp1)
	    {
	      goto L1112;
	    }
	  ++iq;
/*   sort right hand ends */
	}
L1114:
      test = FALSE;
      i__2 = ncomp1 - 1;
      for (it = 1; it <= i__2; ++it)
	{
	  if (iposa[icnum1[it - 1] - 1] + 
	      ilena[icnum1[it - 1] - 1] >
	      iposa[icnum1[it] - 1] +
	      ilena[icnum1[it] - 1])
	    {
	      test = TRUE;
	      itemp = icnum1[it - 1];
	      icnum1[it - 1] = icnum1[it];
	      icnum1[it] = itemp;
	    }
	}
      if (test)
	{
	  goto L1114;
	}
      iq = ncomp1;
      while(iflag_(icnum1[iq - 1], 1) == 1)
	{
	  ic = icnum1[iq - 1];
	  if (red)
	    {
	      strtcpy (ntemp1, namea + ((ic - 1) << 3), 8) ;
	      gprintf (iunit, "%s\n", ntemp1);
	    } 
	  else
	    {
	      strtcpy (ntemp1, namea + ((ic - 1) << 3), 8) ;
	      gprintf (iunit, "%4d-%-8s (%3d)\n",
		       igela[ic - 1], ntemp1, icont);
	    }
	  if (iq <= 1)
	    {
	      goto L1112;
	    }
	  --iq;
	}
L1112:
      ;
    }
  if (iunit != stdout)
    fclose (iunit) ;
  goto L99;
L1150:
  cydubl_();
  goto L99;
L1250:
/* search and list */
  key = FALSE;
  iret = 6 ;			/* fortran-hack */
  while(iret != 8)
    {
      keysub_(&key, &i, nclone, &iret);
      if (iret != 8)
	{
	  strtcpy (ntemp1, namea + ((i - 1) << 3), 8) ;
	  gprintf (stdout, " %s\n", ntemp1);
	}
    }
  goto L99;
L1350:
  iunit = 0;
  test = FALSE;
  iunit = getfile_() ;
  if (iunit == stdout)
    {
      test = TRUE;
    }
  gencont1_(nclone, gout, &igpt, chstrt, ctot, cpn, &cpc);
  seek_10 (1) ;
  fread (&icmax, sizeof(long int), 1, unit_10);
  for (iq = 1; iq <= icmax; ++iq)
    {
      cdir[iq - 1] = FALSE;
    }
  for (iqchr = 1; iqchr <= 6; ++iqchr)
    {
      for (iq = 1; iq <= ctot[iqchr - 1]; ++iq)
	{
	  itemp = cpn[iq + iqchr * 200 - 201];
	  if (itemp > 0)
	    {
	      cdir[itemp - 1] = TRUE;
	    }
	}
    }
/*   eliminate hidden contigs and empty contigs */
  for (iq = 1; iq <= icmax; ++iq)
    {
      if (! cdir[iq - 1])
	{
	  icc = 0;
	  for (iqq = 2; iqq <= *nclone + 1; ++iqq)
	    {
	      if (iconta[iqq - 1] == iq)
		{
		  ++icc;
		  if (iflag_(iqq, 8) == 1)
		    {
		      cdir[iq - 1] = TRUE;
		    }
		  goto L1302;
		}
	    }
	  if (icc == 0)
	    {
	      cdir[iq - 1] = TRUE;
	    }
	}
L1302:
      ;
    }
  iqc = 0;
  ictot = 0;
  pcurr = 0.f;
  gprintf (stdout, "\n") ;
  while(iqc < icmax)
    {
      ++iqc;
      if (! cdir[iqc - 1])
	{
	  gprintf (iunit, " %6d\n", iqc);
	  ++ictot;
	}
    }
  if (iunit != stdout)
    fclose (iunit) ;
  goto L99;
} /* checkcont1_ */

#undef tnameb
#undef tname


/*   program to seek duplicate remark entries in different contigs */
int cydubl_(void)
{
  /* Local variables */
  static long int minl, maxl;
  static char name1[9], name2[9];
  static long int klen1, klen2;
  static char tname[9];
  static long int irlen, icont1, icont2, ic, iq, iclone;
  static char remark[41], remark1[41], remark2[41];
  static long int len;
  static char key1[9], key2[9];
  static FILE *iunit ;
  
  irlen = 40;
  maxl = 8;
  minl = 6;
  strcpy(key1, "Y");
  strcpy(key2, "cy");
  klen1 = 1;
  klen2 = 2;
  iunit = getfile_() ;
  
  unit_14 = FILopen ("scratch1", "dat", "w") ;
  iq = 0;
  while(TRUE)
    {
      ++iq;
      seek_11 (iq) ;
      fread (&iclone, sizeof(long int), 1, unit_11);
      fread (tname, sizeof(char), 8, unit_11);
      fread (remark, sizeof(char), 40, unit_11);
      if (ferror (unit_11) || feof(unit_11)) goto L102 ;

      for (ic = minl; ic <= irlen; ++ic)
	{
	  if (strncmp(remark + ic + 1 - klen2 - 1, key2, klen2) == 0)
	    {
	      for (len = minl; len <= maxl; ++len)
		{
		  if (strncmp(remark + max(1,ic + 1 - len) - 1,
			      key1, klen1) == 0)
		    { 
		      strtcpy (ntemp1, remark + max(1,ic + 1 - len) - 1,
			       ic - max(1,ic + 1 - len) - 1) ;
		      strtcpy (ntemp2, namea + ((iclone - 1) << 3), 8) ;
		      gprintf (unit_14, "%-8s   %6d   %-8s\n", 
			       ntemp1, iconta[iclone-1], ntemp2) ;
		      goto L101;
		    }
		}
	    }
L101:
	  ;
	}
    }
L102:
      
  fclose (unit_14) ;
  system ("rm -f scratch2.dat ; sort scratch1.dat > scratch2.dat") ;
  unit_14 = FILopen ("scratch2", "dat", "r");
  fscanf (unit_14, "%s%ld%s", remark1, &icont1, name1);
  if (ferror(unit_14)) goto L103 ;
  while(TRUE && !feof(unit_14))
    {
      fscanf (unit_14, "%s%ld%s", remark2, &icont2, name2) ;
      if (strncmp(remark1, remark2, 40) == 0 && icont1 != icont2)
	{
	  gprintf (iunit, "\n") ;
	  gprintf (iunit, "%-8s   %s   %6d\n", 
		   remark1, name1, icont1);
	  gprintf (iunit, "%-8s   %s   %6d\n", 
		   remark2, name2, icont2);
	}
      strtcpy(remark1, remark2, 40);
      strtcpy(name1, name2, 8);
      icont1 = icont2;
    }
  fclose (unit_14) ;
  unlink ("scratch1.dat") ;
L103:
    return 0;
} /* cydubl_ */

BOOL lstchk_(long int *ichk, long int *ncomp, long int *icnuma)
{
  /* System generated locals */
  BOOL ret_val;
  
  /* Local variables */
  static long int iq;
  
  /* Parameter adjustments */
  --icnuma;
  
  /* Function Body */
  ret_val = FALSE;
  for (iq = 1; iq <= *ncomp; ++iq)
    {
      if (icnuma[iq] == *ichk)
	{
	  ret_val = TRUE;
	  return ret_val;
	}
    }
  return ret_val;
} /* lstchk_ */

int redset_(long int *lina, long int *icpnt, BOOL *logver)
{
  /* Local variables */
  static long int itemp, iq;
  
  /* Parameter adjustments */
  --lina;

 L10:
  gprintf (stdout, "  number of clones to analyse (def = %d) = ", *icpnt) ;
  readinput ("", stemp, 10) ; if (nonint(stemp)) goto L10 ;
  itemp = a2int (stemp) ;
  if (itemp != 0)
    {
      *icpnt = min(*icpnt,itemp);
    }
  if (*logver)
    {
      for (iq = 1; iq <= *icpnt; ++iq)
	{
	  strtcpy (ntemp1, namea + ((lina[iq] - 1) << 3), 8) ;
	  gprintf (stdout, "%s\n", ntemp1);
	}
    }
  return 0;
} /* redset_ */

int modnam_(void)
{
  /* Local variables */
  static char name[9], cname[9], kname[9], nname[9];
  static long int igel, klen, ikey, nclone;
  static long int lband, nband, nnbnd, nigel, icont, iq, ix, nbands;
  static BOOL key;
  
  key = FALSE;
  seek_1 (1) ;
  fread (&nclone, sizeof(long int), 1, unit_1);
  fread (&nbands, sizeof(long int), 1, unit_1);
L3:
  gprintf (stdout, " clone name (H gets help) = ") ;
  readinput ("", cname, 8) ;
  if (strcasecmp(cname, "key") == 0) 
    {
      key = TRUE;
      goto L80;
    }
  if (strcasecmp(cname, "unkey") == 0)
    {
      key = FALSE;
      gprintf (stdout, " key mode cancelled\n");
      goto L3;
    }
  if (strcasecmp(cname, "h") == 0)
    {
      gprintf (stdout, "\n"
	       "   KEY   enter KEYword mode\n"
	       " UNKEY   leave keyword mode\n"
	       "     ,   get next clone\n"
	       ) ;
      goto L3;
    }
  if (strlength(cname, 8) == 0)
    {
      if (key)
	{
	  goto L81;
	}
      else
	{
	  return 0;
	}
    }
  if (strcmp(cname, ",") == 0)
    {
      ix = min(nclone + 1,ix + 1);
      goto L2;
    }
  for (ix = 2; ix <= nclone + 1; ++ix)
    {
      if (strncmp(namea + ((ix - 1) << 3), cname, 8) == 0)
	{
	  goto L2;
	}
    }
  gprintf (stdout, "clone not found\n");
  goto L3;
L2:
  seek_1 (ix) ;
  fread (name, sizeof(char), 8, unit_1);
  fread (&nband, sizeof(long int), 1, unit_1);
  fread (&lband, sizeof(long int), 1, unit_1);
  fread (&igel, sizeof(long int), 1, unit_1);
  fread (&icont, sizeof(long int), 1, unit_1);

  gprintf (stdout, " %-8s%7d%7d%7d%7d\n", 
	  name, nband, lband, igel, icont);

  gprintf (stdout, " new name       = ") ;
  readinput (name, nname, 8) ;
/*   protect against cancellation of clone in contig */
  if (strlength(nname, 8) == 0)
    {
      strtcpy(nname, name, 8);
    }
  if (*nname == '!' && icont != 0)
    {
      gprintf (stdout, "  delete clone from contig before cancellation \n") ;
      return 0;
    }
L10:
  gprintf (stdout, " new nband      = ") ;
  sprintf (ntemp1, "%ld", nband) ;
  readinput (ntemp1, stemp, 10) ; if (nonint(stemp)) goto L10 ;
  nnbnd = a2int (stemp) ;
  if (nnbnd == 0)
    {
      nnbnd = nband;
    }
  if (nnbnd < 0)
    {
      nnbnd = 0;
    }
L11:
  gprintf (stdout, " new gel number = ") ;
  sprintf (ntemp1, "%ld", igel) ;
  readinput (ntemp1, stemp, 10) ; if (nonint(stemp)) goto L11 ;
  nigel = a2int (stemp) ;
  if (nigel == 0)
    {
      nigel = igel;
    }
  seek_1 (ix) ;
  fwrite (nname, sizeof(char), 8, unit_1);
  fwrite (&nnbnd, sizeof(long int), 1, unit_1);
  fwrite (&lband, sizeof(long int), 1, unit_1);
  fwrite (&nigel, sizeof(long int), 1, unit_1);
  fwrite (&icont, sizeof(long int), 1, unit_1);
  fwrt_(unit_1);
  strncpy(namea + ((ix - 1) << 3), nname, 8);
  nbanda[ix - 1] = nnbnd;
  igela[ix - 1] = nigel;

  seek_1 (ix) ;
  fread (name, sizeof(char), 8, unit_1);
  fread (&nband, sizeof(long int), 1, unit_1);
  fread (&lband, sizeof(long int), 1, unit_1);
  fread (&igel, sizeof(long int), 1, unit_1);
  fread (&icont, sizeof(long int), 1, unit_1);

  gprintf (stdout, " %-8s%7d%7d%7d%7d\n",
	  name, nband, lband, igel, icont);
  goto L3;
/*   keyword routines */
L80:
  ikey = 1;
  keyw_(kname, &klen);
  if (klen == 0)
    {
      key = FALSE;
      goto L3;
    }
L81:
  if (ikey > nclone)
    {
      goto L80;
    }
  ++ikey;
  for (iq = 1; iq <= 9 - klen; ++iq)
    {
      if (strncmp(namea + (((ikey - 1) << 3) + (iq - 1)),
		 kname, klen) == 0)
	{
	  ix = ikey;
	  goto L2;
	}
    }
  goto L81;
} /* modnam_ */

#ifdef KEYW_IS_IN_CLIB_C
int keyw_(char *kname, long int *klen)
{
  /* Local variables */
  static long int iq;
  
L1003:
  gprintf (stdout, " enter keyword: ") ;
  readinput ("", kname, 8) ; if (!*kname) goto L1003 ;
  for (iq = 8; iq >= 1; --iq)
    {
      if (kname[iq - 1] != ' ')
	{
	  goto L11;
	}
    }
  *klen = 0;
  return 0;
L11:
  *klen = iq;
  return 0;
} /* keyw_ */
#endif

int clonaccum_(long int *ifrom, long int *ito, long int *lina, 
	       long int *icpnt)
{
  static long int itot, iclone ;

  /* Parameter adjustments */
  --lina;

  
  /* Function Body */
  itot = 0;
  for (iclone = *ifrom; iclone <= *ito; ++iclone)
    {
      if (elim_(&iclone))
	{
	  goto L101;
	}
      *icpnt = min(29999,*icpnt + 1);
      ++itot;
      lina[*icpnt] = iclone;
L101:
      ;
    }
  gprintf (stdout, " %d  clones added      %d total\n", itot, *icpnt);
  return 0;
} /* clonaccum_ */

int tycont_(long int *icontt, FILE *idev, long int *nclone)
{
  /* Local variables */
  static long int ican, i, itcan, icnum1[4000], icnum2[4000], ncomp2, ncomp1,
  iq, ix, iy, iposav;

/*   -1 means 0 contig wanted */
  if (*icontt == -1)
    {
      for (ix = 2; ix <= *nclone + 1; ++ix)
	{
	  if (iconta[ix - 1] == 0 && namea[(ix - 1) * 8] != 
	      '!')
	    {
	      strtcpy (ntemp1, namea + ((ix - 1) << 3), 8) ;
	      gprintf (idev, "%4d-%-8s\n",
		       igela[ix - 1], ntemp1);
	    }
	}
      return 0;
/*   first list all valid clones */
    }
  ncomp2 = 0;
  for (ix = 2; ix <= *nclone + 1; ++ix)
    {
      if (iconta[ix - 1] ==
	  *icontt && namea[(ix - 1) * 8] != '!')
	{
	  ++ncomp2;
	  icnum2[ncomp2 - 1] = ix;
	}
    }
  asscont_(nclone, icontt, iconta, iposa, &ncomp1, icnum1,
	   &iposav, icana);
  for (i = 1; i <= ncomp1; ++i)
    {
      ix = icnum1[i - 1];
      iy = abs(icana[ix - 1]);
	if (iy == 0)
	  {
	    strtcpy (ntemp1, namea + ((ix - 1) << 3), 8) ;
	    gprintf (idev, "%4d-%-8s\n",
		     igela[ix - 1], ntemp1);
	    goto L1055;
	  }
	else
	  {
	    strtcpy (ntemp1, namea + ((ix - 1) << 3), 8) ;
	    gprintf (idev, "%4d-%-8s\n",
		     igela[ix - 1], ntemp1);
	    if (iy == 1)
	      {
		ican = ix;
	      }
	    for (iq = 1; iq <= ncomp2; ++iq)
	      {
		ix = icnum2[iq - 1];
		itcan = icana[ix - 1];
		if (itcan == ican)
		  {
		    strtcpy (ntemp1, namea + ((ix - 1) << 3), 8) ;
		    gprintf (idev, "%4d-%-8s\n",
			     igela[ix - 1], ntemp1);
		  } 
		else if (itcan == -ican)
		  {
		    strtcpy (ntemp1, namea + ((ix - 1) << 3), 8) ;
		    gprintf (idev, "%4d-%-8s               (partial identity)\n",
			     igela[ix - 1], ntemp1);
		  }
		else if (abs(itcan) == ican + 10000000)
		  {
		    strtcpy (ntemp1, namea + ((ix - 1) << 3), 8) ;
		    gprintf (idev, "%4d-%-8s               (limbo)\n",
			     igela[ix - 1], ntemp1);
		  }
	      }
	  }
L1055:
      ;
    }
  gprintf (idev, "\n") ;
  return 0;
} /* tycont_ */

int getinit1_(long int *icpnt, long int *lina, long int *nclone,
	      char *kname, long int *ktlen)
{
  /* Local variables */
  static long int itot, mnlen, itlen, ip;
  
  /* Parameter adjustments */
  --lina;
  
  /* Function Body */
  itot = 0;
  itlen = 0;
  mnlen = 0;
  for (ip = 2; ip <= *nclone + 1; ++ip)
    {
      if (keychk_(&ip, &c__1, ktlen, kname))
	{
	  if (elim_(&ip))
	    {
	      goto L611;
	    }
	  *icpnt = min(29999,*icpnt + 1);
	  ++itot;
	  itlen += ilena[ip - 1];
	  lina[*icpnt] = ip;
	  goto L611;
	}
L611:
      ;
    }
  if (itot > 0)
    {
      mnlen = itlen / itot;
    }
  gprintf (stdout, "  %6d clones added,  mean size = %4d  total clones = %6d\n",
	  itot, mnlen, *icpnt);
  return 0;
} /* getinit1_ */

int getset1_(long int *icpnt, long int *lina, long int *nclone, 
	     char *cname)
{
  /* Local variables */
  static long int ifrom;
  static long int ito;
  
  /* Parameter adjustments */
  --lina;
  
  /* Function Body */
  if (strlength(cname, 8) == 0)
    {
      ifrom = 2;
      goto L603;
    }
  for (ifrom = 2; ifrom <= *nclone + 1; ++ifrom)
    {
      if (strncmp(namea + ((ifrom - 1) << 3), cname, 8) == 0)
	{
	  goto L603;
	}
    }
  gprintf (stdout, "clone not found\n") ;
  return 0;
L603:
  gprintf (stdout, "  last clone in set = ") ;
  readinput ("", cname, 8) ;
  if (strlength(cname, 8) == 0)
    {
      ito = *nclone + 1;
      clonaccum_(&ifrom, &ito, &lina[1], icpnt);
      return 0;
    }
  for (ito = 2; ito <= *nclone + 1; ++ito)
    {
      if (strncmp(namea + ((ito - 1) << 3), cname, 8) == 0)
	{
	  clonaccum_(&ifrom, &ito, &lina[1], icpnt);
	  return 0;
	}
    }
  gprintf (stdout, "clone not found\n") ;
  return 0;
} /* getset1_ */

BOOL elim_(long int *ip)
{
  /* System generated locals */
  BOOL ret_val;
  
  /* Local variables */
  static char name[9];
  static long int iq;
  
  ret_val = FALSE;
  strncpy(name, namea + ((*ip - 1) << 3), 8);
  for (iq = 1; iq <= 8; ++iq)
    {
      if (name[iq - 1] == '!')
	{
/* no repeats or cancellations */
	  ret_val = TRUE;
	  return ret_val;
	}
    }
  return ret_val;
} /* elim_ */

/*   plots clone occurrence across screen */
int clc_(long int *nclone, long int *icont, long int *ixs, 
	 long int *iscale, long int *ncomp1, long int *icnum1)
{
  /* System generated locals */
  long int i__2;
  static char nopss[128];	/* correlates to projectbase */
  static char equiv_0[25];
#define kname (equiv_0)
#define knameb (equiv_0)
  
/* Local variables */
  static long int ifac, ican;
  static long int klen;
  static long int imax, ipxf;
  static long int ipxt;
  static long int imode, iyclc;
  static long int isrch, ktlen, itemp, icnum3[4000], ic;
  static long int iq;
  static long int ix;
  static char ans[1];
  static long int iys;
  
  /* Parameter adjustments */
  --icnum1;
  
  strcpy (nopss, "") ;

  /* Function Body */
  if (ifac == 0)
    {
      ifac = 1;
    }
  iyclc = 400;
  iys = 440;
  clearvt640_();
  selectvt100_();
  clearvt100_();
  movevt100_(0, 0) ;
L104:
  gprintf (stdout, "   vertical scale (def = %d) = ", ifac) ;
  readinput ("", stemp, 3) ; if (nonint(stemp)) goto L104 ;
  itemp = a2int (stemp) ;
  if (itemp > 0)
    {
      ifac = itemp;
    }
  selectvt640_();
  plotcont4_(ixs, &iys, iscale, ncomp1, &icnum1[1], nopss, nclone, &imode);
  selectvt100_();
L101:
  clearvt100_();
  movevt100_(0, 1) ;
  keyw1_(kname, &ktlen, &klen);
  if (ktlen == 0)
    {
      clearvt640_() ;
      return 0;
    }
/*   get options */
  gprintf (stdout,
	   " Options :\n"
	   "  F = search first characters only : ") ;
  readinput ("", stemp, 2) ; *ans = *stemp ;
  if (*ans == 'F' || *ans == 'f')
    {
      isrch = 1;
    }
  else
    {
      isrch = 9 - klen;
    }
  for (iq = 1; iq <= 1000; ++iq)
    {
      icnum3[iq - 1] = 0;
    }
  for (ix = 2; ix <= *nclone + 1; ++ix)
    {
      if (iconta[ix - 1] != *icont)
	{
	  goto L102;
	}
      if (elim_(&ix))
	{
	  goto L102;
	}
      if (! keychk_(&ix, &isrch, &ktlen, kname))
	{
	  goto L102;
	}
      ican = (i__2 = icana[ix - 1], abs(i__2)) % 10000000;
      if (ican > 1)
	{
	  ic = ican;
	} 
      else
	{
	  ic = ix;
	}
      ipxf = (*ixs + iposa[ic - 1]) * *iscale + 500;
      ipxt = ipxf + ilena[ic - 1] * *iscale;
      i__2 = min(1000,ipxt);
      for (iq = max(1,ipxf); iq <= i__2; ++iq)
	{
	  icnum3[iq - 1] += ifac;
	}
L102:
      ;
    }
  imax = 0;
  for (iq = 10; iq <= 1000; ++iq)
    {
      if (icnum3[iq - 1] > imax)
	{
	  imax = icnum3[iq - 1];
	}
    }
  iyclc = iyclc - 15 - max(0, imax - 15);
  if (iyclc - imax < 1)
    {
      iyclc = 385 - max(0,imax - 15);
/*      initvt640_();
*/
      clearvt640_() ;
      selectvt640_();
      plotcont4_(ixs, &iys, iscale, ncomp1, &icnum1[1], nopss,
		 nclone, &imode);
    }
  selectvt640_();
  movevt640_(1, iyclc);
  textvt640_(knameb, 24);
  colorvt640_(BLUE) ;
  for (iq = 10; iq <= 1000; ++iq)
    {
      if (icnum3[iq - 1] == 0)
	{
	  goto L103;
	}
      movevt640_(iq, max(1,iyclc - icnum3[iq - 1]));
      drawvt640_(iq, min(700,iyclc + icnum3[iq - 1]));
L103:
      ;
    }
  colorvt640_(BLACK) ;
  selectvt100_();
  iyclc = iyclc - 15 - max(0,imax - 15);
  goto L101;
} /* clc_ */

#undef knameb
#undef kname


/*   clone listing facility */
int clist_(long int *nclone, long int *ic)
{
  if (! unit_20)
    {
      if (!(unit_20 = FILopen ("clone", "lis", "w")))
	return 0 ;
    }
  strtcpy (ntemp1, namea + ((*ic - 1) << 3), 8) ;
  gprintf (unit_20, "%4d-%-8s(%3db,%4d)\n",
	   igela[*ic - 1], ntemp1, nbanda[*ic - 1], iconta[*ic - 1]) ;
  fflush (unit_20) ;
  return 0;
} /* clist_ */

int mvcurs_(long int *imov)
{
  static char esc = 27;
  
  if (*imov < -9)		/* left */
    {
      gprintf (stdout, "%c[%2dD", esc, -(*imov));
    } 
  else if (*imov < 0)		/* left */
    {
      gprintf (stdout, "%c[%1dD", esc, -(*imov));
    } 
  else if (*imov > 9)		/* right */
    {
      gprintf (stdout, "%c[%2dC", esc, *imov);
    }
  else if (*imov > 0)		/* right */
    {
      gprintf (stdout, "%c[%1dC", esc, *imov);
    }
  return 0;
} /* mvcurs_ */

/*   writes from icurs to iwend */
int wrbuff_(char *rbuff)
{
  /* Local variables */
  static long int iq;
  
  /* Parameter adjustments */
  --rbuff;
  
  for (iq = icurs; iq <= iwend; ++iq)
    {
      gprintf (stdout, "%c", rbuff[iq]);
    }
  return 0;
} /* wrbuff_ */

int wrchar_(char *char_, char *rbuff)
{
  /* System generated locals */
  long int i__1;
  
  /* Local variables */
  static long int iq;

  /* Parameter adjustments */
  --rbuff;
  
  /* Function Body */
  if (icurs >= ibtot + 1)
    {
      return 0;
    }
  for (iq = ibtot; iq >= icurs + 1; --iq)
    {
      rbuff[iq] = rbuff[iq - 1];
    }
  rbuff[icurs] = *char_;
  iwend = min(ibtot,iwend);
  wrbuff_(rbuff + 1);
  i__1 = icurs - iwend;
  mvcurs_(&i__1);
  ++icurs;
  iwend = min(iwend + 1,ibtot + 1);
  return 0;
} /* wrchar_ */

int delchar_(char *rbuff)
{
  /* System generated locals */
  long int i__1;
  
  /* Local variables */
  static long int iq;
  
  /* Parameter adjustments */
  --rbuff;
  
  /* Function Body */
  if (icurs <= 1 || iwend <= 1)
    {
      return 0;
    }
  i__1 = ibtot;
  for (iq = icurs; iq <= i__1; ++iq)
    {
      rbuff[iq - 1] = rbuff[iq];
    }
  --iwend;
  rbuff[iwend] = ' ';
  mvcurs_(&c_n1);
  --icurs;
  wrbuff_(rbuff + 1);
  i__1 = icurs - iwend - 1;
  mvcurs_(&i__1);
  return 0;
} /* delchar_ */

int nestcurs_(char *rbuff)
{
  /* System generated locals */
  long int i__1 ;
  
  /* Local variables */
  static long int iq;
  
  /* Parameter adjustments */
  --rbuff;
  
  /* Function Body */
  iq = ibtot;
  while(iq > 1 && rbuff[iq] == ' ')
    {
      --iq;
    }
  if (rbuff[iq] != ' ')
    {
      iq = min(iq + 1,ibtot + 1);
    }
  i__1 = iq - icurs;
  mvcurs_(&i__1);
  icurs = iq;
/* set cursor and iwend at (last char + 1) */
  iwend = iq;
  return 0;
} /* nestcurs_ */

/*   to abstract part of project under a new project name */
int abstr_(long int *icont, long int *nclone)
{
  /* System generated locals */
  long int i__2;
  
  /* Local variables */
  static long int igel, lband;
  static long int nband;
  static char tname[9];
  static long int ix, iy, nbandsn, nclonen;
  static char newproject[128];
  
/*   get name of new project */
L1:
  gprintf (stdout, "     project name = ") ;
  readinput ("", newproject, 128) ;
  if (strlength(newproject, 128) == 0)
    {
      return 0 ;
    }
  if (!(unit_21 = FILopen (newproject, "nam", "r+"))) goto L1 ;
  fread (&nclonen, sizeof(long int), 1, unit_21);
  fread (&nbandsn, sizeof(long int), 1, unit_21);

  gprintf (stdout, " (old) number of clones = %6d   "
	   "number of bands = %7d\n", nclonen, nbandsn);

  if (!(unit_22 = FILopen (newproject, "cor", "r+"))) goto L1 ;

  if (!(unit_23 = FILopen (newproject, "cnt", "r+"))) goto L1 ;

  if (!(unit_29 = FILopen (newproject, "flg", "r+"))) goto L1 ;

  for (iy = 2; iy <= *nclone + 1; ++iy) 
    {
      if (iconta[iy - 1] == *icont)
	{
	  if (nbanda[iy - 1] != 0 && iflag_(iy, 4) != 1)
	    {
	      ++nclonen;
	      seek_1 (iy) ;
	      fread (tname, sizeof(char), 8, unit_1);
	      fread (&nband, sizeof(long int), 1, unit_1);
	      fread (&lband, sizeof(long int), 1, unit_1);
	      fread (&igel, sizeof(long int), 1, unit_1);

	      seek_21 (nclonen + 1);
	      fwrite (tname, sizeof(char), 8, unit_21);
	      fwrite (&nband, sizeof(long int), 1, unit_21);
	      i__2 = nbandsn + 1;
	      fwrite (&i__2, sizeof(long int), 1, unit_21);
	      fwrite (&igel, sizeof(long int), 1, unit_21);
	      
	      seek_23 (nclonen + 1);
	      fwrite (&c__0, sizeof(long int), 1, unit_23);
	      fwrite (&nband, sizeof(long int), 1, unit_23);
	      fwrite (&c__0, sizeof(long int), 1, unit_23);
	      fwrite (&c__0, sizeof(long int), 1, unit_23);

	      seek_29 (nclonen + 1);
	      fwrite (&c__0, sizeof(long int), 1, unit_29);
	      for (ix = lband; ix <= lband + nband - 1; ++ix)
		{
		  ++nbandsn;
		  seek_22 (nbandsn);
		  fwrite (&coorda[ix - 1],
			  sizeof(short int), 1, unit_22);
		}
	      seek_21 (1) ;
	      fwrite (&nclonen, sizeof(long int), 1, unit_21);
	      fwrite (&nbandsn, sizeof(long int), 1, unit_21);
	    }
	}
    }
  seek_21 (1) ;
  fread (&nclonen, sizeof(long int), 1, unit_21);
  fread (&nbandsn, sizeof(long int), 1, unit_21);

  gprintf (stdout, " (new) number of clones = %6d   "
	   "number of bands = %7d\n", nclonen, nbandsn);

  return 0;
} /* abstr_ */

