/*  File: lastclones.c
 *  Author: Friedemann "F" Wobus (fw@sanger.ac.uk)
 *  Copyright (C) John Sulston and Friedemann Wobus, 1994
 *-------------------------------------------------------------------
 * This file is part of the ContigC physical mapping database package,
 * 	written by John Sulston (jes@sanger.ac.uk)
 *	ported to UNIX-C by Friedemann Wobus (fw@sanger.ac.uk)
 *
 * Description:  
 * SCCS: $Id: makeascnam.c,v 1.1 2001/02/14 12:44:39 edgrif Exp $
 * HISTORY:
 * Last edited: Sep  5 16:20 1995 (fw)
 * Created: Tue Oct 18 18:43:33 1994 (fw)
 *-------------------------------------------------------------------
 */
	
#include "co9.h"

/*****************************************************************/

extern FILE *unit_1 ;		/* .nam */

void usage(void)
{
  printf ("Usage: makeascnam \n"
	  " will convert .nam part of the database into ascii tables\n");
  exit (-1) ;
}

void main (int argc, char **argv)
{
  /* Local variables */
  static char filnam[128], output[128], tname[8], cname[9];
  static int i ;
  static long int icount, nbands1, nclone1, nband, lband, igel, icont;
  FILE *filout ;

/* first check for HELP options */
  for (i = 1; i < argc; ++i)
    if (strcasecmp(argv[i], "-h") == 0) usage () ;

  printf ("\nMAKEASCNAM - program to convert .nam file\n"
	  "           to ascii for name processing.\n");

  printf ("  project name = ") ;
  readinput ("", filnam, 128) ;
  if (strlength(filnam, 128) == 0) exit (1) ;

  printf ("\n  ascii project name (def = \"ascdb\") = ") ;
  readinput ("ascdb", output, 128) ;
  if (strlength(output, 128) == 0) strcpy (output, "ascdb") ;

  if (!(unit_1 = FILopen (filnam, "nam", "r"))) exit (-1) ;
  if (!(filout = FILopen (output, "nam", "w"))) exit (-1) ;

  seek_1 (1) ;
  fread (&nclone1, sizeof(long int), 1, unit_1);
  fread (&nbands1, sizeof(long int), 1, unit_1);

  printf ("   input database %10s : number of clones = %6ld, "
	  "number of bands = %8ld\n\n", filnam, nclone1, nbands1) ;

  fprintf (filout, "%ld %ld\n", nclone1, nbands1) ;
 
  for (icount = 2; icount <= nclone1 + 1; icount++)
    {
      seek_1 (icount) ;
      fread (tname, sizeof(char), 8, unit_1);
      fread (&nband, sizeof(long int), 1, unit_1);
      fread (&lband, sizeof(long int), 1, unit_1);
      fread (&igel, sizeof(long int), 1, unit_1);

      strtcpy (cname, tname, 8) ;
      fprintf (filout, "%-8s %6ld %6ld %6ld %6ld\n", cname, nband, lband, igel, icont) ;
    }
  fclose (unit_1) ;
  fclose (filout) ;

  printf ("done..\n") ;
}


