/*  File: openmapdb.c
 *  Author: Friedemann "F" Wobus (fw@sanger.ac.uk)
 *  Copyright (C) John Sulston and Friedemann Wobus, 1994
 *-------------------------------------------------------------------
 * This file is part of the ContigC physical mapping database package,
 * 	written by John Sulston (jes@sanger.ac.uk)
 *	ported to UNIX-C by Friedemann Wobus (fw@sanger.ac.uk)
 *
 * Description: creates a new database project, with empty files
 * SCCS: $Id: openmapdb.c,v 1.1 2001/02/14 12:44:39 edgrif Exp $
 * HISTORY:
 * Last edited: Feb 13 16:23 1995 (fw)
 * Created: Thu May 19 16:44:41 1994 (fw)
 *-------------------------------------------------------------------
 */

#include "co9.h"
#include <sys/time.h>

/*****************************************************************/

extern FILE *unit_1 ;			/* .nam */
extern FILE *unit_2 ;			/* .cor */
extern FILE *unit_4 ;			/* .cnt */
extern FILE *unit_10 ;			/* .stk */
extern FILE *unit_11 ;			/* .rem */
extern FILE *unit_13 ;			/* .flg */
extern FILE *unit_14 ;                  /* .rej, .pss */

/* Table of constant values */

static long int c__1 = 1;
static long int c__0 = 0;

/* OPENMAPDB starts new database, by initialising 'empty' files */
void main (int argc, char **argv)
{
  /* Local variables */
  static char projectbase[128] ;
  static long int m, n;
  static long int itemp;
  struct tm  *ct ;
  struct timeval tv ;
  static char datestr[6] = "750119" ; /* my birthday */
  static long int date ;

  gettimeofday(&tv, (struct timezone *) NULL);
  ct = localtime(&tv.tv_sec);
  sprintf(datestr, "%02d%02d%02d",
	  ct->tm_year, ct->tm_mon + 1, ct->tm_mday) ;
  sscanf (datestr, "%ld", &date) ;

  n = 0;
  m = 0;
  if (argc > 1)
    {
      strcpy (projectbase, argv[1]) ;
      printf ("  project name for new database = %s\n", projectbase) ;
    }
  else
    {
      printf ("  project name for new database = ") ;
      readinput ("", projectbase, 50) ;
    }

  if (!(unit_1 = FILopen (projectbase, "nam", "w"))) exit (-1) ;
  seek_1 (1) ;
  fwrite (&n, sizeof(long int), 1, unit_1);
  fwrite (&m, sizeof(long int), 1, unit_1);
  fclose (unit_1) ;
  
  if (!(unit_2 = FILopen (projectbase, "cor", "w"))) exit (-1) ;
  fclose (unit_2) ;

  if (!(unit_4 = FILopen (projectbase, "cnt", "w"))) exit (-1) ;
  fclose (unit_4) ;

  if (!(unit_10 = FILopen (projectbase, "stk", "w"))) exit (-1) ;
  seek_10 (1) ;
  fwrite (&c__1, sizeof(long int), 1, unit_10);
  seek_10 (2) ;
  fwrite (&c__0, sizeof(long int), 1, unit_10);
  fclose (unit_10) ;

  itemp = -9 ;
  if (!(unit_11 = FILopen (projectbase, "rem", "w"))) exit (-1) ;
  fwrite (&c__0, sizeof(long int), 1, unit_11);
  seek_11 (2) ;
  fwrite (&itemp, sizeof(long int), 1, unit_11);
  fclose (unit_11) ;

  if (!(unit_13 = FILopen (projectbase, "flg", "w"))) exit (-1) ;
  seek_13 (1) ;
  fwrite (&date, sizeof(long int), 1, unit_13);
  fclose (unit_13) ;

  if (!(unit_14 = FILopen (projectbase, "rej", "w"))) exit (-1) ;
  seek_14 (1) ;
  fwrite (&c__0, sizeof(long int), 1, unit_14);
  fclose (unit_14) ;

  if (!(unit_14 = FILopen (projectbase, "pss", "w"))) exit (-1) ;
  seek_14 (1) ;
  fwrite (&c__0, sizeof(long int), 1, unit_14);
  fclose (unit_14) ;
}
